(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    280206,       7349]
NotebookOptionsPosition[    227598,       6283]
NotebookOutlinePosition[    228307,       6308]
CellTagsIndexPosition[    228218,       6303]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["NMSSM<-> SM+Singlet+EWinos Matching", "Section",
 CellChangeTimes->{{3.752044877059842*^9, 
  3.752044912049901*^9}},ExpressionUUID->"8e253acc-b2e1-4487-8f3f-\
39240e608766"],

Cell[CellGroupData[{

Cell["Interactive Mode", "Subsection",
 CellChangeTimes->{{3.752044913378347*^9, 
  3.752044927956657*^9}},ExpressionUUID->"8033087c-0dd7-450f-8f98-\
0ea56236d76f"],

Cell[CellGroupData[{

Cell["Initialisation", "Subsubsection",
 CellChangeTimes->{{3.752044932863575*^9, 
  3.752044951261437*^9}},ExpressionUUID->"4d1bb4e3-8777-4655-b01c-\
8ae5d285a8a8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "SARAH`"}]], "Input",
 CellChangeTimes->{{3.7520440613866987`*^9, 3.752044063132701*^9}, {
  3.752044873017816*^9, 
  3.75204487364178*^9}},ExpressionUUID->"8c37efd2-dd51-4c4a-807d-\
d14c687de43d"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    StyleBox["\<\"SARAH \"\>", "Section",
     FontSize->14],
    StyleForm[#, "Section", FontSize -> 14]& ], "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"(Private Version)\"\>", "Section",
     FontSize->14],
    StyleForm[#, "Section", FontSize -> 14]& ]}],
  SequenceForm[
   StyleForm["SARAH ", "Section", FontSize -> 14], 
   StyleForm["(Private Version)", "Section", FontSize -> 14]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044068014967*^9},ExpressionUUID->"e88c70fa-07b1-4d68-b1d1-\
35a04a529988"],

Cell[BoxData["\<\"by Florian Staub, 2018\"\>"], "Print",
 CellChangeTimes->{
  3.752044068016016*^9},ExpressionUUID->"b737dca7-4974-4785-8c76-\
8e9e837c8c45"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"contributions by M. Gabelmann, M. D. Goodsell, K. Nickel\"\>",
   
   FontSize->10],
  StyleForm[#, FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752044068016862*^9},ExpressionUUID->"4cf98d7f-61d5-4837-bc10-\
74cef0ea3358"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044068017398*^9},ExpressionUUID->"1fc082a8-63a0-4ca3-acab-\
e0e902cd2b37"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"References:\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752044068048223*^9},ExpressionUUID->"0d7aa8b5-5d18-48e4-8108-\
0b9585ba542b"],

Cell[BoxData["\<\"  Comput.Phys.Commun.181 (2010) 1077-1086. \
(arXiv:0909.2863[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.752044068049543*^9},ExpressionUUID->"ebee0be5-0019-45bf-8fb9-\
000440e64a9e"],

Cell[BoxData["\<\"  Comput.Phys.Commun.182 (2011) 808-833. \
(arXiv:1002.0840[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.7520440680501633`*^9},ExpressionUUID->"d2849734-93f2-45be-8ef3-\
97754b5f705b"],

Cell[BoxData["\<\"  Comput.Phys.Commun.184 (2013) 1792-1809. \
(arXiv:1207.0906[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.752044068050652*^9},ExpressionUUID->"8cb02d3a-7e0c-4cfa-8eef-\
8f2ad4371395"],

Cell[BoxData["\<\"  Comput.Phys.Commun.185 (2014) 1773-1790. \
(arXiv:1309.7223[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.752044068051177*^9},ExpressionUUID->"7934db82-e554-40a5-897f-\
45178f530bc6"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Download and Documentation:\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752044068051952*^9},ExpressionUUID->"7d90e073-b151-48a0-97a7-\
fe9912cb83b8"],

Cell[BoxData["\<\"  http://sarah.hepforge.org\"\>"], "Print",
 CellChangeTimes->{
  3.752044068052546*^9},ExpressionUUID->"35d31cec-1bcb-4a2a-a548-\
77a2473401f5"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044068053026*^9},ExpressionUUID->"0e8e5c70-b557-46a1-9d31-\
6073ed0ee12e"],

Cell[BoxData["\<\"Start evaluation of a model with:\"\>"], "Print",
 CellChangeTimes->{
  3.7520440680535707`*^9},ExpressionUUID->"56136fb8-ead9-4251-a430-\
c39dab1e33c5"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"   Start[\\\"Name of Model\\\"]\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044068086225*^9},ExpressionUUID->"812eed21-6d0d-49ec-9bea-\
10bcd2ebb964"],

Cell[BoxData["\<\"e.g. Start[\\\"MSSM\\\"] or \
Start[\\\"NMSSM\\\",\\\"CKM\\\"]\"\>"], "Print",
 CellChangeTimes->{
  3.752044068087139*^9},ExpressionUUID->"73fe4867-4278-4b27-acf9-\
b67956e09ac3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"To get a list with all installed models, use \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"ShowModels\"\>", "Section",
     FontSize->12],
    StyleForm[#, "Section", FontSize -> 12]& ]}],
  SequenceForm["To get a list with all installed models, use ", 
   StyleForm["ShowModels", "Section", FontSize -> 12]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440680880136`*^9},ExpressionUUID->"437799f5-2c4a-4d93-94ff-\
ac48aefcce7b"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Start", "[", "\"\<SMSSM\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7520440642184467`*^9, 
  3.752044072456822*^9}},ExpressionUUID->"6a093b6b-a23b-4a28-8309-\
198468b48d2a"],

Cell[CellGroupData[{

Cell[BoxData["\<\"Preparing arrays\"\>"], "Print",
 CellChangeTimes->{
  3.752044073054357*^9},ExpressionUUID->"8a0ca265-7df2-4b75-b267-\
f1fbeb2f1797"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" ... checking Directory: \"\>", 
   "\[InvisibleSpace]", "\<\"/home/martin/FeynTools/sarah4/Models/\"\>"}],
  SequenceForm[
  " ... checking Directory: ", "/home/martin/FeynTools/sarah4/Models/"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073054727*^9},ExpressionUUID->"11b8ccb1-0769-4d1e-99b6-\
61acd8ef955d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Model files loaded   \"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044073055483*^9},ExpressionUUID->"00385777-2edd-4031-977c-\
c25312d74e31"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Model    : \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"SMSSM\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Model    : ", 
   StyleForm["SMSSM", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073055973*^9},ExpressionUUID->"639d4748-67cf-4117-9a25-\
f71475568553"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Author(s): \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"F.Staub\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Author(s): ", 
   StyleForm["F.Staub", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073056608*^9},ExpressionUUID->"b0c7be51-6a50-4036-a3d3-\
8e96b92e53f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Date     : \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"2012-09-01\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Date     : ", 
   StyleForm["2012-09-01", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440730573874`*^9},ExpressionUUID->"e60590af-1857-40da-a2c3-\
9343e9469837"],

Cell[BoxData["\<\"******************************************************* \
\"\>"], "Print",
 CellChangeTimes->{
  3.752044073058001*^9},ExpressionUUID->"7c7f52d3-9153-4139-b6e6-\
008599c8426b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Loading \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"Susyno\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ], 
   "\[InvisibleSpace]", "\<\" functions for the handling of Lie Groups \"\>"}],
  SequenceForm["Loading ", 
   StyleForm["Susyno", "Section", FontSize -> 10], 
   " functions for the handling of Lie Groups "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440730584707`*^9},ExpressionUUID->"f38859e6-c1e2-4050-ac73-\
877dbbee7c67"],

Cell[BoxData["\<\"Based on Susyno v.2.0 by Renato Fonseca (1106.5016)\"\>"], \
"Print",
 CellChangeTimes->{
  3.752044073058967*^9},ExpressionUUID->"76b9afde-3487-4a83-967e-\
9e20551803c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"webpage: \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"web.ist.utl.pt/renato.fonseca/susyno.html\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["webpage: ", 
   StyleForm[
   "web.ist.utl.pt/renato.fonseca/susyno.html", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073059436*^9},ExpressionUUID->"d7678b77-31ea-433c-8b6b-\
abb177d1ff56"],

Cell[BoxData["\<\"******************************************************* \
\"\>"], "Print",
 CellChangeTimes->{
  3.752044073059992*^9},ExpressionUUID->"b381fb3e-b5b0-4fba-b317-\
6783085a5955"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Initialization\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044073112679*^9},ExpressionUUID->"5d7bb62d-56e8-4ec9-a9f1-\
7f7967c4d30b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Checking model files: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCheckModelFiles, StandardForm],
    ImageSizeCache->{117., {3., 9.}}]}],
  SequenceForm["Checking model files: ", 
   Dynamic[SARAH`DynamicCheckModelFiles]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073113942*^9},ExpressionUUID->"76e75b12-e174-482b-bbc4-\
2a437e812f3a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Initialize gauge groups: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitGaugeG, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Initialize gauge groups: ", 
   Dynamic[SARAH`DynamicInitGaugeG]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073115191*^9},ExpressionUUID->"ec292356-2e79-4778-97c5-\
6275b2581bfa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Initialize field: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitFields, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Initialize field: ", 
   Dynamic[SARAH`DynamicInitFields]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440731441193`*^9},ExpressionUUID->"20d217fd-b99c-4ed7-bf14-\
a02e3fd7a802"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Preprocessing necessary information: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitMisc, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Preprocessing necessary information: ", 
   Dynamic[SARAH`DynamicInitMisc]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073154709*^9},ExpressionUUID->"49bd7c04-17d2-4c7c-9988-\
d58db5e34c1b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Checking for anomalies: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCheckAnomalies, StandardForm],
    ImageSizeCache->{1088., {3., 9.}}]}],
  SequenceForm["Checking for anomalies: ", 
   Dynamic[SARAH`DynamicCheckAnomalies]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440733627462`*^9},ExpressionUUID->"8045716e-aebd-4d7d-be9b-\
4b52b16361a0"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Derive Lagrangian\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044073416562*^9},ExpressionUUID->"79f65334-0972-42d1-9f3b-\
dd6bbbf00d40"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate superpotential: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTermSuperpotentialNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTermSuperpotential, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate superpotential: ", 
   Dynamic[SARAH`DynamicTermSuperpotentialNr], "/", 8, "(", 
   Dynamic[SARAH`DynamicTermSuperpotential], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440734176607`*^9},ExpressionUUID->"4481724e-2978-4dbf-bcbb-\
2b9d7fa2e359"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  checking charge conservation: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCheckingCCSup, StandardForm],
    ImageSizeCache->{381., {3., 9.}}]}],
  SequenceForm["  checking charge conservation: ", 
   Dynamic[SARAH`DynamicCheckingCCSup]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073470161*^9},ExpressionUUID->"ce73ce6f-cdd4-4850-8660-\
e0ab7d2a4d9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate F-Terms: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicFTermNr, StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "12", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicFTermName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate F-Terms: ", 
   Dynamic[SARAH`DynamicFTermNr], "/", 12, " (", 
   Dynamic[SARAH`DynamicFTermName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044073477825*^9},ExpressionUUID->"3a1a21f0-d0b8-457c-87fc-\
358c1495cf8a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate Matter interactions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMatterNr, StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "144", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMatterName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate Matter interactions: ", 
   Dynamic[SARAH`DynamicMatterNr], "/", 144, " (", 
   Dynamic[SARAH`DynamicMatterName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440735547047`*^9},ExpressionUUID->"dbe4157b-562c-43e9-8b36-\
ce2374040da9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate soft-breaking terms: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicSoftTermsCurrent, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Calculate soft-breaking terms: ", 
   Dynamic[SARAH`DynamicSoftTermsCurrent]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044074029539*^9},ExpressionUUID->"4a64ff0f-05fa-422e-93ce-\
4884fe6a94d1"],

Cell[BoxData["\<\"Calculate kinetic Terms\"\>"], "Print",
 CellChangeTimes->{
  3.752044074097869*^9},ExpressionUUID->"23f705fc-c600-4bf6-9b48-\
07938908d9a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... for scalars: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticScalarNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticScalarName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... for scalars: ", 
   Dynamic[SARAH`DynamicKineticScalarNr], "/", 8, " (", 
   Dynamic[SARAH`DynamicKineticScalarName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440740996923`*^9},ExpressionUUID->"6d328ade-35b1-414c-af7a-\
692dbd38093a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... for fermions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticFermionNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticFermionName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... for fermions: ", 
   Dynamic[SARAH`DynamicKineticFermionNr], "/", 8, " (", 
   Dynamic[SARAH`DynamicKineticFermionName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044074300542*^9},ExpressionUUID->"75d8f56e-80f5-4b90-8ffe-\
306391281e59"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate D-Terms: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicDTermsNr, StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "24", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicDTermsName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate D-Terms: ", 
   Dynamic[SARAH`DynamicDTermsNr], "/", 24, " (", 
   Dynamic[SARAH`DynamicDTermsName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204407442095*^9},ExpressionUUID->"614a8419-2ca0-42bd-a412-044473b21427"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate gaugino interactions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGauginoMatter, StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "24", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGauginoMatterName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate gaugino interactions: ", 
   Dynamic[SARAH`DynamicGauginoMatter], "/", 24, " (", 
   Dynamic[SARAH`DynamicGauginoMatterName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044075233685*^9},ExpressionUUID->"b9305e7c-60c5-408c-9a2e-\
1f95fb7b5a41"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate vector-gaugino interactions: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGauginoVector, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGauginoVectorName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate vector-gaugino interactions: ", 
   Dynamic[SARAH`DynamicGauginoVector], "/", 3, " (", 
   Dynamic[SARAH`DynamicGauginoVectorName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044075369088*^9},ExpressionUUID->"e2bf3201-8dcd-4d33-83e9-\
4742a6b2485f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate vector self-interactions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicVectorNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicVectorName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate vector self-interactions: ", 
   Dynamic[SARAH`DynamicVectorNr], "/", 3, " (", 
   Dynamic[SARAH`DynamicVectorName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440753864317`*^9},ExpressionUUID->"598f629c-c6e8-4128-8b75-\
9a4fea98b75e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGaugeTNr, StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "11", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGaugeTName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate gauge transformations: ", 
   Dynamic[SARAH`DynamicGaugeTNr], "/", 11, " (", 
   Dynamic[SARAH`DynamicGaugeTName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440754409313`*^9},ExpressionUUID->"6287d874-eacf-4df9-ab5c-\
88cc4045fbdb"],

Cell[BoxData["\<\"Eleminate sums\"\>"], "Print",
 CellChangeTimes->{
  3.7520440754585333`*^9},ExpressionUUID->"cabdf239-6d69-41dc-9b97-\
ee06c1570aba"],

Cell[BoxData["\<\"Calc Complete Lagrangian\"\>"], "Print",
 CellChangeTimes->{
  3.752044075476664*^9},ExpressionUUID->"c09b4604-0ac2-4ce5-82ce-\
1eeaa4c79b05"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7520440755289927`*^9},ExpressionUUID->"0b059dfb-90cb-4cf8-8080-\
37e31e6992a8"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Evolve States: GaugeES\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520440755299673`*^9},ExpressionUUID->"f5119373-a6a6-43ec-bd91-\
84a9f4f45f10"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Rotate Lagrangian: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRotateLag[1], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["Rotate Lagrangian: ", 
   Dynamic[
    SARAH`DynamicRotateLag[1]], "/", 14],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440755311337`*^9},ExpressionUUID->"eca3b719-b40f-4e39-b596-\
95f3dfce0a2a"],

Cell[BoxData["\<\"Derive ghost terms: \"\>"], "Print",
 CellChangeTimes->{
  3.752044075986826*^9},ExpressionUUID->"9c6c2111-7a0b-4dce-8eca-\
d624947e9cbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... generate gauge fixing terms: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[
     SARAH`DynamicGFnr[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicGFname[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... generate gauge fixing terms: ", 
   Dynamic[
    SARAH`DynamicGFnr[SARAH`GaugeES]], "/", 3, " (", 
   Dynamic[
    SARAH`DynamicGFname[SARAH`GaugeES]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440760586863`*^9},ExpressionUUID->"011c3776-33a3-460a-8366-\
2eab578b08f9"],

Cell[BoxData["\<\"  ... calculate Ghost interactions\"\>"], "Print",
 CellChangeTimes->{
  3.7520440760594873`*^9},ExpressionUUID->"ca04c8aa-5547-4532-8875-\
6f3bd3f1478e"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",
 CellChangeTimes->{
  3.7520440760601883`*^9},ExpressionUUID->"edc147ac-ea67-4a46-8c74-\
c45d9541e07c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save information (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicSaveInfo[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Save information (", 
   Dynamic[
    SARAH`DynamicSaveInfo[SARAH`GaugeES]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044076132098*^9},ExpressionUUID->"f69238ce-8afa-47a5-bb99-\
cf1da12f3280"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044076307494*^9},ExpressionUUID->"4f428931-cb33-4b9f-a5ee-\
cddc37f360ce"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Evolve States: EWSB\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520440763084097`*^9},ExpressionUUID->"44229511-88c4-49a7-a1a7-\
a12f93286a3e"],

Cell[BoxData["\<\"Parametrize Higgs Sector\"\>"], "Print",
 CellChangeTimes->{
  3.7520440763095627`*^9},ExpressionUUID->"61c36186-44aa-4277-9881-\
49ea2cc396f8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTvev[2]], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "54", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTvev[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTvev[2]]], "/", 54, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTvev[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440763108883`*^9},ExpressionUUID->"297d8340-291d-4c42-a2e0-\
6cdb6d21ba4d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calc mass matrices gauge sector: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicMMgaugeNr[SARAH`EWSB], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicMMgaugeName[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calc mass matrices gauge sector: ", 
   Dynamic[
    SARAH`DynamicMMgaugeNr[SARAH`EWSB]], "/", 3, "(", 
   Dynamic[
    SARAH`DynamicMMgaugeName[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440763638487`*^9},ExpressionUUID->"3b938e47-7bb4-4705-8fc2-\
3e289847b106"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTgaugeMM[2]], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "64", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTgaugeMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTgaugeMM[2]]], "/", 64, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTgaugeMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204407677015*^9},ExpressionUUID->"a11b46cf-bf2b-402d-bab0-50cc7cfafea8"],

Cell[BoxData["\<\"Add Phases\"\>"], "Print",
 CellChangeTimes->{
  3.752044076837377*^9},ExpressionUUID->"39acb61b-0286-49f6-8d7c-\
f3cc6f3b63c0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTphasesMM[2]], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "59", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTphasesMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTphasesMM[2]]], "/", 59, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTphasesMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044076839088*^9},ExpressionUUID->"8912e2f7-9f25-497b-8f78-\
06574c927d6e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Rotate Lagrangian: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRotateLag[2], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["Rotate Lagrangian: ", 
   Dynamic[
    SARAH`DynamicRotateLag[2]], "/", 14],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440769132223`*^9},ExpressionUUID->"65794a18-d6ad-4999-81b9-\
4373cc7ec858"],

Cell[BoxData["\<\"Derive ghost terms: \"\>"], "Print",
 CellChangeTimes->{
  3.752044077697686*^9},ExpressionUUID->"d3987093-54a8-4907-81f7-\
8d6cb07d30f6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... generate gauge fixing terms: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[
     SARAH`DynamicGFnr[SARAH`EWSB], StandardForm],
    ImageSizeCache->{10., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicGFname[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... generate gauge fixing terms: ", 
   Dynamic[
    SARAH`DynamicGFnr[SARAH`EWSB]], "/", 4, " (", 
   Dynamic[
    SARAH`DynamicGFname[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044077768449*^9},ExpressionUUID->"6257078c-d45f-4ec4-aa2b-\
23d8de994dae"],

Cell[BoxData["\<\"  ... calculate Ghost interactions\"\>"], "Print",
 CellChangeTimes->{
  3.752044079641715*^9},ExpressionUUID->"5576fcbe-2b4d-4a98-83ff-\
1f7c856e7ac8"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",
 CellChangeTimes->{
  3.752044079768796*^9},ExpressionUUID->"0cdc93a4-46cb-4391-9823-\
1d967f77b8d3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculate mass matrices \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicNrMass[{{{$CellContext`SdL, $CellContext`SdR}, {
         Susyno`LieGroups`conj[$CellContext`SdL], 
         Susyno`LieGroups`conj[$CellContext`SdR]}}, {{$CellContext`SvL}, {
         Susyno`LieGroups`conj[$CellContext`SvL]}}, {{$CellContext`SuL, \
$CellContext`SuR}, {
         Susyno`LieGroups`conj[$CellContext`SuL], 
         Susyno`LieGroups`conj[$CellContext`SuR]}}, {{$CellContext`SeL, \
$CellContext`SeR}, {
         Susyno`LieGroups`conj[$CellContext`SeL], 
         Susyno`LieGroups`conj[$CellContext`SeR]}}, {{$CellContext`phid, \
$CellContext`phiu, $CellContext`phiS}, {$CellContext`phid, $CellContext`phiu, \
$CellContext`phiS}}, {{$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}, {$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}}, {{$CellContext`SHdm, 
         Susyno`LieGroups`conj[$CellContext`SHup]}, {
         Susyno`LieGroups`conj[$CellContext`SHdm], $CellContext`SHup}}, \
{{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`FsR}, {$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, \
$CellContext`FHu0, $CellContext`FsR}}, {{$CellContext`fWm, \
$CellContext`FHdm}, {$CellContext`fWp, $CellContext`FHup}}, \
{{$CellContext`FeL}, {
         Susyno`LieGroups`conj[$CellContext`FeR]}}, {{$CellContext`FdL}, {
         Susyno`LieGroups`conj[$CellContext`FdR]}}, {{$CellContext`FuL}, {
         Susyno`LieGroups`conj[$CellContext`FuR]}}}], StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "12", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicNameMass[{{{$CellContext`SdL, $CellContext`SdR}, {
         Susyno`LieGroups`conj[$CellContext`SdL], 
         Susyno`LieGroups`conj[$CellContext`SdR]}}, {{$CellContext`SvL}, {
         Susyno`LieGroups`conj[$CellContext`SvL]}}, {{$CellContext`SuL, \
$CellContext`SuR}, {
         Susyno`LieGroups`conj[$CellContext`SuL], 
         Susyno`LieGroups`conj[$CellContext`SuR]}}, {{$CellContext`SeL, \
$CellContext`SeR}, {
         Susyno`LieGroups`conj[$CellContext`SeL], 
         Susyno`LieGroups`conj[$CellContext`SeR]}}, {{$CellContext`phid, \
$CellContext`phiu, $CellContext`phiS}, {$CellContext`phid, $CellContext`phiu, \
$CellContext`phiS}}, {{$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}, {$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}}, {{$CellContext`SHdm, 
         Susyno`LieGroups`conj[$CellContext`SHup]}, {
         Susyno`LieGroups`conj[$CellContext`SHdm], $CellContext`SHup}}, \
{{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`FsR}, {$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, \
$CellContext`FHu0, $CellContext`FsR}}, {{$CellContext`fWm, \
$CellContext`FHdm}, {$CellContext`fWp, $CellContext`FHup}}, \
{{$CellContext`FeL}, {
         Susyno`LieGroups`conj[$CellContext`FeR]}}, {{$CellContext`FdL}, {
         Susyno`LieGroups`conj[$CellContext`FdR]}}, {{$CellContext`FuL}, {
         Susyno`LieGroups`conj[$CellContext`FuR]}}}], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculate mass matrices ", 
   Dynamic[
    SARAH`DynamicNrMass[{{{$CellContext`SdL, $CellContext`SdR}, {
        Susyno`LieGroups`conj[$CellContext`SdL], 
        Susyno`LieGroups`conj[$CellContext`SdR]}}, {{$CellContext`SvL}, {
        Susyno`LieGroups`conj[$CellContext`SvL]}}, {{$CellContext`SuL, \
$CellContext`SuR}, {
        Susyno`LieGroups`conj[$CellContext`SuL], 
        Susyno`LieGroups`conj[$CellContext`SuR]}}, {{$CellContext`SeL, \
$CellContext`SeR}, {
        Susyno`LieGroups`conj[$CellContext`SeL], 
        Susyno`LieGroups`conj[$CellContext`SeR]}}, {{$CellContext`phid, \
$CellContext`phiu, $CellContext`phiS}, {$CellContext`phid, $CellContext`phiu, \
$CellContext`phiS}}, {{$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}, {$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}}, {{$CellContext`SHdm, 
        Susyno`LieGroups`conj[$CellContext`SHup]}, {
        Susyno`LieGroups`conj[$CellContext`SHdm], $CellContext`SHup}}, \
{{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`FsR}, {$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, \
$CellContext`FHu0, $CellContext`FsR}}, {{$CellContext`fWm, \
$CellContext`FHdm}, {$CellContext`fWp, $CellContext`FHup}}, \
{{$CellContext`FeL}, {
        Susyno`LieGroups`conj[$CellContext`FeR]}}, {{$CellContext`FdL}, {
        Susyno`LieGroups`conj[$CellContext`FdR]}}, {{$CellContext`FuL}, {
        Susyno`LieGroups`conj[$CellContext`FuR]}}}]], "/", 12, " (", 
   Dynamic[
    SARAH`DynamicNameMass[{{{$CellContext`SdL, $CellContext`SdR}, {
        Susyno`LieGroups`conj[$CellContext`SdL], 
        Susyno`LieGroups`conj[$CellContext`SdR]}}, {{$CellContext`SvL}, {
        Susyno`LieGroups`conj[$CellContext`SvL]}}, {{$CellContext`SuL, \
$CellContext`SuR}, {
        Susyno`LieGroups`conj[$CellContext`SuL], 
        Susyno`LieGroups`conj[$CellContext`SuR]}}, {{$CellContext`SeL, \
$CellContext`SeR}, {
        Susyno`LieGroups`conj[$CellContext`SeL], 
        Susyno`LieGroups`conj[$CellContext`SeR]}}, {{$CellContext`phid, \
$CellContext`phiu, $CellContext`phiS}, {$CellContext`phid, $CellContext`phiu, \
$CellContext`phiS}}, {{$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}, {$CellContext`sigmad, $CellContext`sigmau, \
$CellContext`sigmaS}}, {{$CellContext`SHdm, 
        Susyno`LieGroups`conj[$CellContext`SHup]}, {
        Susyno`LieGroups`conj[$CellContext`SHdm], $CellContext`SHup}}, \
{{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`FsR}, {$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, \
$CellContext`FHu0, $CellContext`FsR}}, {{$CellContext`fWm, \
$CellContext`FHdm}, {$CellContext`fWp, $CellContext`FHup}}, \
{{$CellContext`FeL}, {
        Susyno`LieGroups`conj[$CellContext`FeR]}}, {{$CellContext`FdL}, {
        Susyno`LieGroups`conj[$CellContext`FdR]}}, {{$CellContext`FuL}, {
        Susyno`LieGroups`conj[$CellContext`FuR]}}}]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044079770926*^9},ExpressionUUID->"5d122492-b6f6-417e-8cee-\
3aba092a28ea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTmatterMM[2]], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "75", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTmatterMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTmatterMM[2]]], "/", 75, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTmatterMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044084968712*^9},ExpressionUUID->"977f0aa3-6333-4f35-a9b9-\
74e16b5fd3d7"],

Cell[BoxData["\<\"Calculate Tadpole Equations\"\>"], "Print",
 CellChangeTimes->{
  3.752044085068*^9},ExpressionUUID->"f1036903-416d-46cf-8d77-955a3dabd1de"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save information (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicSaveInfo[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Save information (", 
   Dynamic[
    SARAH`DynamicSaveInfo[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044086876285*^9},ExpressionUUID->"66e97881-8afa-4608-b698-\
37bfb723b962"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044089168971*^9},ExpressionUUID->"f26acb52-4810-4152-9a15-\
d4a4feb82c9d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Finishing\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044089169834*^9},ExpressionUUID->"7ca1e9cd-20cd-4eef-a995-\
5c79d4254279"],

Cell[BoxData["\<\"Calculate final Lagrangian\"\>"], "Print",
 CellChangeTimes->{
  3.7520440891705627`*^9},ExpressionUUID->"f6e88f89-4353-4723-b7b0-\
0433f19bbce7"],

Cell[BoxData["\<\"Cleaning up\"\>"], "Print",
 CellChangeTimes->{
  3.7520440891712627`*^9},ExpressionUUID->"254c23ff-a25f-4e40-8809-\
ca54b4518137"],

Cell[BoxData["\<\"   ... add matrix products\"\>"], "Print",
 CellChangeTimes->{
  3.752044089171975*^9},ExpressionUUID->"09c19c4a-cf09-4844-b4fd-\
f7c8d451eca1"],

Cell[BoxData["\<\"   ... checking for massless particles\"\>"], "Print",
 CellChangeTimes->{
  3.752044089172723*^9},ExpressionUUID->"6acf6131-18ea-4975-a953-\
08d91cdd02ea"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   ... calculating tree level masses (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCalcTreeMasses, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   ... calculating tree level masses (", 
   Dynamic[SARAH`DynamicCalcTreeMasses], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520440900976267`*^9},ExpressionUUID->"6f7e038f-e8ba-4daa-a4e6-\
9489b42cc705"],

Cell[BoxData["\<\"   ... simplify mass matrices\"\>"], "Print",
 CellChangeTimes->{
  3.752044091159259*^9},ExpressionUUID->"b4f06fe2-81fb-4d0d-bee5-\
8f5203402fc0"],

Cell[BoxData["\<\"Numerical calculations (if necessary)\"\>"], "Print",
 CellChangeTimes->{
  3.752044091479604*^9},ExpressionUUID->"238444a1-849c-4d33-96e8-\
b337a5493205"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   ... checking for spectrum file: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[SARAH`DynamicSpectrumFileInput, StandardForm],
    ImageSizeCache->{200., {3., 9.}}]}],
  SequenceForm["   ... checking for spectrum file: ", 
   Dynamic[SARAH`DynamicSpectrumFileInput]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044091480653*^9},ExpressionUUID->"c041c4b6-a854-4bf6-b837-\
4f23de1ce6a3"],

Cell[BoxData["\<\"   ... reading parameter values and dependences\"\>"], \
"Print",
 CellChangeTimes->{
  3.7520440914812317`*^9},ExpressionUUID->"7be6c510-ef17-46fe-8958-\
777490bca00d"],

Cell[BoxData["\<\"   ... calculate mixing matrices\"\>"], "Print",
 CellChangeTimes->{
  3.7520440914818172`*^9},ExpressionUUID->"4ef6967f-f1e5-4b4c-b876-\
8d41cabb0a50"],

Cell[BoxData["\<\"Checking for CP even and odd scalars\"\>"], "Print",
 CellChangeTimes->{
  3.75204409163381*^9},ExpressionUUID->"046f5ffc-09ca-4f8e-a5d5-5dc00a1a33df"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044091634993*^9},ExpressionUUID->"c62b78e6-65c9-48d9-bc58-\
40cb18a7672b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All Done. \"\>", "\[InvisibleSpace]", "\<\"SMSSM\"\>", 
   "\[InvisibleSpace]", "\<\" is ready!\"\>"}],
  SequenceForm["All Done. ", "SMSSM", " is ready!"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044091635927*^9},ExpressionUUID->"86d9671d-e733-4396-b6d0-\
4d1ed2ecc70f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"(Model initialized in \"\>", "\[InvisibleSpace]", "18.593682`",
    "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm["(Model initialized in ", 18.593682, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044091636752*^9},ExpressionUUID->"118ba7ed-4fdf-44c6-9c70-\
e3ee0c8d28ef"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7520440916374073`*^9},ExpressionUUID->"05121063-589f-47c0-b4fb-\
a437d53f90af"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044091638021*^9},ExpressionUUID->"c3be22e1-ed07-4810-9cd5-\
cabfc2fb67ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Are you unfamiliar with SARAH? Use \"\>", "\[InvisibleSpace]", 
   
   TagBox[
    StyleBox["\<\"SARAH`FirstSteps\"\>", "Section",
     FontSize->12],
    StyleForm[#, "Section", FontSize -> 12]& ]}],
  SequenceForm["Are you unfamiliar with SARAH? Use ", 
   StyleForm["SARAH`FirstSteps", "Section", FontSize -> 12]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044091638918*^9},ExpressionUUID->"701d6fc2-4db0-4b3d-9cfe-\
a7f3aa7a4f9c"]
}, Open  ]]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "load", " ", "definitions", " ", "used", " ", "in", " ", "the", " ", 
    "batch", " ", "mode"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Get", "[", 
   RowBox[{"$sarahCurrentModelDir", "<>", "\"\<Matching_SplitSUSY.m\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7520440738933973`*^9, 3.752044144817738*^9}, {
  3.752044180477662*^9, 3.752044263010445*^9}, {3.752045020554051*^9, 
  3.75204502104455*^9}},ExpressionUUID->"cb15113d-0ac6-46f1-b4ae-\
582b2b171875"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Initialize", " ", "interactive", " ", "mode", " ", "with", " ", "the", 
    " ", "definitions", " ", "from", " ", "the", " ", "steering", " ", "file",
     " ", "loaded", " ", "above"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"InitMatching", "[", 
   RowBox[{
    RowBox[{"Parametrisation", "\[Rule]", "$ParametrisationUV"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", "$AssumptionsMatching"}], ",", " ", 
    RowBox[{"SolveTadpoles", "\[Rule]", "$SolveTadpolesUV"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.752044281980734*^9, 3.752044305273777*^9}, {
  3.752044340182748*^9, 3.752044348955825*^9}, {3.752045028543371*^9, 
  3.752045056241386*^9}},ExpressionUUID->"4b2dc146-5f6d-4aac-b138-\
f20677f6b3ae"],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Initialise Matching Routines\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.75204434985984*^9},ExpressionUUID->"2b423b86-56f2-4f26-b101-4f60b2efc738"],

Cell[BoxData["\<\"Checking model for missing definitions\"\>"], "Print",
 CellChangeTimes->{
  3.7520443499126263`*^9},ExpressionUUID->"86d350de-2de3-4747-8111-\
41d66776534b"],

Cell[BoxData["\<\"Generate Directories\"\>"], "Print",
 CellChangeTimes->{
  3.752044349914083*^9},ExpressionUUID->"8bb480d0-8931-4f73-aae1-\
cd1a264e474d"],

Cell[BoxData["\<\"Building Particle List\"\>"], "Print",
 CellChangeTimes->{
  3.752044349987568*^9},ExpressionUUID->"02f5caf4-1959-42c1-8d54-\
4cd216508ebb"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate all vertices\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044350045988*^9},ExpressionUUID->"9f4ad561-dd04-4faf-acb6-\
02995ed1e8cb"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044350213912*^9},ExpressionUUID->"8e810de3-2081-4433-ac79-\
9d3ccc1bacc8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "26", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"26", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 26, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSS]], "/", 26 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520443510508213`*^9},ExpressionUUID->"79a84881-5e1c-48e7-a039-\
f3018c5c587b"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044364098443*^9},ExpressionUUID->"5c6bcc50-1fd1-47db-aff5-\
e70d642487a5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "65", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"65", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{353., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 65, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSSS]], "/", 65 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044364927549*^9},ExpressionUUID->"d7c052dc-02e3-4e36-8f90-\
1a285dee09c9"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044389877164*^9},ExpressionUUID->"95ac231f-47b9-426e-83cc-\
0b1ad84b371b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "66", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"66", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 66, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSV]], "/", 66 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044390432447*^9},ExpressionUUID->"44d5fbf8-7d73-44ee-b5b1-\
a6beb9c00bde"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      One Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044401938088*^9},ExpressionUUID->"71d57adb-deb8-4092-8d50-\
7c23a2bc116a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044402506741*^9},ExpressionUUID->"e6c18be6-11ca-43c5-9850-\
21e16103d2a4"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520444091801977`*^9},ExpressionUUID->"517d2ff9-a856-4b41-9b09-\
ef5c67ee6cc3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "178", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"178", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{352., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 178, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSVV]], "/", 178 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044409782675*^9},ExpressionUUID->"dcb7d7f4-1476-471d-a1fe-\
482da9f63108"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044446984639*^9},ExpressionUUID->"9f1e92c8-f001-470f-a6ac-\
1d43e453c08e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"21", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 21, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVV]], "/", 21 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044447050518*^9},ExpressionUUID->"7e223910-bdf7-476f-ba49-\
b9029fbaed72"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Scalar - Interactions\"\>", "Section",
   
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044449943577*^9},ExpressionUUID->"3b4626fd-6c7e-4e4b-8487-\
69818d6cd89f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "84", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"84", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 84, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFS]], "/", 84 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044451427128*^9},ExpressionUUID->"a506cebc-6a2e-4fef-af6b-\
bf4cfb0b957e"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044475903124*^9},ExpressionUUID->"e3518c2b-1fd5-46fc-8ca4-\
4dd77cdeb6ca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "59", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"59", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 59, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFV]], "/", 59 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044476211072*^9},ExpressionUUID->"9df77601-6f91-4d01-b81d-\
b4f8b35b88a0"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520444959893093`*^9},ExpressionUUID->"93e1291d-456e-4de0-beae-\
01aa643af788"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044496101583*^9},ExpressionUUID->"b5fb0bc7-a0be-4bc2-b814-\
2daed353620f"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044505630177*^9},ExpressionUUID->"3538e639-6082-432c-be56-\
b4bb9b84b17f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "65", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"65", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{352., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 65, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGV]], "/", 65 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044505727146*^9},ExpressionUUID->"424b3775-0ed7-4ef3-b479-\
e3a3d9a019b4"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044508989044*^9},ExpressionUUID->"4ead3a13-4cd3-4cb6-ba23-\
7c15b33b3a28"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "48", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"48", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 48, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGS]], "/", 48 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044509103876*^9},ExpressionUUID->"159011f7-e9f7-4998-89f8-\
3de6c425aed3"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Auxiliary - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752044511592967*^9},ExpressionUUID->"529ac02a-986c-44cf-9667-\
f2e368725262"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "102", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`ASS], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"102", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`ASS], StandardForm],
    ImageSizeCache->{358., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 102, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`ASS]], "/", 102 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`ASS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520445117778273`*^9},ExpressionUUID->"6918cf14-0390-4a70-87b0-\
4f9580351dde"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752044523033843*^9},ExpressionUUID->"20f2531b-4fa7-47ab-a772-\
18d76f676d4d"],

Cell[BoxData["\<\"Simplify Vertices\"\>"], "Print",
 CellChangeTimes->{
  3.75204452303489*^9},ExpressionUUID->"ccb58b68-c15b-40ea-a7df-bface65b00ab"],

Cell[BoxData["\<\"Writing vertices to files\"\>"], "Print",
 CellChangeTimes->{
  3.75204455371707*^9},ExpressionUUID->"4b7f5071-863f-4370-9b67-da83300ee11d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All vertices calculated. (Time needed: \"\>", 
   "\[InvisibleSpace]", "206.605448`", "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm["All vertices calculated. (Time needed: ", 206.605448, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752044553890668*^9},ExpressionUUID->"3de7a6b2-de11-4214-ba31-\
1cf57e26b90c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The vertices are saved in \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Vertices/\"\
\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["The vertices are saved in ", 
   StyleForm[
   "/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Vertices/", "Section", 
    FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520445538919697`*^9},ExpressionUUID->"f5012871-11da-4a71-97dc-\
133dcd5f22bf"],

Cell[BoxData["\<\"Calculate Expressions for Masses and Rotation \
Matrices\"\>"], "Print",
 CellChangeTimes->{
  3.752044554743362*^9},ExpressionUUID->"ad5f2c07-f43c-45f9-add1-\
71dc02e561b8"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check for how the mass eigenstates are labeled", "Subsubsection",
 CellChangeTimes->{{3.752044955347095*^9, 
  3.752044989246244*^9}},ExpressionUUID->"7c05fa7f-bfe8-4665-9406-\
fc0f996ee233"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "M"}]], "Input",
 CellChangeTimes->{{3.752044363030939*^9, 3.752044363442337*^9}, {
  3.752044743864078*^9, 
  3.7520447442175827`*^9}},ExpressionUUID->"4b773128-7f11-49fa-988b-\
6ae68bd147d8"],

Cell[CellGroupData[{

Cell["Susyno`LieGroups`M", "Print", "PrintUsage",
 CellChangeTimes->{3.7520447447831097`*^9},
 CellTags->
  "Info133752048344-6846142",ExpressionUUID->"bc583f9d-d7dc-44df-8566-\
1466db81a86e"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"M", "[", "Ah", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "MAinput"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Cha", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Chi", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Fd", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Fe", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Fu", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Glu", "]"}], "=", "0"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "hh", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "MAinput"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Hpm", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "MAinput"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Sd", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{
          "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Se", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{
          "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Su", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{
          "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0", ",", "m0"}], 
          "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"M", "[", "Sv", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"m0", ",", "m0", ",", "m0"}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Susyno`LieGroups`M],
  Editable->False]], "Print",
 CellChangeTimes->{3.7520447448073473`*^9},
 CellTags->
  "Info133752048344-6846142",ExpressionUUID->"15cc254d-feb2-4f78-b718-\
20f4987f078a"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"\[Rule]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"hh", "[", "3", "]"}], ",", 
      RowBox[{"Ah", "[", "3", "]"}], ",", 
      RowBox[{"Hpm", "[", "2", "]"}]}], ")"}], " ", "correspond", " ", "to", 
    " ", "the", " ", "heavy", " ", "doublet"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.752044747598928*^9, 3.75204477946579*^9}, 
   3.752044994654005*^9, {3.75204574478693*^9, 
   3.752045769883153*^9}},ExpressionUUID->"905724b6-55b0-420f-a8ef-\
4b499f55a13d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"EFTcoupLO", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"hh", "[", "1", "]"}], ",", 
    RowBox[{"hh", "[", "1", "]"}], ",", 
    RowBox[{"hh", "[", "1", "]"}], ",", 
    RowBox[{"hh", "[", "1", "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"EFTcoupLO", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"hh", "[", "2", "]"}], ",", 
    RowBox[{"hh", "[", "2", "]"}], ",", 
    RowBox[{"hh", "[", "2", "]"}], ",", 
    RowBox[{"hh", "[", "2", "]"}]}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.752044780314843*^9, 
  3.752044833790512*^9}},ExpressionUUID->"8606040a-ad75-4ac4-b958-\
59599506457a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "6"}], " ", 
  SuperscriptBox["KappaNMSSM", "2"]}]], "Output",
 CellChangeTimes->{{3.752044803409182*^9, 3.752044834076312*^9}, 
   3.752045292839785*^9},ExpressionUUID->"5bde8b6c-c071-4c15-b818-\
02e567178308"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"8", " ", 
       SuperscriptBox["LambdaNMSSM", "2"], " ", 
       SuperscriptBox["TanBeta", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["g1Q", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}], "+", 
      RowBox[{
       SuperscriptBox["g2Q", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}]}], ")"}]}], 
   RowBox[{"4", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}]]}]], "Output",
 CellChangeTimes->{{3.752044803409182*^9, 3.752044834076312*^9}, 
   3.752045292879342*^9},ExpressionUUID->"3b88804d-5352-4b85-a83e-\
1e50d72b7265"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"\[Rule]", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"hh", "[", "1", "]"}], " ", "is", " ", "the", " ", "singlet", 
     " ", "and", " ", 
     RowBox[{"hh", "[", "2", "]"}], " ", "is", " ", "the", " ", "SM"}], "-", 
    RowBox[{"like", " ", "Higgs"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.752044805318305*^9, 3.752044857046962*^9}, {
  3.752045803376445*^9, 
  3.752045807029949*^9}},ExpressionUUID->"334122b1-54b5-43b3-a3ea-\
6c68f886289a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: NLO corrections to the singlet-higgs-higgs coupling \
\>", "Subsubsection",
 CellChangeTimes->{{3.75204507515408*^9, 3.752045125119556*^9}, {
  3.7520453846738377`*^9, 3.75204538680171*^9}, {3.752045595030875*^9, 
  3.7520456000640163`*^9}},ExpressionUUID->"af2ed19f-80f3-4c7f-b8a3-\
874236a55488"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"EFTcoupLO", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"hh", "[", "1", "]"}], ",", 
    RowBox[{"hh", "[", "2", "]"}], ",", 
    RowBox[{"hh", "[", "2", "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EFTcoupNLO", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"hh", "[", "1", "]"}], ",", 
      RowBox[{"hh", "[", "2", "]"}], ",", 
      RowBox[{"hh", "[", "2", "]"}]}], "}"}], "]"}], "-", "%"}], "//", 
  "FullSimplify"}]}], "Input",
 CellChangeTimes->{{3.7520451259842377`*^9, 3.752045139656794*^9}, {
  3.7520451976251497`*^9, 3.7520452063741407`*^9}, {3.7520452367046633`*^9, 
  3.752045252388242*^9}, {3.752045298994787*^9, 
  3.752045349747044*^9}},ExpressionUUID->"d0f0aea6-731a-4859-b086-\
52b947d54b2e"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox["2"], " ", "TanBeta", " ", "TLambdaNMSSM"}], 
  RowBox[{"1", "+", 
   SuperscriptBox["TanBeta", "2"]}]]], "Output",
 CellChangeTimes->{
  3.7520451467364397`*^9, {3.752045198625572*^9, 3.752045255024325*^9}, {
   3.752045299540444*^9, 
   3.7520453505520678`*^9}},ExpressionUUID->"e47e5d30-0b6c-498e-9719-\
f5c76e7caf26"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"48", " ", 
    SqrtBox["2"], " ", 
    SuperscriptBox["m0", "2"], " ", 
    SuperscriptBox["MAinput", "2"], " ", 
    SuperscriptBox["\[Pi]", "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["TanBeta", "2"]}], ")"}], "3"]}]], 
  RowBox[{"TanBeta", " ", "TLambdaNMSSM", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["m0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         SuperscriptBox["MAinput", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", 
            SuperscriptBox["g1Q", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["g2Q", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}], "-", 
           RowBox[{"2", " ", "LambdaNMSSM", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"3", " ", "LambdaNMSSM", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SuperscriptBox["TanBeta", "2"]}], ")"}], "2"]}], "+", 
              RowBox[{"4", " ", "KappaNMSSM", " ", "TanBeta", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox["TanBeta", "2"]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}], "-", 
        RowBox[{"12", " ", 
         RowBox[{"(", 
          RowBox[{"TanBeta", "+", 
           SuperscriptBox["TanBeta", "3"]}], ")"}], " ", "TKappaNMSSM", " ", 
         "TLambdaNMSSM"}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"9", "-", 
           RowBox[{"8", " ", 
            SuperscriptBox["TanBeta", "2"]}], "+", 
           RowBox[{"9", " ", 
            SuperscriptBox["TanBeta", "4"]}]}], ")"}], " ", 
         SuperscriptBox["TLambdaNMSSM", "2"]}]}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["m0", "2"], " ", 
      SuperscriptBox["MAinput", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         SuperscriptBox["g2Q", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["TanBeta", "4"]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["g1Q", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           SuperscriptBox["TanBeta", "2"], "+", 
           SuperscriptBox["TanBeta", "4"]}], ")"}]}], "-", 
        RowBox[{"4", " ", "LambdaNMSSM", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "KappaNMSSM", " ", "TanBeta", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["TanBeta", "2"]}], ")"}]}], "+", 
           RowBox[{"LambdaNMSSM", " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              SuperscriptBox["TanBeta", "2"], "+", 
              SuperscriptBox["TanBeta", "4"]}], ")"}]}]}], ")"}]}]}], ")"}], 
      " ", 
      RowBox[{"Log", "[", 
       FractionBox[
        SuperscriptBox["m0", "2"], 
        SuperscriptBox["MAinput", "2"]], "]"}]}], "+", 
     RowBox[{"6", " ", 
      SuperscriptBox["m0", "2"], " ", "TLambdaNMSSM", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"TanBeta", "+", 
           SuperscriptBox["TanBeta", "3"]}], ")"}], " ", "TKappaNMSSM"}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["TanBeta", "2"]}], ")"}], "2"], " ", 
         "TLambdaNMSSM"}]}], ")"}], " ", 
      RowBox[{"Log", "[", 
       FractionBox[
        SuperscriptBox["MAinput", "2"], 
        SuperscriptBox["m0", "2"]], "]"}]}], "-", 
     RowBox[{
      SuperscriptBox["Azero", "2"], " ", 
      SuperscriptBox["MAinput", "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["TanBeta", "2"]}], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"YdQ", "[", 
           RowBox[{"3", ",", "3"}], "]"}], "2"]}], "+", 
        SuperscriptBox[
         RowBox[{"YeQ", "[", 
          RowBox[{"3", ",", "3"}], "]"}], "2"], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"YuQ", "[", 
           RowBox[{"3", ",", "3"}], "]"}], "2"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.7520451467364397`*^9, {3.752045198625572*^9, 3.752045255024325*^9}, {
   3.752045299540444*^9, 3.7520453250887012`*^9}, 
   3.752045366219461*^9},ExpressionUUID->"2f98bbce-dc63-4736-aada-\
e3322850ec74"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Batch Mode", "Subsection",
 CellChangeTimes->{{3.752045510023188*^9, 
  3.752045530285631*^9}},ExpressionUUID->"95b9b768-0e5b-4c4b-a3dd-\
91d9a2c27cb7"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "compute", " ", "all", " ", "matching", " ", "conditions", " ", "at", " ", 
    "once"}], ",", " ", 
   RowBox[{"also", " ", "generate", " ", "a", " ", "suitable", " ", 
    RowBox[{"SPheno", ".", "m"}], " ", "in", " ", "the", " ", 
    RowBox[{"SplitSUSY", "/", "NMSSM"}], " ", "directory", " ", "as", " ", 
    "well", " ", "as", " ", "Fortran", " ", "functions", " ", "for", " ", 
    "the", " ", "analytical", " ", "expression", " ", "ins", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Ouput", "/", "SMSSM"}], "/", "Matching"}], "/", 
     "SimpleSplitNMSSM"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.752045607413987*^9, 
  3.752045707554408*^9}},ExpressionUUID->"da330e5d-1830-436b-8363-\
7e69740df309"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InitMatching", "[", 
  RowBox[{"InputFile", "\[Rule]", "\"\<Matching_SplitSUSY.m\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.752045532591009*^9, 3.752045563755913*^9}, 
   3.752045606168625*^9},ExpressionUUID->"3817fcc3-1726-442f-800f-\
11534fe6d023"],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Initialise Matching Routines\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045711787978*^9},ExpressionUUID->"284b355a-555b-45e9-893f-\
b97c44b8cc57"],

Cell[BoxData["\<\"Checking model for missing definitions\"\>"], "Print",
 CellChangeTimes->{
  3.75204571181872*^9},ExpressionUUID->"2cd5e1e0-32a1-4abf-ae50-268fad0c171b"],

Cell[BoxData["\<\"Generate Directories\"\>"], "Print",
 CellChangeTimes->{
  3.752045711852181*^9},ExpressionUUID->"68cc65cc-3f61-47f9-89cd-\
2d52e3846339"],

Cell[BoxData["\<\"Building Particle List\"\>"], "Print",
 CellChangeTimes->{
  3.7520457119584217`*^9},ExpressionUUID->"bd52fb8b-fe22-46b6-a1fa-\
0c7ebd3ed379"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate all vertices\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045711991475*^9},ExpressionUUID->"d90d8329-5297-4d93-b32d-\
9277e72e321d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045712208321*^9},ExpressionUUID->"9ebd3ad0-ba0d-47e0-aa22-\
8c218954b7b3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "26", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"26", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{342., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 26, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSS]], "/", 26 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045713216844*^9},ExpressionUUID->"b8f3027e-81ce-40c9-9191-\
09857133d1c4"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045726739298*^9},ExpressionUUID->"11186366-4fdb-4b6f-a636-\
f25245eaef15"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "65", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"65", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{353., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 65, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSSS]], "/", 65 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045727750091*^9},ExpressionUUID->"dc268dd3-0bd8-4b33-81db-\
b6811b049715"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045753135913*^9},ExpressionUUID->"520e9bfd-bc4e-4301-ac4a-\
f360da10747a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "66", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"66", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{343., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 66, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSV]], "/", 66 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045753779595*^9},ExpressionUUID->"472d5857-091e-433e-87f8-\
f2a3e2d2c45a"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      One Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045765771619*^9},ExpressionUUID->"8cd41b99-8271-4220-8a51-\
5f1b214f82d8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045766412847*^9},ExpressionUUID->"9ce53143-da4b-4724-abcc-\
d8d0bac57b6d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045773283155*^9},ExpressionUUID->"4e9a3b8a-ebad-4168-9191-\
7eb15516e5cf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "178", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"178", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{353., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 178, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSVV]], "/", 178 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045773950782*^9},ExpressionUUID->"0fc9f2da-7302-4942-9bc6-\
4e43b750f7ac"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520458123853292`*^9},ExpressionUUID->"b653a66c-7b62-4134-bd20-\
dbcdc23ec800"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"21", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{336., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 21, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVV]], "/", 21 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520458124510508`*^9},ExpressionUUID->"2d360e50-37c9-47ea-ba2c-\
0d018d5bd545"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Scalar - Interactions\"\>", "Section",
   
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045815480816*^9},ExpressionUUID->"714c89a6-5961-4018-8a34-\
527a2b7451ab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "84", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"84", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{353., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 84, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFS]], "/", 84 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520458172046757`*^9},ExpressionUUID->"5632605f-b2d6-4a3f-99ed-\
c1fa54e95070"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045842066353*^9},ExpressionUUID->"94dd113c-c680-4d10-bf6e-\
27debbaeb32b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "59", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"59", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{352., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 59, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFV]], "/", 59 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045842374419*^9},ExpressionUUID->"8c3ca25a-f80d-4b41-9c66-\
88228d56221d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520458625995407`*^9},ExpressionUUID->"86c03657-2b43-4820-9aff-\
e9d31eee3e23"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{343., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045862721264*^9},ExpressionUUID->"3a4adb53-bb41-4eda-9034-\
2d8486654739"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045872602096*^9},ExpressionUUID->"6048f6c5-11d9-48d2-8aef-\
144b5e38cb20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "65", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"65", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 65, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGV]], "/", 65 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045872713873*^9},ExpressionUUID->"4c00e978-d97d-4906-aac6-\
7bf9412804fe"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045876059598*^9},ExpressionUUID->"b4063669-04b2-4b00-bc5d-\
fc77c5d5e193"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "48", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"48", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 48, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGS]], "/", 48 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045876189774*^9},ExpressionUUID->"f35faf2b-a865-484c-8009-\
bb380599ae33"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Auxiliary - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045878870632*^9},ExpressionUUID->"08ea1f6f-87a6-4688-9eb5-\
34869bebd411"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "102", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`ASS], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"102", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`ASS], StandardForm],
    ImageSizeCache->{358., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 102, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`ASS]], "/", 102 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`ASS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045879100357*^9},ExpressionUUID->"8e7e176b-4738-4722-a31b-\
fecb90a9bb5b"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7520458913712893`*^9},ExpressionUUID->"0f5add1a-d14c-4703-ab77-\
6459589db643"],

Cell[BoxData["\<\"Simplify Vertices\"\>"], "Print",
 CellChangeTimes->{
  3.752045891376087*^9},ExpressionUUID->"378f6485-2b5f-4df7-9b51-\
2ebc91f3d340"],

Cell[BoxData["\<\"Writing vertices to files\"\>"], "Print",
 CellChangeTimes->{
  3.752045924373829*^9},ExpressionUUID->"469b9d6d-48d0-4fbd-ac0b-\
1292c91e9886"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All vertices calculated. (Time needed: \"\>", 
   "\[InvisibleSpace]", "214.99158399999993`", 
   "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "All vertices calculated. (Time needed: ", 214.99158399999993`, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045924580999*^9},ExpressionUUID->"4b5e2f0e-efd4-4a03-88d6-\
a65315b03aba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The vertices are saved in \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Vertices/\"\
\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["The vertices are saved in ", 
   StyleForm[
   "/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Vertices/", "Section", 
    FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045924582016*^9},ExpressionUUID->"9dcb6a33-ddf4-4db6-81dd-\
a58cadf32a02"],

Cell[BoxData["\<\"Calculate Expressions for Masses and Rotation \
Matrices\"\>"], "Print",
 CellChangeTimes->{
  3.752045925466209*^9},ExpressionUUID->"3cac4dfd-b06c-4163-bf1a-\
0c096263fc94"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Perform Matching\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752045926647109*^9},ExpressionUUID->"1845c007-ba2a-4348-a0ab-\
92c6a5f16bc9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Tree-Level Matching: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLO, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "5", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLOname, StandardForm],
    ImageSizeCache->{65., {3., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Tree-Level Matching: ", 
   Dynamic[SARAH`DynamicLO], "/", 5, " (", 
   Dynamic[SARAH`DynamicLOname], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045926648386*^9},ExpressionUUID->"182bd5fe-f3c6-447c-91c6-\
aeb02239f4e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  One-Loop Matching: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicNLO, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "5", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicNLOname, StandardForm],
    ImageSizeCache->{65., {3., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  One-Loop Matching: ", 
   Dynamic[SARAH`DynamicNLO], "/", 5, " (", 
   Dynamic[SARAH`DynamicNLOname], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752045927189259*^9},ExpressionUUID->"3596521e-131c-489c-91a3-\
e4222f55006c"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write Output\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046050875486*^9},ExpressionUUID->"b5644946-3fdf-4fce-812f-\
ac1f8e13981d"],

Cell[BoxData["\<\"  Writing LaTeX Output\"\>"], "Print",
 CellChangeTimes->{
  3.752046050876234*^9},ExpressionUUID->"756aba7e-7839-4a58-a807-\
62e24183ad30"],

Cell[BoxData["\<\"  Writing SPheno Output\"\>"], "Print",
 CellChangeTimes->{
  3.75204605156948*^9},ExpressionUUID->"2d6fcf3d-ae6a-4eff-971a-18fc25af90a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Done... Output is written to \"\>", 
   "\[InvisibleSpace]", \
"\<\"/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Matching/\
SimpleSplitNMSSM/\"\>"}],
  SequenceForm[
  "Done... Output is written to ", 
   "/home/martin/FeynTools/sarah4/Output/SMSSM/EWSB/Matching/SimpleSplitNMSSM/\
"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046051812516*^9},ExpressionUUID->"df6e7383-1399-4331-8c5c-\
7fa9f020546c"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create SPheno Output", "Subsection",
 CellChangeTimes->{{3.752046385689947*^9, 3.752046424838399*^9}, {
  3.7520465490121603`*^9, 
  3.7520465501298428`*^9}},ExpressionUUID->"a813fb72-3042-4937-aaba-\
481b4e6c6af8"],

Cell[BoxData[
 RowBox[{"Quit", "[", "]"}]], "Input",
 CellChangeTimes->{{3.752046426158771*^9, 
  3.752046430781917*^9}},ExpressionUUID->"a0ca2c57-a713-4665-ae23-\
2fc1b024c990"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", "SARAH`"}], "\[IndentingNewLine]", 
 RowBox[{"Start", "[", 
  RowBox[{"\"\<SplitSUSY\>\"", ",", "\"\<NMSSM\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.752046434894696*^9, 
  3.752046455767728*^9}},ExpressionUUID->"85dc48ab-1283-4f5e-a2a9-\
eac1988108c0"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    StyleBox["\<\"SARAH \"\>", "Section",
     FontSize->14],
    StyleForm[#, "Section", FontSize -> 14]& ], "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"(Private Version)\"\>", "Section",
     FontSize->14],
    StyleForm[#, "Section", FontSize -> 14]& ]}],
  SequenceForm[
   StyleForm["SARAH ", "Section", FontSize -> 14], 
   StyleForm["(Private Version)", "Section", FontSize -> 14]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046458542098*^9},ExpressionUUID->"35d84b5e-6209-4766-9398-\
4a613032777a"],

Cell[BoxData["\<\"by Florian Staub, 2018\"\>"], "Print",
 CellChangeTimes->{
  3.752046458542601*^9},ExpressionUUID->"b11de04d-4883-4c75-bc6e-\
f9df35d8c7fa"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"contributions by M. Gabelmann, M. D. Goodsell, K. Nickel\"\>",
   
   FontSize->10],
  StyleForm[#, FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.7520464585434437`*^9},ExpressionUUID->"74a595ee-2317-4ad1-bb76-\
7f04ed5c2bfa"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046458543944*^9},ExpressionUUID->"88f7e458-c8a4-4bfd-95c1-\
91c70034d50f"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"References:\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752046458544435*^9},ExpressionUUID->"32517d07-d933-402e-8b24-\
bd732cb2143e"],

Cell[BoxData["\<\"  Comput.Phys.Commun.181 (2010) 1077-1086. \
(arXiv:0909.2863[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.752046458544883*^9},ExpressionUUID->"12a335ad-508c-4c27-a874-\
ce9a8bfd6f1a"],

Cell[BoxData["\<\"  Comput.Phys.Commun.182 (2011) 808-833. \
(arXiv:1002.0840[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.7520464585453987`*^9},ExpressionUUID->"3042924d-85c7-4bbb-9a6b-\
08b616b1e304"],

Cell[BoxData["\<\"  Comput.Phys.Commun.184 (2013) 1792-1809. \
(arXiv:1207.0906[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.7520464585459747`*^9},ExpressionUUID->"d6577e6b-9373-4cae-94d1-\
4afbdc1132ec"],

Cell[BoxData["\<\"  Comput.Phys.Commun.185 (2014) 1773-1790. \
(arXiv:1309.7223[hep-ph])\"\>"], "Print",
 CellChangeTimes->{
  3.752046458546554*^9},ExpressionUUID->"9d48999e-7584-447a-b59f-\
9e3fcf1097ab"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Download and Documentation:\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752046458547084*^9},ExpressionUUID->"35af3a44-2b8b-4895-87f9-\
b96853f37ba8"],

Cell[BoxData["\<\"  http://sarah.hepforge.org\"\>"], "Print",
 CellChangeTimes->{
  3.752046458547571*^9},ExpressionUUID->"d926a47f-0f8b-45d9-a483-\
35a153e989be"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046458548074*^9},ExpressionUUID->"ea0bab6b-e565-401a-8e37-\
62827d584309"],

Cell[BoxData["\<\"Start evaluation of a model with:\"\>"], "Print",
 CellChangeTimes->{
  3.752046458548544*^9},ExpressionUUID->"31a0db5d-3073-4d31-ba92-\
4722c3a46984"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"   Start[\\\"Name of Model\\\"]\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520464585490847`*^9},ExpressionUUID->"31d5178a-ce2f-4f6e-985e-\
f854001b0d99"],

Cell[BoxData["\<\"e.g. Start[\\\"MSSM\\\"] or \
Start[\\\"NMSSM\\\",\\\"CKM\\\"]\"\>"], "Print",
 CellChangeTimes->{
  3.752046458549658*^9},ExpressionUUID->"61ea757a-2497-49d0-84b8-\
ed805baa7dda"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"To get a list with all installed models, use \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"ShowModels\"\>", "Section",
     FontSize->12],
    StyleForm[#, "Section", FontSize -> 12]& ]}],
  SequenceForm["To get a list with all installed models, use ", 
   StyleForm["ShowModels", "Section", FontSize -> 12]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464585502453`*^9},ExpressionUUID->"01fa3974-ad96-491d-a139-\
9c701348f98f"],

Cell[BoxData["\<\"Preparing arrays\"\>"], "Print",
 CellChangeTimes->{
  3.752046459097973*^9},ExpressionUUID->"14df397b-3184-49c4-b57d-\
8267571e7732"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" ... checking Directory: \"\>", 
   "\[InvisibleSpace]", "\<\"/home/martin/FeynTools/sarah4/Models/\"\>"}],
  SequenceForm[
  " ... checking Directory: ", "/home/martin/FeynTools/sarah4/Models/"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464590991087`*^9},ExpressionUUID->"1d279d79-e5e6-4919-b43b-\
c6d52f764d70"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Model files loaded   \"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046459099978*^9},ExpressionUUID->"f717791f-9bb2-419b-be2d-\
59e01a859565"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Model    : \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"SplitNMSSM\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Model    : ", 
   StyleForm["SplitNMSSM", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204645910102*^9},ExpressionUUID->"b1d7d2cc-4469-471e-9cca-fe4e2b4bc0f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Author(s): \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"F.Staub, M. Gabelmann\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Author(s): ", 
   StyleForm["F.Staub, M. Gabelmann", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459102104*^9},ExpressionUUID->"c673efdc-2f8f-46fc-a9cc-\
31bc6dbbd42d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Date     : \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"2018-04-05\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["  Date     : ", 
   StyleForm["2018-04-05", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204645910355*^9},ExpressionUUID->"b6e4480b-d845-48e8-b4fe-9885617c7347"],

Cell[BoxData["\<\"******************************************************* \
\"\>"], "Print",
 CellChangeTimes->{
  3.752046459104394*^9},ExpressionUUID->"626165a5-85b1-4bbd-a53b-\
4549ab319e67"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Loading \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"Susyno\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ], 
   "\[InvisibleSpace]", "\<\" functions for the handling of Lie Groups \"\>"}],
  SequenceForm["Loading ", 
   StyleForm["Susyno", "Section", FontSize -> 10], 
   " functions for the handling of Lie Groups "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459105324*^9},ExpressionUUID->"13afa37b-2b09-4c8b-815f-\
1db8949bdd7a"],

Cell[BoxData["\<\"Based on Susyno v.2.0 by Renato Fonseca (1106.5016)\"\>"], \
"Print",
 CellChangeTimes->{
  3.7520464591060762`*^9},ExpressionUUID->"8e8798e0-3370-4fe1-bcba-\
6a50a5973b8b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"webpage: \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"web.ist.utl.pt/renato.fonseca/susyno.html\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["webpage: ", 
   StyleForm[
   "web.ist.utl.pt/renato.fonseca/susyno.html", "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459106946*^9},ExpressionUUID->"b3ea8d5c-8fb1-422a-bd26-\
7df8f6028fbe"],

Cell[BoxData["\<\"******************************************************* \
\"\>"], "Print",
 CellChangeTimes->{
  3.7520464591079187`*^9},ExpressionUUID->"e34f3e16-0d27-4ba7-acde-\
71da4fbb7c7e"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Initialization\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046459109363*^9},ExpressionUUID->"f67a0d3c-7526-45fa-a5e3-\
664d668a34d7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Checking model files: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCheckModelFiles, StandardForm],
    ImageSizeCache->{117., {3., 9.}}]}],
  SequenceForm["Checking model files: ", 
   Dynamic[SARAH`DynamicCheckModelFiles]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464591367598`*^9},ExpressionUUID->"43987770-5874-4b62-9a68-\
d50b6581106b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Initialize gauge groups: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitGaugeG, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Initialize gauge groups: ", 
   Dynamic[SARAH`DynamicInitGaugeG]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459139908*^9},ExpressionUUID->"0fd86f07-aad4-4124-9836-\
07038a384202"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Initialize field: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitFields, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Initialize field: ", 
   Dynamic[SARAH`DynamicInitFields]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459162962*^9},ExpressionUUID->"87e20d30-8d65-4434-bbfe-\
f77b32ade198"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Preprocessing necessary information: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicInitMisc, StandardForm],
    ImageSizeCache->{67., {0., 9.}}]}],
  SequenceForm["Preprocessing necessary information: ", 
   Dynamic[SARAH`DynamicInitMisc]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204645921815*^9},ExpressionUUID->"5b5a6b08-1fec-44e1-8fea-28d533af61ac"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Checking for anomalies: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCheckAnomalies, StandardForm],
    ImageSizeCache->{1088., {3., 9.}}]}],
  SequenceForm["Checking for anomalies: ", 
   Dynamic[SARAH`DynamicCheckAnomalies]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464594164457`*^9},ExpressionUUID->"bf9f4f19-f3ce-444d-8497-\
72d303bfbc8d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Derive Lagrangian\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046459470373*^9},ExpressionUUID->"dfd76ff0-2ee7-4a48-bc5b-\
6332c8bc9acd"],

Cell[BoxData["\<\"Calculate kinetic Terms\"\>"], "Print",
 CellChangeTimes->{
  3.752046459472307*^9},ExpressionUUID->"cbcb38d2-93b5-4608-82a9-\
e1656673b6c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... for scalars: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticScalarNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticScalarName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... for scalars: ", 
   Dynamic[SARAH`DynamicKineticScalarNr], "/", 14, " (", 
   Dynamic[SARAH`DynamicKineticScalarName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459474667*^9},ExpressionUUID->"20bf5dff-d5fe-464e-abf6-\
8a2f44f7a187"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... for fermions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticFermionNr, StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicKineticFermionName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... for fermions: ", 
   Dynamic[SARAH`DynamicKineticFermionNr], "/", 14, " (", 
   Dynamic[SARAH`DynamicKineticFermionName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464595211153`*^9},ExpressionUUID->"4f185746-cefa-418e-877c-\
5fcbc3d4ea9c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate vector self-interactions: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicVectorNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicVectorName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate vector self-interactions: ", 
   Dynamic[SARAH`DynamicVectorNr], "/", 3, " (", 
   Dynamic[SARAH`DynamicVectorName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459757174*^9},ExpressionUUID->"9d11bc0c-3454-48f1-a1b2-\
cb6f7327deaa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculate gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGaugeTNr, StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "17", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicGaugeTName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calculate gauge transformations: ", 
   Dynamic[SARAH`DynamicGaugeTNr], "/", 17, " (", 
   Dynamic[SARAH`DynamicGaugeTName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459782115*^9},ExpressionUUID->"e443e645-510d-4a6b-8044-\
ee8bf0f2dc71"],

Cell[BoxData["\<\"Eleminate sums\"\>"], "Print",
 CellChangeTimes->{
  3.752046459837051*^9},ExpressionUUID->"3072755a-cf8f-4b7a-a330-\
0d6ca7791252"],

Cell[BoxData["\<\"Calc Complete Lagrangian\"\>"], "Print",
 CellChangeTimes->{
  3.752046459838072*^9},ExpressionUUID->"8cd66c73-c6a5-4734-ae48-\
4a82206581e3"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046459838922*^9},ExpressionUUID->"642ecaaf-0e82-44ac-ae9f-\
e7c13195a0ec"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Evolve States: GaugeES\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.75204645983986*^9},ExpressionUUID->"7a80e224-49fa-478b-a6bd-d755c3af8203"],

Cell[BoxData["\<\"Adding terms to the Lagrangian: \"\>"], "Print",
 CellChangeTimes->{
  3.752046459840741*^9},ExpressionUUID->"c28fa9ef-2006-4523-80c3-\
2dc84103825a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" ... adding: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], " ", "mSi2", " ", 
     RowBox[{"Si", ".", "Si"}]}], "-", 
    FractionBox[
     RowBox[{"mSr2", " ", 
      RowBox[{"Sr", ".", "Sr"}]}], "2"], "-", 
    RowBox[{"m2", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "H"}]}], "-", 
    RowBox[{
     SqrtBox["2"], " ", "KappaSHr", " ", 
     RowBox[{"Sr", ".", "H", ".", 
      RowBox[{"conj", "[", "H", "]"}]}]}], "+", 
    FractionBox[
     RowBox[{"3", " ", "KappaSri", " ", 
      RowBox[{"Sr", ".", "Si", ".", "Si"}]}], 
     SqrtBox["2"]], "-", 
    FractionBox[
     RowBox[{"KappaSr", " ", 
      RowBox[{"Sr", ".", "Sr", ".", "Sr"}]}], 
     SqrtBox["2"]], "-", 
    RowBox[{
     FractionBox["1", "8"], " ", "LambdaSi", " ", 
     RowBox[{"Si", ".", "Si", ".", "Si", ".", "Si"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], " ", "LambdaSHi", " ", 
     RowBox[{"Si", ".", "Si", ".", 
      RowBox[{"conj", "[", "H", "]"}], ".", "H"}]}], "-", 
    RowBox[{
     FractionBox["1", "4"], " ", "LambdaSri", " ", 
     RowBox[{"Sr", ".", "Sr", ".", "Si", ".", "Si"}]}], "-", 
    RowBox[{
     FractionBox["1", "8"], " ", "LambdaSr", " ", 
     RowBox[{"Sr", ".", "Sr", ".", "Sr", ".", "Sr"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], " ", "LambdaSHr", " ", 
     RowBox[{"Sr", ".", "Sr", ".", 
      RowBox[{"conj", "[", "H", "]"}], ".", "H"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], " ", "LambdaH", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "H", ".", 
      RowBox[{"conj", "[", "H", "]"}], ".", "H"}]}]}], 
   "\[InvisibleSpace]", "\<\" (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicStatusAddTerms[
     Rational[-1, 2] $CellContext`mSi2 Dot[$CellContext`Si, $CellContext`Si] + 
      Rational[-1, 2] $CellContext`mSr2 Dot[SARAH`Sr, SARAH`Sr] - 
      Susyno`LieGroups`m2 Dot[
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] - 
      2^Rational[1, 2] $CellContext`KappaSHr Dot[SARAH`Sr, $CellContext`H, 
        Susyno`LieGroups`conj[$CellContext`H]] + 
      3 2^Rational[-1, 2] $CellContext`KappaSri 
       Dot[SARAH`Sr, $CellContext`Si, $CellContext`Si] - 
      2^Rational[-1, 2] $CellContext`KappaSr 
      Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
      Rational[-1, 8] $CellContext`LambdaSi 
       Dot[$CellContext`Si, $CellContext`Si, $CellContext`Si, \
$CellContext`Si] + 
      Rational[-1, 2] $CellContext`LambdaSHi 
       Dot[$CellContext`Si, $CellContext`Si, 
         Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
      Rational[-1, 4] $CellContext`LambdaSri 
       Dot[SARAH`Sr, SARAH`Sr, $CellContext`Si, $CellContext`Si] + 
      Rational[-1, 8] $CellContext`LambdaSr 
       Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
      Rational[-1, 2] $CellContext`LambdaSHr Dot[SARAH`Sr, SARAH`Sr, 
         Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
      Rational[-1, 2] $CellContext`LambdaH Dot[
         Susyno`LieGroups`conj[$CellContext`H], $CellContext`H, 
         Susyno`LieGroups`conj[$CellContext`H], $CellContext`H]], 
     StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[
  " ... adding: ", 
   Rational[-1, 2] $CellContext`mSi2 Dot[$CellContext`Si, $CellContext`Si] + 
   Rational[-1, 2] $CellContext`mSr2 Dot[SARAH`Sr, SARAH`Sr] - 
   Susyno`LieGroups`m2 Dot[
     Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] - 
   2^Rational[1, 2] $CellContext`KappaSHr Dot[SARAH`Sr, $CellContext`H, 
     Susyno`LieGroups`conj[$CellContext`H]] + 
   3 2^Rational[-1, 2] $CellContext`KappaSri 
    Dot[SARAH`Sr, $CellContext`Si, $CellContext`Si] - 
   2^Rational[-1, 2] $CellContext`KappaSr Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
   Rational[-1, 8] $CellContext`LambdaSi 
    Dot[$CellContext`Si, $CellContext`Si, $CellContext`Si, $CellContext`Si] + 
   Rational[-1, 2] $CellContext`LambdaSHi 
    Dot[$CellContext`Si, $CellContext`Si, 
      Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
   Rational[-1, 4] $CellContext`LambdaSri 
    Dot[SARAH`Sr, SARAH`Sr, $CellContext`Si, $CellContext`Si] + 
   Rational[-1, 8] $CellContext`LambdaSr 
    Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
   Rational[-1, 2] $CellContext`LambdaSHr Dot[SARAH`Sr, SARAH`Sr, 
      Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
   Rational[-1, 2] $CellContext`LambdaH Dot[
      Susyno`LieGroups`conj[$CellContext`H], $CellContext`H, 
      Susyno`LieGroups`conj[$CellContext`H], $CellContext`H], " (", 
   Dynamic[
    SARAH`DynamicStatusAddTerms[
    Rational[-1, 2] $CellContext`mSi2 Dot[$CellContext`Si, $CellContext`Si] + 
     Rational[-1, 2] $CellContext`mSr2 Dot[SARAH`Sr, SARAH`Sr] - 
     Susyno`LieGroups`m2 Dot[
       Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] - 
     2^Rational[1, 2] $CellContext`KappaSHr Dot[SARAH`Sr, $CellContext`H, 
       Susyno`LieGroups`conj[$CellContext`H]] + 
     3 2^Rational[-1, 2] $CellContext`KappaSri 
      Dot[SARAH`Sr, $CellContext`Si, $CellContext`Si] - 
     2^Rational[-1, 2] $CellContext`KappaSr Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
     Rational[-1, 8] $CellContext`LambdaSi 
      Dot[$CellContext`Si, $CellContext`Si, $CellContext`Si, $CellContext`Si] + 
     Rational[-1, 2] $CellContext`LambdaSHi 
      Dot[$CellContext`Si, $CellContext`Si, 
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
     Rational[-1, 4] $CellContext`LambdaSri 
      Dot[SARAH`Sr, SARAH`Sr, $CellContext`Si, $CellContext`Si] + 
     Rational[-1, 8] $CellContext`LambdaSr 
      Dot[SARAH`Sr, SARAH`Sr, SARAH`Sr, SARAH`Sr] + 
     Rational[-1, 2] $CellContext`LambdaSHr Dot[SARAH`Sr, SARAH`Sr, 
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`H] + 
     Rational[-1, 2] $CellContext`LambdaH Dot[
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`H, 
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`H]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459843454*^9},ExpressionUUID->"e4e6b5ae-7940-4c33-b1c5-\
dc5d09b16aba"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\" ... adding: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], " ", "MB", " ", 
     RowBox[{"FB", ".", "FB"}]}], "-", 
    FractionBox[
     RowBox[{"MG", " ", 
      RowBox[{"FG", ".", "FG"}]}], "2"], "-", 
    FractionBox[
     RowBox[{"MW", " ", 
      RowBox[{"FW", ".", "FW"}]}], "2"], "-", 
    FractionBox[
     RowBox[{"g1d", " ", 
      RowBox[{"H", ".", "FB", ".", "Hd"}]}], 
     SqrtBox["2"]], "-", 
    RowBox[{"Ysd", " ", 
     RowBox[{"H", ".", "Fs", ".", "Hd"}]}], "+", 
    RowBox[{"g2d", " ", 
     RowBox[{"H", ".", "FW", ".", "Hd"}]}], "+", 
    RowBox[{"Yu", " ", 
     RowBox[{"H", ".", "u", ".", "q"}]}], "-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", "Ysi", " ", 
      RowBox[{"Si", ".", "Fs", ".", "Fs"}]}], 
     SqrtBox["2"]], "-", 
    FractionBox[
     RowBox[{"\[ImaginaryI]", " ", "Ysiud", " ", 
      RowBox[{"Si", ".", "Hu", ".", "Hd"}]}], 
     SqrtBox["2"]], "-", 
    FractionBox[
     RowBox[{"Ysr", " ", 
      RowBox[{"Sr", ".", "Fs", ".", "Fs"}]}], 
     SqrtBox["2"]], "-", 
    FractionBox[
     RowBox[{"Ysrud", " ", 
      RowBox[{"Sr", ".", "Hu", ".", "Hd"}]}], 
     SqrtBox["2"]], "-", 
    RowBox[{"Yd", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "d", ".", "q"}]}], "-", 
    RowBox[{"Ye", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "e", ".", "l"}]}], "-", 
    FractionBox[
     RowBox[{"g1u", " ", 
      RowBox[{
       RowBox[{"conj", "[", "H", "]"}], ".", "FB", ".", "Hu"}]}], 
     SqrtBox["2"]], "+", 
    RowBox[{"Ysu", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "Fs", ".", "Hu"}]}], "-", 
    RowBox[{"g2u", " ", 
     RowBox[{
      RowBox[{"conj", "[", "H", "]"}], ".", "FW", ".", "Hu"}]}]}], 
   "\[InvisibleSpace]", "\<\" (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicStatusAddTerms[
     Rational[-1, 2] $CellContext`MB Dot[$CellContext`FB, $CellContext`FB] + 
      Rational[-1, 2] $CellContext`MG Dot[$CellContext`FG, $CellContext`FG] + 
      Rational[-1, 2] $CellContext`MW Dot[$CellContext`FW, $CellContext`FW] - 
      2^Rational[-1, 2] $CellContext`g1d 
      Dot[$CellContext`H, $CellContext`FB, SARAH`Hd] - $CellContext`Ysd 
      Dot[$CellContext`H, $CellContext`Fs, SARAH`Hd] + $CellContext`g2d 
       Dot[$CellContext`H, $CellContext`FW, SARAH`Hd] + 
      SARAH`Yu Dot[$CellContext`H, $CellContext`u, SARAH`q] + 
      Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysi 
       Dot[$CellContext`Si, $CellContext`Fs, $CellContext`Fs] + 
      Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysiud 
       Dot[$CellContext`Si, SARAH`Hu, SARAH`Hd] - 
      2^Rational[-1, 2] $CellContext`Ysr 
      Dot[SARAH`Sr, $CellContext`Fs, $CellContext`Fs] - 
      2^Rational[-1, 2] $CellContext`Ysrud Dot[SARAH`Sr, SARAH`Hu, SARAH`Hd] - 
      SARAH`Yd Dot[
        Susyno`LieGroups`conj[$CellContext`H], SARAH`d, SARAH`q] - SARAH`Ye 
      Dot[
        Susyno`LieGroups`conj[$CellContext`H], Susyno`LieGroups`e, SARAH`l] - 
      2^Rational[-1, 2] $CellContext`g1u Dot[
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`FB, 
        SARAH`Hu] + $CellContext`Ysu Dot[
         Susyno`LieGroups`conj[$CellContext`H], $CellContext`Fs, 
         SARAH`Hu] - $CellContext`g2u Dot[
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`FW, SARAH`Hu]], 
     StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[
  " ... adding: ", 
   Rational[-1, 2] $CellContext`MB Dot[$CellContext`FB, $CellContext`FB] + 
   Rational[-1, 2] $CellContext`MG Dot[$CellContext`FG, $CellContext`FG] + 
   Rational[-1, 2] $CellContext`MW Dot[$CellContext`FW, $CellContext`FW] - 
   2^Rational[-1, 2] $CellContext`g1d 
   Dot[$CellContext`H, $CellContext`FB, SARAH`Hd] - $CellContext`Ysd 
   Dot[$CellContext`H, $CellContext`Fs, SARAH`Hd] + $CellContext`g2d 
    Dot[$CellContext`H, $CellContext`FW, SARAH`Hd] + 
   SARAH`Yu Dot[$CellContext`H, $CellContext`u, SARAH`q] + 
   Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysi 
    Dot[$CellContext`Si, $CellContext`Fs, $CellContext`Fs] + 
   Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysiud 
    Dot[$CellContext`Si, SARAH`Hu, SARAH`Hd] - 
   2^Rational[-1, 2] $CellContext`Ysr 
   Dot[SARAH`Sr, $CellContext`Fs, $CellContext`Fs] - 
   2^Rational[-1, 2] $CellContext`Ysrud Dot[SARAH`Sr, SARAH`Hu, SARAH`Hd] - 
   SARAH`Yd Dot[
     Susyno`LieGroups`conj[$CellContext`H], SARAH`d, SARAH`q] - SARAH`Ye Dot[
     Susyno`LieGroups`conj[$CellContext`H], Susyno`LieGroups`e, SARAH`l] - 
   2^Rational[-1, 2] $CellContext`g1u Dot[
     Susyno`LieGroups`conj[$CellContext`H], $CellContext`FB, 
     SARAH`Hu] + $CellContext`Ysu Dot[
      Susyno`LieGroups`conj[$CellContext`H], $CellContext`Fs, 
      SARAH`Hu] - $CellContext`g2u Dot[
     Susyno`LieGroups`conj[$CellContext`H], $CellContext`FW, SARAH`Hu], " (", 
   
   Dynamic[
    SARAH`DynamicStatusAddTerms[
    Rational[-1, 2] $CellContext`MB Dot[$CellContext`FB, $CellContext`FB] + 
     Rational[-1, 2] $CellContext`MG Dot[$CellContext`FG, $CellContext`FG] + 
     Rational[-1, 2] $CellContext`MW Dot[$CellContext`FW, $CellContext`FW] - 
     2^Rational[-1, 2] $CellContext`g1d 
     Dot[$CellContext`H, $CellContext`FB, SARAH`Hd] - $CellContext`Ysd 
     Dot[$CellContext`H, $CellContext`Fs, SARAH`Hd] + $CellContext`g2d 
      Dot[$CellContext`H, $CellContext`FW, SARAH`Hd] + 
     SARAH`Yu Dot[$CellContext`H, $CellContext`u, SARAH`q] + 
     Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysi 
      Dot[$CellContext`Si, $CellContext`Fs, $CellContext`Fs] + 
     Complex[0, -1] 2^Rational[-1, 2] $CellContext`Ysiud 
      Dot[$CellContext`Si, SARAH`Hu, SARAH`Hd] - 
     2^Rational[-1, 2] $CellContext`Ysr 
     Dot[SARAH`Sr, $CellContext`Fs, $CellContext`Fs] - 
     2^Rational[-1, 2] $CellContext`Ysrud Dot[SARAH`Sr, SARAH`Hu, SARAH`Hd] - 
     SARAH`Yd Dot[
       Susyno`LieGroups`conj[$CellContext`H], SARAH`d, SARAH`q] - SARAH`Ye Dot[
       Susyno`LieGroups`conj[$CellContext`H], Susyno`LieGroups`e, SARAH`l] - 
     2^Rational[-1, 2] $CellContext`g1u Dot[
       Susyno`LieGroups`conj[$CellContext`H], $CellContext`FB, 
       SARAH`Hu] + $CellContext`Ysu Dot[
        Susyno`LieGroups`conj[$CellContext`H], $CellContext`Fs, 
        SARAH`Hu] - $CellContext`g2u Dot[
       Susyno`LieGroups`conj[$CellContext`H], $CellContext`FW, SARAH`Hu]]], 
   ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046459968553*^9},ExpressionUUID->"d5185993-d1bd-43c0-bbfb-\
86b9404b444e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Rotate Lagrangian: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRotateLag[1], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["Rotate Lagrangian: ", 
   Dynamic[
    SARAH`DynamicRotateLag[1]], "/", 14],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046460220155*^9},ExpressionUUID->"9c8dc8b9-a271-4407-a71b-\
4f3a82604433"],

Cell[BoxData["\<\"Derive ghost terms: \"\>"], "Print",
 CellChangeTimes->{
  3.752046460363686*^9},ExpressionUUID->"98074ca6-44b9-48c5-8b44-\
803912bf2f5f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... generate gauge fixing terms: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[
     SARAH`DynamicGFnr[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicGFname[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... generate gauge fixing terms: ", 
   Dynamic[
    SARAH`DynamicGFnr[SARAH`GaugeES]], "/", 3, " (", 
   Dynamic[
    SARAH`DynamicGFname[SARAH`GaugeES]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464603894243`*^9},ExpressionUUID->"7cb6ca9c-a8d1-440c-aa63-\
3e5f0ffa1235"],

Cell[BoxData["\<\"  ... calculate Ghost interactions\"\>"], "Print",
 CellChangeTimes->{
  3.7520464603912687`*^9},ExpressionUUID->"0d4af0f8-6e42-4ed7-976b-\
4e4e9bd51486"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",
 CellChangeTimes->{
  3.7520464604442244`*^9},ExpressionUUID->"b2e06f57-e4a4-495c-ba75-\
eddeddc31b29"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save information (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicSaveInfo[SARAH`GaugeES], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Save information (", 
   Dynamic[
    SARAH`DynamicSaveInfo[SARAH`GaugeES]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046460445839*^9},ExpressionUUID->"bca38708-f615-4277-8a78-\
2aca72382ba8"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046460500205*^9},ExpressionUUID->"e84240be-c768-4f17-ad2e-\
2f33e8b8fb86"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Evolve States: EWSB\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046460501217*^9},ExpressionUUID->"b2607755-2e8e-41e1-9d6b-\
1a818ad8e539"],

Cell[BoxData["\<\"Parametrize Higgs Sector\"\>"], "Print",
 CellChangeTimes->{
  3.7520464605021257`*^9},ExpressionUUID->"6380148d-6d05-44e6-8539-\
10712eecf221"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTvev[2]], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "30", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTvev[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTvev[2]]], "/", 30, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTvev[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046460503902*^9},ExpressionUUID->"cedb53b9-8bae-475d-b627-\
07bc455a6077"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calc mass matrices gauge sector: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicMMgaugeNr[SARAH`EWSB], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicMMgaugeName[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Calc mass matrices gauge sector: ", 
   Dynamic[
    SARAH`DynamicMMgaugeNr[SARAH`EWSB]], "/", 2, "(", 
   Dynamic[
    SARAH`DynamicMMgaugeName[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046460558998*^9},ExpressionUUID->"63c6550d-b64e-40c6-89ad-\
9f2d8df1a5f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTgaugeMM[2]], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "37", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTgaugeMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTgaugeMM[2]]], "/", 37, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTgaugeMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464606643057`*^9},ExpressionUUID->"8063cd49-fee4-44da-85e2-\
3e2bb7b03e8c"],

Cell[BoxData["\<\"Add Phases\"\>"], "Print",
 CellChangeTimes->{
  3.752046460739149*^9},ExpressionUUID->"c3a8a0fd-a79b-41f0-a7ca-\
03f172f8c5f5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTphasesMM[2]], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "33", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTphasesMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTphasesMM[2]]], "/", 33, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTphasesMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046460741015*^9},ExpressionUUID->"0d957782-3181-49aa-ac38-\
4894a40471d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Rotate Lagrangian: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRotateLag[2], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14"}],
  SequenceForm["Rotate Lagrangian: ", 
   Dynamic[
    SARAH`DynamicRotateLag[2]], "/", 14],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464607422543`*^9},ExpressionUUID->"81820431-17a4-4dee-a426-\
dd483f52f9ec"],

Cell[BoxData["\<\"Derive ghost terms: \"\>"], "Print",
 CellChangeTimes->{
  3.752046460993226*^9},ExpressionUUID->"4060bbc7-fda8-48e7-9f3a-\
9bf1fa65b192"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... generate gauge fixing terms: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[
     SARAH`DynamicGFnr[SARAH`EWSB], StandardForm],
    ImageSizeCache->{10., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicGFname[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... generate gauge fixing terms: ", 
   Dynamic[
    SARAH`DynamicGFnr[SARAH`EWSB]], "/", 4, " (", 
   Dynamic[
    SARAH`DynamicGFname[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464609951277`*^9},ExpressionUUID->"a39fd052-b807-4488-8553-\
b53d40754d1d"],

Cell[BoxData["\<\"  ... calculate Ghost interactions\"\>"], "Print",
 CellChangeTimes->{
  3.7520464614730463`*^9},ExpressionUUID->"444c1dbc-82f3-43b7-9a89-\
736b2b0f9e70"],

Cell[BoxData["\<\"Calc Mixings of Matter Fields\"\>"], "Print",
 CellChangeTimes->{
  3.752046461494278*^9},ExpressionUUID->"39501baa-d903-4b52-9a6f-\
52e63b15ae65"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculate mass matrices \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicNrMass[{{{$CellContext`phiH, $CellContext`phiS}, \
{$CellContext`phiH, $CellContext`phiS}}, {{$CellContext`sigmaH, \
$CellContext`Sm}, {$CellContext`sigmaH, $CellContext`Sm}}, \
{{$CellContext`dL}, {
         Susyno`LieGroups`conj[$CellContext`dR]}}, {{$CellContext`uL}, {
         Susyno`LieGroups`conj[$CellContext`uR]}}, {{$CellContext`eL}, {
         Susyno`LieGroups`conj[$CellContext`eR]}}, {{$CellContext`fB, \
$CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, $CellContext`fS}, \
{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`fS}}, {{$CellContext`fWm, $CellContext`FHdm}, {$CellContext`fWp, \
$CellContext`FHup}}}], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicNameMass[{{{$CellContext`phiH, $CellContext`phiS}, \
{$CellContext`phiH, $CellContext`phiS}}, {{$CellContext`sigmaH, \
$CellContext`Sm}, {$CellContext`sigmaH, $CellContext`Sm}}, \
{{$CellContext`dL}, {
         Susyno`LieGroups`conj[$CellContext`dR]}}, {{$CellContext`uL}, {
         Susyno`LieGroups`conj[$CellContext`uR]}}, {{$CellContext`eL}, {
         Susyno`LieGroups`conj[$CellContext`eR]}}, {{$CellContext`fB, \
$CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, $CellContext`fS}, \
{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`fS}}, {{$CellContext`fWm, $CellContext`FHdm}, {$CellContext`fWp, \
$CellContext`FHup}}}], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculate mass matrices ", 
   Dynamic[
    SARAH`DynamicNrMass[{{{$CellContext`phiH, $CellContext`phiS}, \
{$CellContext`phiH, $CellContext`phiS}}, {{$CellContext`sigmaH, \
$CellContext`Sm}, {$CellContext`sigmaH, $CellContext`Sm}}, \
{{$CellContext`dL}, {
        Susyno`LieGroups`conj[$CellContext`dR]}}, {{$CellContext`uL}, {
        Susyno`LieGroups`conj[$CellContext`uR]}}, {{$CellContext`eL}, {
        Susyno`LieGroups`conj[$CellContext`eR]}}, {{$CellContext`fB, \
$CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, $CellContext`fS}, \
{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`fS}}, {{$CellContext`fWm, $CellContext`FHdm}, {$CellContext`fWp, \
$CellContext`FHup}}}]], "/", 7, " (", 
   Dynamic[
    SARAH`DynamicNameMass[{{{$CellContext`phiH, $CellContext`phiS}, \
{$CellContext`phiH, $CellContext`phiS}}, {{$CellContext`sigmaH, \
$CellContext`Sm}, {$CellContext`sigmaH, $CellContext`Sm}}, \
{{$CellContext`dL}, {
        Susyno`LieGroups`conj[$CellContext`dR]}}, {{$CellContext`uL}, {
        Susyno`LieGroups`conj[$CellContext`uR]}}, {{$CellContext`eL}, {
        Susyno`LieGroups`conj[$CellContext`eR]}}, {{$CellContext`fB, \
$CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, $CellContext`fS}, \
{$CellContext`fB, $CellContext`fW0, $CellContext`FHd0, $CellContext`FHu0, \
$CellContext`fS}}, {{$CellContext`fWm, $CellContext`FHdm}, {$CellContext`fWp, \
$CellContext`FHup}}}]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046461549247*^9},ExpressionUUID->"6b288e11-1880-46f7-9a07-\
6d97a10dd4f0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Update gauge transformations: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGT[
      SARAH`UGTmatterMM[2]], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "44", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicUGTname[
      SARAH`UGTmatterMM[2]], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Update gauge transformations: ", 
   Dynamic[
    SARAH`DynamicUGT[
     SARAH`UGTmatterMM[2]]], "/", 44, " (", 
   Dynamic[
    SARAH`DynamicUGTname[
     SARAH`UGTmatterMM[2]]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204646216788*^9},ExpressionUUID->"cfce0bc4-853d-4635-b355-5bbe5a1fcf41"],

Cell[BoxData["\<\"Calculate Tadpole Equations\"\>"], "Print",
 CellChangeTimes->{
  3.752046462241415*^9},ExpressionUUID->"def650f3-c8b1-4de9-8165-\
cdd4c2b7e6e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Save information (\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicSaveInfo[SARAH`EWSB], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Save information (", 
   Dynamic[
    SARAH`DynamicSaveInfo[SARAH`EWSB]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464626909037`*^9},ExpressionUUID->"a676351b-1e41-44b6-83df-\
2b651c30a5c9"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046463361434*^9},ExpressionUUID->"0ee2c2dd-3042-4d88-a3b5-\
44ea56633fb3"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Finishing\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046463362444*^9},ExpressionUUID->"9e77d06f-2647-44b5-b9ea-\
7e7c200be170"],

Cell[BoxData["\<\"Calculate final Lagrangian\"\>"], "Print",
 CellChangeTimes->{
  3.752046463363305*^9},ExpressionUUID->"88664ed8-2e33-40f6-a7d7-\
257e5e68cbdf"],

Cell[BoxData["\<\"Cleaning up\"\>"], "Print",
 CellChangeTimes->{
  3.752046463364151*^9},ExpressionUUID->"863d89fc-4db9-4cde-aa38-\
4e96acee303f"],

Cell[BoxData["\<\"   ... add matrix products\"\>"], "Print",
 CellChangeTimes->{
  3.7520464633650217`*^9},ExpressionUUID->"882647cb-4ed0-40b4-ae1a-\
f15f8897a48a"],

Cell[BoxData["\<\"   ... checking for massless particles\"\>"], "Print",
 CellChangeTimes->{
  3.752046463365924*^9},ExpressionUUID->"197d152e-d375-4224-b190-\
a4cfdf119364"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   ... calculating tree level masses (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCalcTreeMasses, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   ... calculating tree level masses (", 
   Dynamic[SARAH`DynamicCalcTreeMasses], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046464052672*^9},ExpressionUUID->"6c812504-10a4-4e4f-8bf8-\
ab165ea7e682"],

Cell[BoxData["\<\"   ... simplify mass matrices\"\>"], "Print",
 CellChangeTimes->{
  3.75204646412704*^9},ExpressionUUID->"6cb3e7d1-fb32-465f-9bc0-73c4a079903a"],

Cell[BoxData["\<\"Numerical calculations (if necessary)\"\>"], "Print",
 CellChangeTimes->{
  3.7520464641286507`*^9},ExpressionUUID->"8a0fb273-6b39-4b6d-a39a-\
5941fd847ac1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   ... checking for spectrum file: \"\>", "\[InvisibleSpace]", 
   
   DynamicBox[ToBoxes[SARAH`DynamicSpectrumFileInput, StandardForm],
    ImageSizeCache->{200., {3., 9.}}]}],
  SequenceForm["   ... checking for spectrum file: ", 
   Dynamic[SARAH`DynamicSpectrumFileInput]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046464130433*^9},ExpressionUUID->"dfdbcb9e-3a4c-4f5a-8de1-\
1583d03a6067"],

Cell[BoxData["\<\"   ... reading parameter values and dependences\"\>"], \
"Print",
 CellChangeTimes->{
  3.752046464132389*^9},ExpressionUUID->"2061fd49-c274-4199-9a37-\
5cc35c01a908"],

Cell[BoxData["\<\"   ... calculate mixing matrices\"\>"], "Print",
 CellChangeTimes->{
  3.752046464134128*^9},ExpressionUUID->"4ba6a039-e534-4e98-91e3-\
34eb42b175af"],

Cell[BoxData["\<\"Checking for CP even and odd scalars\"\>"], "Print",
 CellChangeTimes->{
  3.752046464160308*^9},ExpressionUUID->"a6e2b546-1b37-4409-95cf-\
ca1bb4ecdbfb"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046464162718*^9},ExpressionUUID->"311fbb7a-c5d9-4eaf-829f-\
c16c5290625d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All Done. \"\>", "\[InvisibleSpace]", "\<\"SplitSUSY\"\>", 
   "\[InvisibleSpace]", "\<\" is ready!\"\>"}],
  SequenceForm["All Done. ", "SplitSUSY", " is ready!"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204646416397*^9},ExpressionUUID->"a0809791-c34b-41dd-b904-03fbf1e8d3da"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"(Model initialized in \"\>", "\[InvisibleSpace]", 
   "5.105983000000001`", "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm["(Model initialized in ", 5.105983000000001, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520464641650057`*^9},ExpressionUUID->"52382fc9-a438-429c-8b7e-\
5a446e159eed"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046464165956*^9},ExpressionUUID->"eb37cfb4-1b2f-404f-a86a-\
46c7591d484b"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046464166851*^9},ExpressionUUID->"e0184929-979d-4af9-9570-\
742b09aa31e5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Are you unfamiliar with SARAH? Use \"\>", "\[InvisibleSpace]", 
   
   TagBox[
    StyleBox["\<\"SARAH`FirstSteps\"\>", "Section",
     FontSize->12],
    StyleForm[#, "Section", FontSize -> 12]& ]}],
  SequenceForm["Are you unfamiliar with SARAH? Use ", 
   StyleForm["SARAH`FirstSteps", "Section", FontSize -> 12]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046464167864*^9},ExpressionUUID->"99d40189-8083-4e94-9504-\
d707c2da12dc"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeSPheno", "[", 
  RowBox[{
   RowBox[{
   "InputFile", "\[Rule]", "\"\<SPhenoEFT_SMSSM_SimpleSplitNMSSM.m\>\""}], 
   ",", 
   RowBox[{"IncludeFlavorKit", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.752046459079307*^9, 
  3.752046506275201*^9}},ExpressionUUID->"603ca995-fd45-4e74-9990-\
4b6bd5897704"],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Generate SPheno Source Code\"\>", "Section"],
  StyleForm[#, "Section"]& ]], "Print",
 CellChangeTimes->{
  3.752046508599099*^9},ExpressionUUID->"617b8a2b-848a-4831-8acc-\
fe4f0d8b7b7d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Performing necessary calculations\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.752046508600123*^9},ExpressionUUID->"62fdcec2-114c-4e73-8618-\
0e27f99d6cfc"],

Cell[BoxData["\<\"Checking model for missing definitions\"\>"], "Print",
 CellChangeTimes->{
  3.752046508654502*^9},ExpressionUUID->"6d01f63e-ec99-49e3-b3cd-\
3f8c7751e5c1"],

Cell[BoxData["\<\"Generate Directories\"\>"], "Print",
 CellChangeTimes->{
  3.752046508655724*^9},ExpressionUUID->"c1bd9798-8a90-480a-9f97-\
f8554b72622a"],

Cell[BoxData["\<\"Building Particle List\"\>"], "Print",
 CellChangeTimes->{
  3.752046508733947*^9},ExpressionUUID->"d06514d0-7d1e-4009-b961-\
01bad91049fd"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate all vertices\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046508793408*^9},ExpressionUUID->"f92315d9-7249-475e-9978-\
055503c80092"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046508876267*^9},ExpressionUUID->"da3cd9b0-de80-4831-ac03-\
b3d815643dd8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"6", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSS], StandardForm],
    ImageSizeCache->{352., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 6, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSS]], "/", 6 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520465089519987`*^9},ExpressionUUID->"333a758c-d8e5-4d6d-a388-\
fc32ac6874c6"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046509769466*^9},ExpressionUUID->"4c46e125-56aa-49c4-b94b-\
0e1062561af3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"9", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSSS], StandardForm],
    ImageSizeCache->{343., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 9, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSSS]], "/", 9 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSSS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046509839122*^9},ExpressionUUID->"dc15a044-740e-49ef-84e2-\
8cd328ee6b93"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465111466103`*^9},ExpressionUUID->"56331768-80f9-4db4-a396-\
26e0ff4d10eb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "32", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"32", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 32, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSV]], "/", 32 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046511345455*^9},ExpressionUUID->"d4bfc014-8b5c-46e4-9cc1-\
209e91991da0"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      One Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046514732181*^9},ExpressionUUID->"11190609-5d20-4d4b-b533-\
a0dae8b6e50a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046514915203*^9},ExpressionUUID->"86b3bc34-f220-49a2-8adf-\
a0d9e20c8078"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - Two Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046519303837*^9},ExpressionUUID->"50b55c51-6afd-44ac-a7a2-\
1a4a43314a5d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "80", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"80", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`SSVV], StandardForm],
    ImageSizeCache->{350., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 80, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`SSVV]], "/", 80 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`SSVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046519514297*^9},ExpressionUUID->"8bbc65b2-456d-45e3-bfaf-\
c12ca42d8c89"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Three Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046531608768*^9},ExpressionUUID->"ebc1a9c7-6e57-4c6b-9a04-\
4a9cc12f4d5f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"21", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 21, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVV]], "/", 21 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204653167222*^9},ExpressionUUID->"0980d597-bfc7-4c41-aa29-b4325e11a901"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Scalar - Interactions\"\>", "Section",
   
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046534760466*^9},ExpressionUUID->"4eac567a-1fa6-4d1f-afef-\
a44ac83992a7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"16", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFS], StandardForm],
    ImageSizeCache->{352., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 16, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFS]], "/", 16 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046534982861*^9},ExpressionUUID->"cb4e367e-4484-4354-a26c-\
b61cfd72ee21"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Fermion - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465392967157`*^9},ExpressionUUID->"3ba65548-1277-49c8-86a7-\
1f03199dea9f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "51", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"51", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`FFV], StandardForm],
    ImageSizeCache->{350., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 51, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`FFV]], "/", 51 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`FFV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046539606276*^9},ExpressionUUID->"80b66c72-bb48-4327-85bb-\
cbeb7685e893"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Four Vector Boson - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046554641032*^9},ExpressionUUID->"df309dfd-0f51-4abf-a0cb-\
97557bb4ebbc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "36", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"36", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`VVVV], StandardForm],
    ImageSizeCache->{344., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 36, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`VVVV]], "/", 36 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`VVVV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046554733388*^9},ExpressionUUID->"b3905ec3-ecdf-4b6b-8b22-\
22da34488836"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Vector Boson - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465646039133`*^9},ExpressionUUID->"072199af-7fb1-4a18-a659-\
e6742bf57196"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "65", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"65", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGV], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 65, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGV]], "/", 65 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGV]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046564672423*^9},ExpressionUUID->"79c289ce-c7be-4e8a-b2b5-\
c82a6f1ba696"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Ghost - One Scalar - Interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465679619102`*^9},ExpressionUUID->"815e654b-31b0-4e6a-a339-\
4653ba72e110"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     Found \"\>", "\[InvisibleSpace]", "48", 
   "\[InvisibleSpace]", "\<\" potential vertices. Calculating \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressNrGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"48", " ", "\<\". (\"\>"}], "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`progressCurrentGV[SARAH`GGS], StandardForm],
    ImageSizeCache->{351., {3., 14.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["     Found ", 48, " potential vertices. Calculating ", 
   Dynamic[
    SARAH`progressNrGV[SARAH`GGS]], "/", 48 ". (", 
   Dynamic[
    SARAH`progressCurrentGV[SARAH`GGS]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520465680305643`*^9},ExpressionUUID->"a933b98c-f15a-4be9-ae5b-\
c8b0224373db"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"      Two Scalar - One Auxiliary - Interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.75204656947965*^9},ExpressionUUID->"01dbc707-d134-4d6b-81bb-f827a638eaa9"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752046569481804*^9},ExpressionUUID->"f631d61c-9b37-4e50-8e95-\
8f894cb03c91"],

Cell[BoxData["\<\"Simplify Vertices\"\>"], "Print",
 CellChangeTimes->{
  3.752046569482381*^9},ExpressionUUID->"0c9484f3-1d3d-49d6-8d6b-\
9e78a28322c6"],

Cell[BoxData["\<\"Writing vertices to files\"\>"], "Print",
 CellChangeTimes->{
  3.7520465705038767`*^9},ExpressionUUID->"b0706b03-eab4-45c0-805b-\
7608447e9700"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All vertices calculated. (Time needed: \"\>", 
   "\[InvisibleSpace]", "61.91936699999998`", 
   "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "All vertices calculated. (Time needed: ", 61.91936699999998, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046570591135*^9},ExpressionUUID->"47e228c5-f7ac-4c13-8f4b-\
884a6d4a6f64"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The vertices are saved in \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/EWSB/\
Vertices/\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["The vertices are saved in ", 
   StyleForm[
   "/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/EWSB/Vertices/", 
    "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046570592628*^9},ExpressionUUID->"ab0d2193-efcb-40a5-b0dc-\
20ec68cfcd8f"],

Cell[BoxData["\<\"Generate interaction list\"\>"], "Print",
 CellChangeTimes->{
  3.7520465707655067`*^9},ExpressionUUID->"383d86b2-5169-4bd0-9253-\
27e039ef9349"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate 1-loop corrections\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046570952366*^9},ExpressionUUID->"081ee6cc-b352-450f-bbde-\
94101a8aada7"],

Cell[BoxData["\<\"  For rotated fields\"\>"], "Print",
 CellChangeTimes->{
  3.7520465709564953`*^9},ExpressionUUID->"27d83af0-7103-4033-8218-\
cea00f3b184a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... processing: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopNameMM, StandardForm],
    ImageSizeCache->{25., {0., 9.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopNrMM, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  ... processing: ", 
   Dynamic[SARAH`DynamicOneLoopNameMM], "(", 
   Dynamic[SARAH`DynamicOneLoopNrMM], "/", 7, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046570957099*^9},ExpressionUUID->"03f825fd-749d-42bd-b89f-\
c4881bbb1ca2"],

Cell[BoxData["\<\"  For tadpoles\"\>"], "Print",
 CellChangeTimes->{
  3.752046572198205*^9},ExpressionUUID->"9fcffe23-fd4e-4549-8c0d-\
857fe1255c60"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    ... processing: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopTadName, StandardForm],
    ImageSizeCache->{33., {3., 9.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopTadNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopTadNrAll, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["    ... processing: ", 
   Dynamic[SARAH`DynamicOneLoopTadName], "(", 
   Dynamic[SARAH`DynamicOneLoopTadNr], "/", 
   Dynamic[SARAH`DynamicOneLoopTadNrAll], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046572200067*^9},ExpressionUUID->"902b10ba-425f-4748-908b-\
b60475371ba7"],

Cell[BoxData["\<\"  For gauge eigenstates\"\>"], "Print",
 CellChangeTimes->{
  3.752046572270159*^9},ExpressionUUID->"1d2b5e00-15b5-4741-8cb1-\
5b49a50ef797"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"    ... processing: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopNameNM, StandardForm],
    ImageSizeCache->{26., {3., 9.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicOneLoopNrNM, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["    ... processing: ", 
   Dynamic[SARAH`DynamicOneLoopNameNM], "(", 
   Dynamic[SARAH`DynamicOneLoopNrNM], "/", 7, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046572271188*^9},ExpressionUUID->"7d6eb850-8af6-4254-a74b-\
39e1386d825a"],

Cell[BoxData["\<\"   Simplify expression\"\>"], "Print",
 CellChangeTimes->{
  3.75204657282815*^9},ExpressionUUID->"fe77bb4a-0095-45ef-85b7-8d720c993aee"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate non-supersymmetric RGEs\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465728861713`*^9},ExpressionUUID->"8244ab99-be11-43d8-92e5-\
a3858bd6dba8"],

Cell[BoxData["\<\"Initializing Invariants... \"\>"], "Print",
 CellChangeTimes->{
  3.752046572887233*^9},ExpressionUUID->"89ba4ec5-0d74-49be-8a12-\
974cb22a266d"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Fermion bilinear\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046576012786*^9},ExpressionUUID->"c59d8ef7-80f2-499b-ad80-\
ed691dba45af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"                      (Time needed so far: \"\>", 
   "\[InvisibleSpace]", "4.41266499999999`", 
   "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "                      (Time needed so far: ", 4.41266499999999, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520465772952538`*^9},ExpressionUUID->"f660033b-a5ea-4843-aae3-\
a4fed87a2c4f"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Fermion chains\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520465772965612`*^9},ExpressionUUID->"7c6a3953-75df-4e96-89fb-\
b6a8e844dc9c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"                      (Time needed so far: \"\>", 
   "\[InvisibleSpace]", "79.86929199999997`", 
   "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "                      (Time needed so far: ", 79.86929199999997, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046652903861*^9},ExpressionUUID->"e24dc3c9-9756-432e-807f-\
03b566ffb81f"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Scalar bilinear\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046652905128*^9},ExpressionUUID->"fd0e26f0-83d8-4f20-87b1-\
0e42c13152e6"],

Cell[BoxData["\<\"     ... 1-loop\"\>"], "Print",
 CellChangeTimes->{
  3.7520466529057093`*^9},ExpressionUUID->"7e1fee9c-0918-4ddb-b9fe-\
22459f5a271b"],

Cell[BoxData["\<\"     ... 2-loop\"\>"], "Print",
 CellChangeTimes->{
  3.7520466640587053`*^9},ExpressionUUID->"c9b85e11-a604-45bc-9284-\
519d104d2fd7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"                      (Time needed so far: \"\>", 
   "\[InvisibleSpace]", "259.773634`", "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "                      (Time needed so far: ", 259.773634, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046833120946*^9},ExpressionUUID->"8647f0ee-7745-4c41-a8e4-\
a92f34fc40ee"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Scalar quartic\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520468331221848`*^9},ExpressionUUID->"c06b03de-8c60-4cb5-a6a9-\
2aa1ff091b57"],

Cell[BoxData["\<\"     ... 1-loop\"\>"], "Print",
 CellChangeTimes->{
  3.752046833123063*^9},ExpressionUUID->"3958677b-dd3e-416c-90fa-\
dc6755141f01"],

Cell[BoxData["\<\"     ... 2-loop\"\>"], "Print",
 CellChangeTimes->{
  3.752046844219686*^9},ExpressionUUID->"30f7da53-f033-4c52-bb2b-\
8849781d6a19"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"                      (Time needed so far: \"\>", 
   "\[InvisibleSpace]", "334.61830499999996`", 
   "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "                      (Time needed so far: ", 334.61830499999996`, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752046908103135*^9},ExpressionUUID->"f4a3e7ac-8f0b-4ad9-ac91-\
cfff48886741"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Scalar cubic\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752046908104147*^9},ExpressionUUID->"aec1e31d-de3e-4a6f-9d1f-\
d2ec8bb14a06"],

Cell[BoxData["\<\"     ... 1-loop\"\>"], "Print",
 CellChangeTimes->{
  3.752046908104678*^9},ExpressionUUID->"b6f651bd-1edd-4c9a-9faf-\
363f9ff0ef11"],

Cell[BoxData["\<\"     ... 2-loop\"\>"], "Print",
 CellChangeTimes->{
  3.752046908965746*^9},ExpressionUUID->"ace27b33-eb4b-4fac-9e35-\
8b6acb4928e1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"                      (Time needed so far: \"\>", 
   "\[InvisibleSpace]", "456.103104`", "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "                      (Time needed so far: ", 456.103104, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047029810731*^9},ExpressionUUID->"75067a5c-2118-4d3c-80ee-\
aa5fe83d3359"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"All necessary invariants are ready (Time needed: \"\>", 
   "\[InvisibleSpace]", "456.103186`", "\[InvisibleSpace]", "\<\"s)\"\>"}],
  SequenceForm[
  "All necessary invariants are ready (Time needed: ", 456.103186, "s)"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047029812001*^9},ExpressionUUID->"41757570-732c-4727-92c3-\
30a82a98f3ff"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752047029812804*^9},ExpressionUUID->"91c7e97c-9609-4b75-ba17-\
d76f2820d3b6"],

Cell[BoxData["\<\"Calculation of beta functions... \"\>"], "Print",
 CellChangeTimes->{
  3.7520470298134823`*^9},ExpressionUUID->"1fb0632d-9cfe-423e-b55a-\
a0dd4f63b117"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for Gauge Couplings\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047029814365*^9},ExpressionUUID->"be85537e-cc82-4fbf-8c90-\
31af7ee98512"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`GAUGE], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`GAUGE], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`GAUGE]], "/", 3, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`GAUGE]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047029815133*^9},ExpressionUUID->"595ac73d-0bf3-4fd2-8312-\
bf403143cdff"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate anomalous dimensions of scalars\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047030192287*^9},ExpressionUUID->"9eb00784-e149-4e3b-a050-\
e33a71313ae4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`GSIJ], StandardForm],
    ImageSizeCache->{10., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`GSIJ], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`GSIJ]], "/", 4, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`GSIJ]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204703019343*^9},ExpressionUUID->"8724461f-214f-439f-9c91-ea2f9719aaea"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate hat(gamma) for running VEVs\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047031776314*^9},ExpressionUUID->"976c0274-4eab-4d5b-a027-\
6e9d17347099"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`GSijHat], StandardForm],
    ImageSizeCache->{10., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "4", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`GSijHat], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`GSijHat]], "/", 4, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`GSijHat]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047031777657*^9},ExpressionUUID->"69c0bc69-a428-4b87-abd1-\
75ce55a5c9ff"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate anomalous dimensions of fermions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047031949785*^9},ExpressionUUID->"2065e4d7-45b7-455f-8615-\
f8e7b109c16e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`GFIJ], StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "11", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`GFIJ], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`GFIJ]], "/", 11, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`GFIJ]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520470319511547`*^9},ExpressionUUID->"edbb7a3f-5303-4d65-8fc5-\
a7bddc57e15a"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for Yukawa-like interactions\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047041279065*^9},ExpressionUUID->"ed46a4df-7e92-48b2-a375-\
b440f3ce41f2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`YIJK], StandardForm],
    ImageSizeCache->{16., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "13", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`YIJK], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`YIJK]], "/", 13, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`YIJK]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047041280813*^9},ExpressionUUID->"fd894a07-504b-4861-ae8f-\
6b2a10c1000f"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for bilinear Fermion \
interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520470986126213`*^9},ExpressionUUID->"132658c2-054e-432f-8c4f-\
c81b7b1997cb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`MFIJ], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`MFIJ], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`MFIJ]], "/", 3, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`MFIJ]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047098615116*^9},ExpressionUUID->"1191be91-2224-4ebd-adda-\
9e499dab2f0e"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for scalar 4-point interactions\"\>",
    "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047103598242*^9},ExpressionUUID->"00e0f3dc-17ab-4ff8-b855-\
d0ddabbd89fa"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`LIJKL], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`LIJKL], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`LIJKL]], "/", 6, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`LIJKL]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520471036002417`*^9},ExpressionUUID->"20ea2b0a-e3c9-4617-8230-\
b25d31c16034"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for scalar 3-point interactions\"\>",
    "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047663245895*^9},ExpressionUUID->"6e67ead6-49a4-4753-bc22-\
222d0a2d5f32"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`TIJK], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`TIJK], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`TIJK]], "/", 3, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`TIJK]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476632485037`*^9},ExpressionUUID->"104d053d-0e9b-418a-b206-\
1c5a754871c6"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for bilinear scalar \
interactions\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047674493698*^9},ExpressionUUID->"08d2b8bc-0cb4-410d-8cfe-\
6aa67865fc78"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`MSIJ], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`MSIJ], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`MSIJ]], "/", 3, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`MSIJ]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047674494637*^9},ExpressionUUID->"6f14bf96-2c54-4ee1-80c7-\
0dbdc34a4735"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Calculate Beta Functions for VEVs\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047677717339*^9},ExpressionUUID->"bdda9c90-02aa-4dfc-a711-\
7c66e7e2d7b4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"   Calculating \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicProgressRGE[SARAH`VEVI], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "2", "\[InvisibleSpace]", "\<\".(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCoupProgess[SARAH`VEVI], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["   Calculating ", 
   Dynamic[
    SARAH`DynamicProgressRGE[SARAH`VEVI]], "/", 2, ".(", 
   Dynamic[
    SARAH`DynamicCoupProgess[SARAH`VEVI]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047677718281*^9},ExpressionUUID->"c44d7a44-9906-41f7-81df-\
69e2488cc3b3"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7520476810783367`*^9},ExpressionUUID->"e4614894-f955-4b5f-b112-\
440e059b463d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Finished with the calculation of the RGEs. Time needed: \"\>", 
   "\[InvisibleSpace]", "1108.1085380000002`", 
   "\[InvisibleSpace]", "\<\"s\"\>"}],
  SequenceForm[
  "Finished with the calculation of the RGEs. Time needed: ", 
   1108.1085380000002`, "s"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476810792437`*^9},ExpressionUUID->"4c5c11bf-eebf-4d1b-8740-\
ca48df7882f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"The results are saved in \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/RGEs/\"\
\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["The results are saved in ", 
   StyleForm[
   "/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/RGEs/", "Section", 
    FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476810800037`*^9},ExpressionUUID->"b287a9c7-d8bc-41e5-aad1-\
c2d30d321759"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7520476811321917`*^9},ExpressionUUID->"46db3ab3-1fe2-4729-bc8c-\
aa3422d2bc0e"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Preparing SPheno code\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520476811332684`*^9},ExpressionUUID->"b7c640e5-35d2-48e3-be2a-\
cedd71e112bd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Solve tadpole equations for: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"m2", ",", "mSr2"}], "}"}], "\[InvisibleSpace]", "\<\"  (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicStatusSPhenoTad[{Susyno`LieGroups`m2, $CellContext`mSr2}], 
     StandardForm],
    ImageSizeCache->{148., {3., 9.}}], "\[InvisibleSpace]", "\<\") \"\>"}],
  SequenceForm[
  "  Solve tadpole equations for: ", {Susyno`LieGroups`m2, $CellContext`mSr2},
    "  (", 
   Dynamic[
    SARAH`DynamicStatusSPhenoTad[{Susyno`LieGroups`m2, $CellContext`mSr2}]], 
   ") "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476811339703`*^9},ExpressionUUID->"68ce6ce3-b2e0-4502-8921-\
c7e968bc8fca"],

Cell[BoxData["\<\"  Build parameter lists\"\>"], "Print",
 CellChangeTimes->{
  3.752047681387722*^9},ExpressionUUID->"8db388b2-e976-4c85-8069-\
1aca1c267697"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write RGEs\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520476815343657`*^9},ExpressionUUID->"a626035c-935a-488b-98c4-\
340283253275"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing RGEs running up: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRGEup, StandardForm],
    ImageSizeCache->{179., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRGEbeta[SARAH`numberLow], StandardForm],
    ImageSizeCache->{83., {3., 9.}}]}],
  SequenceForm["  Processing RGEs running up: ", 
   Dynamic[SARAH`DynamicRGEup], " ", 
   Dynamic[
    SARAH`DynamicRGEbeta[SARAH`numberLow]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476815353394`*^9},ExpressionUUID->"68ec0926-468c-4a1b-b072-\
1f25e13f5737"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing RGEs running including VEVs: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRGEall, StandardForm],
    ImageSizeCache->{179., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicRGEbeta[SARAH`numberAllwithVEVs], StandardForm],
    ImageSizeCache->{83., {3., 9.}}]}],
  SequenceForm["  Processing RGEs running including VEVs: ", 
   Dynamic[SARAH`DynamicRGEall], " ", 
   Dynamic[
    SARAH`DynamicRGEbeta[SARAH`numberAllwithVEVs]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047682461287*^9},ExpressionUUID->"90629fa7-800d-4966-b793-\
3231af01389e"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write Tree Level-Masses\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520476834747553`*^9},ExpressionUUID->"543ec693-c20a-43d1-a46e-\
9ae9b7df5666"],

Cell[BoxData["\<\"  Getting needed Information\"\>"], "Print",
 CellChangeTimes->{
  3.752047683476652*^9},ExpressionUUID->"4c2972cf-151a-4e7d-944d-\
16ce4771c48f"],

Cell[BoxData["\<\"  Writing header\"\>"], "Print",
 CellChangeTimes->{
  3.752047683533949*^9},ExpressionUUID->"9c02c1b4-a7f8-49af-a2c0-\
fbe22a0f4efc"],

Cell[BoxData["\<\"  Writing routine for calculating all masses\"\>"], "Print",
 CellChangeTimes->{
  3.7520476835349503`*^9},ExpressionUUID->"da95d27a-1953-498d-929c-\
5556bb4c0348"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing all masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassNr, StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing all masses: ", 
   Dynamic[SARAH`DynamicMassNr], "/", 14, "(", 
   Dynamic[SARAH`DynamicMassName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476835356283`*^9},ExpressionUUID->"7f8bfa13-a117-43cb-9804-\
d167caaa45bb"],

Cell[BoxData["\<\"  Writing routine for calculating all masses\"\>"], "Print",
 CellChangeTimes->{
  3.752047683593897*^9},ExpressionUUID->"6a42e1c6-82b4-4a6e-8cc7-\
bbdf2ac35a09"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing all masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassNr, StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing all masses: ", 
   Dynamic[SARAH`DynamicMassNr], "/", 14, "(", 
   Dynamic[SARAH`DynamicMassName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047683594974*^9},ExpressionUUID->"89ea9efb-a248-486f-82f7-\
0252a70ed280"],

Cell[BoxData["\<\"  Writing routine for calculating SM masses\"\>"], "Print",
 CellChangeTimes->{
  3.752047683652796*^9},ExpressionUUID->"d41516f9-52ae-4806-9291-\
94ea05203da7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing SM Masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassSMNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "7", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMassNameSM, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing SM Masses: ", 
   Dynamic[SARAH`DynamicMassSMNr], "/", 7, "(", 
   Dynamic[SARAH`DynamicMassNameSM], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047683710889*^9},ExpressionUUID->"e7463cf7-b6aa-4834-839f-\
56d446917433"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write Couplings\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047683713243*^9},ExpressionUUID->"e2a54e10-80ec-4ac3-b2b6-\
ae08231cdb59"],

Cell[BoxData["\<\"Writing Module Header\"\>"], "Print",
 CellChangeTimes->{
  3.752047683714149*^9},ExpressionUUID->"a60e01f1-c422-437e-b4a8-\
1c7476c6dc6f"],

Cell[BoxData["\<\"Creating couplings for tree-level calculations\"\>"], \
"Print",
 CellChangeTimes->{
  3.7520476837148857`*^9},ExpressionUUID->"e40ca3ea-2ed5-4cb1-8cce-\
c6b5ba46b156"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for all calculations: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsTreeAll, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["AllCouplingsReallyAll"], StandardForm],
    ImageSizeCache->{72., {3., 9.}}]}],
  SequenceForm["  Processing couplings for all calculations: ", 
   Dynamic[SARAH`DynamicCouplingsTreeAll], " ", 
   Dynamic[
    SARAH`DynamicCouplings["AllCouplingsReallyAll"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476837156076`*^9},ExpressionUUID->"07c93bc9-befc-4b69-b0d9-\
7202172b0178"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for tree-level calculations: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsTree, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["AllCouplings"], StandardForm],
    ImageSizeCache->{60., {3., 9.}}]}],
  SequenceForm["  Processing couplings for tree-level calculations: ", 
   Dynamic[SARAH`DynamicCouplingsTree], " ", 
   Dynamic[
    SARAH`DynamicCouplings["AllCouplings"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204768429428*^9},ExpressionUUID->"5f500c02-1c42-4a94-88f6-a1250976ee63"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["T"], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "106", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["T"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["T"]], "/", 106, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["T"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047684893263*^9},ExpressionUUID->"2f77256e-79ca-4bbb-ab16-\
f484d4a96539"],

Cell[BoxData["\<\"Creating couplings for 2-loop effective Potential\"\>"], \
"Print",
 CellChangeTimes->{
  3.752047685601475*^9},ExpressionUUID->"083f91f4-35fa-480f-a797-\
e8d9e18e3528"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for 2-loop effective potential: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsEffpot, StandardForm],
    ImageSizeCache->{133., {3., 9.}}]}],
  SequenceForm["  Processing couplings for 2-loop effective potential: ", 
   Dynamic[SARAH`DynamicCouplingsEffpot]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047685603897*^9},ExpressionUUID->"ab512de2-6bcc-42dd-8017-\
b739470c375f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["2L"], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["2L"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["2L"]], "/", 6, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["2L"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047685895944*^9},ExpressionUUID->"09ddd3e4-b6d7-4e74-8646-\
fb22871ffec7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["2L"], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "23", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["2L"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["2L"]], "/", 23, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["2L"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204768597154*^9},ExpressionUUID->"ca4950cb-c348-4ae8-8f27-72e646e015bf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Creating couplings for 2-loop pole mass: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplings2LPole, StandardForm],
    ImageSizeCache->{134., {3., 9.}}]}],
  SequenceForm["Creating couplings for 2-loop pole mass: ", 
   Dynamic[SARAH`DynamicCouplings2LPole]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047686262478*^9},ExpressionUUID->"6ad5f41f-d737-4332-8edd-\
c6fc7072d37d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["2LP"], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "23", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["2LP"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["2LP"]], "/", 23, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["2LP"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047686390717*^9},ExpressionUUID->"30dc3b12-3f02-4aa6-b1f3-\
4fa5f483092c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Building Coupling List 4pt pole: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`fourptcouplingstatus, StandardForm],
    ImageSizeCache->{414., {3., 9.}}]}],
  SequenceForm["Building Coupling List 4pt pole: ", 
   Dynamic[SARAH`fourptcouplingstatus]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476867120047`*^9},ExpressionUUID->"4d4f4f5f-aa26-4d5b-96fd-\
5aa2f9514892"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["2LP"], StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["2LP"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["2LP"]], "/", 6, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["2LP"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047686795919*^9},ExpressionUUID->"ad9db1e9-b0ae-4394-9568-\
94438598dc37"],

Cell[BoxData["\<\"Creating couplings for loop calculations\"\>"], "Print",
 CellChangeTimes->{
  3.752047686876555*^9},ExpressionUUID->"cd8fdc34-c27b-4c3d-8a17-\
a59a64dafdbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for loop calculations: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsLoop, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["CouplingsForLoopMasses"], StandardForm],
    ImageSizeCache->{72., {3., 9.}}]}],
  SequenceForm["  Processing couplings for loop calculations: ", 
   Dynamic[SARAH`DynamicCouplingsLoop], " ", 
   Dynamic[
    SARAH`DynamicCouplings["CouplingsForLoopMasses"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047686878849*^9},ExpressionUUID->"adbf6d53-6e1b-457c-8147-\
35777b5fb0d0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["L"], StandardForm],
    ImageSizeCache->{24., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "136", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["L"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["L"]], "/", 136, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["L"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047688109754*^9},ExpressionUUID->"413f907b-19f8-4c44-84bd-\
ab5c69a5bb9b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for W/Z calculations: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsWZ, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["CouplingsForVectorBosons"], StandardForm],
    ImageSizeCache->{58., {3., 9.}}]}],
  SequenceForm["  Processing couplings for W/Z calculations: ", 
   Dynamic[SARAH`DynamicCouplingsWZ], " ", 
   Dynamic[
    SARAH`DynamicCouplings["CouplingsForVectorBosons"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047689268386*^9},ExpressionUUID->"699cd6b6-4fac-4362-baba-\
53bfb25a46c8"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for SM-loop calculations: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsSM, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["CouplingsForSMfermions"], StandardForm],
    ImageSizeCache->{58., {3., 9.}}]}],
  SequenceForm["  Processing couplings for SM-loop calculations: ", 
   Dynamic[SARAH`DynamicCouplingsSM], " ", 
   Dynamic[
    SARAH`DynamicCouplings["CouplingsForSMfermions"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047689572155*^9},ExpressionUUID->"157d9bd9-d20a-4273-9bdc-\
75b63d96c4fe"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Processing couplings for one-loop tadpoles: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicCouplingsTad, StandardForm],
    ImageSizeCache->{140., {3., 9.}}], "\[InvisibleSpace]", "\<\" \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCouplings["CouplingsForTadpoles"], StandardForm],
    ImageSizeCache->{58., {3., 9.}}]}],
  SequenceForm["  Processing couplings for one-loop tadpoles: ", 
   Dynamic[SARAH`DynamicCouplingsTad], " ", 
   Dynamic[
    SARAH`DynamicCouplings["CouplingsForTadpoles"]]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476898789167`*^9},ExpressionUUID->"b0078bb7-d52a-424f-b41b-\
91c16364c570"],

Cell[BoxData["\<\"Creating special quartic functions\"\>"], "Print",
 CellChangeTimes->{
  3.752047690063957*^9},ExpressionUUID->"c62a91a0-df73-48b7-a61b-\
4ff87c9baa59"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr["Q"], StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "27", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName["Q"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr["Q"]], "/", 27, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName["Q"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047690336733*^9},ExpressionUUID->"e29da018-b9f2-4d9a-87aa-\
bc4742524d13"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write routine for loop couplings\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520476905260553`*^9},ExpressionUUID->"41df8f28-dcc7-4b3a-ac26-\
02c4521d2b27"],

Cell[BoxData["\<\"  Writing header\"\>"], "Print",
 CellChangeTimes->{
  3.752047693387266*^9},ExpressionUUID->"884d7d12-fc47-4c04-8b04-\
89c411649deb"],

Cell[BoxData["\<\"  Writing 'AlphaEwDR'\"\>"], "Print",
 CellChangeTimes->{
  3.752047693388679*^9},ExpressionUUID->"a8a5ee05-9c60-4ae5-988e-\
1a97a8857f03"],

Cell[BoxData["\<\"  Writing 'AlphaSdr'\"\>"], "Print",
 CellChangeTimes->{
  3.7520476934473953`*^9},ExpressionUUID->"6a1768de-6285-4ed6-82d0-\
5d796f24a47f"],

Cell[BoxData["\<\"  Writing 'AlphaEW_Treshold'\"\>"], "Print",
 CellChangeTimes->{
  3.752047693448749*^9},ExpressionUUID->"4841b527-07e4-45b5-9e67-\
ef33fab4790f"],

Cell[BoxData["\<\"  Writing 'AlphaS_T'\"\>"], "Print",
 CellChangeTimes->{
  3.752047693449669*^9},ExpressionUUID->"6b08d79a-4f5d-4c59-b74a-\
680fad1b4c38"],

Cell[BoxData["\<\"  Write 'DeltaVB'\"\>"], "Print",
 CellChangeTimes->{
  3.752047693450574*^9},ExpressionUUID->"e1d7eaf9-70c1-4bea-ab94-\
a05f9f84bd45"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  write loop induced couplings of Higgs to vector bosons \
(\"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicHiggsLoopCnr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "8", "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  write loop induced couplings of Higgs to vector bosons (", 
   Dynamic[SARAH`DynamicHiggsLoopCnr], "/", 8, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047693629251*^9},ExpressionUUID->"ec2cd1fa-43ff-4a1c-9836-\
135136c657ac"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Writing SPheno two loop diagrammatic Higgs mass\"\>", 
   "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047693693218*^9},ExpressionUUID->"ba5cfa92-4601-4618-aeea-\
acf9fffd680f"],

Cell[BoxData["\<\"by Mark Goodsell (goodsell@lpthe.jussieu.fr), \
arxiv:1503.03098\"\>"], "Print",
 CellChangeTimes->{
  3.752047693694874*^9},ExpressionUUID->"5111f7a4-124f-433c-8448-\
4dd2ec6adfc9"],

Cell[BoxData["\<\"Generating tadpole diagrams\"\>"], "Print",
 CellChangeTimes->{
  3.752047693755084*^9},ExpressionUUID->"c2551262-f4e3-42c0-a3e0-\
33325b9283fd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   DynamicBox[ToBoxes[SARAH`dynamictwolooptadpoletopology, StandardForm],
    ImageSizeCache->{207., {3., 9.}}], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`dynamictwolooptadpolediagram, StandardForm],
    ImageSizeCache->{234., {3., 9.}}]}],
  SequenceForm[
   Dynamic[SARAH`dynamictwolooptadpoletopology], ": ", 
   Dynamic[SARAH`dynamictwolooptadpolediagram]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047693954369*^9},ExpressionUUID->"fee2d4af-4df7-4538-94be-\
2734a832e3e4"],

Cell[BoxData["\<\"Generating mass diagrams for hh states\"\>"], "Print",
 CellChangeTimes->{
  3.7520476942375813`*^9},ExpressionUUID->"b39dd8a0-250d-4c86-a5b3-\
73eb39604a4d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   DynamicBox[ToBoxes[SARAH`dynamictwolooppoletopology, StandardForm],
    ImageSizeCache->{66., {3., 9.}}], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`dynamictwolooppolediagram, StandardForm],
    ImageSizeCache->{241., {3., 9.}}]}],
  SequenceForm[
   Dynamic[SARAH`dynamictwolooppoletopology], ": ", 
   Dynamic[SARAH`dynamictwolooppolediagram]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520476948561697`*^9},ExpressionUUID->"f55b441f-3d87-4560-b226-\
3182973a7735"],

Cell[BoxData["\<\"Generating mass diagrams for Ah states\"\>"], "Print",
 CellChangeTimes->{
  3.752047695816578*^9},ExpressionUUID->"471da1ef-28f1-4b15-85d2-\
0e3b67d9ac14"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   DynamicBox[ToBoxes[SARAH`dynamictwolooppoleAhtopology, StandardForm],
    ImageSizeCache->{66., {3., 9.}}], "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`dynamictwolooppoleAhdiagram, StandardForm],
    ImageSizeCache->{234., {3., 9.}}]}],
  SequenceForm[
   Dynamic[SARAH`dynamictwolooppoleAhtopology], ": ", 
   Dynamic[SARAH`dynamictwolooppoleAhdiagram]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047696320764*^9},ExpressionUUID->"a21f64a0-0ccc-4366-a9b6-\
3c8b7ae0587f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing 1L Gaugeless tadpoles: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`tot2L1dyn, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], 
   "\[InvisibleSpace]", "\<\" completed \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`tad2L1Ldyn, StandardForm],
    ImageSizeCache->{0., {0., 6.}}]}],
  SequenceForm["Writing 1L Gaugeless tadpoles: ", 
   Dynamic[SARAH`tot2L1dyn], " completed ", 
   Dynamic[SARAH`tad2L1Ldyn]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047697128201*^9},ExpressionUUID->"26073ac7-ff04-4ae3-a45e-\
eeb66875d1df"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Calculating shifts to tadpoles and masses due to \"\>", 
   "\[InvisibleSpace]", "\<\"hh, Ah, Hp\"\>"}],
  SequenceForm[
  "Calculating shifts to tadpoles and masses due to ", "hh, Ah, Hp"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047697186509*^9},ExpressionUUID->"cf732eb9-b039-45f2-b80c-\
4b536ebb11ce"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing Tadpoles: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`tad2Ldyn, StandardForm],
    ImageSizeCache->{242., {3., 9.}}]}],
  SequenceForm["Writing Tadpoles: ", 
   Dynamic[SARAH`tad2Ldyn]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204769718808*^9},ExpressionUUID->"ee47ad89-9740-41ef-aeaa-085c142a7907"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing CP-even masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`hh2Ldyn, StandardForm],
    ImageSizeCache->{258., {3., 9.}}]}],
  SequenceForm["Writing CP-even masses: ", 
   Dynamic[SARAH`hh2Ldyn]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047697642754*^9},ExpressionUUID->"4945f370-3f9c-4746-afa2-\
6ec8fe7c1352"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Writing CP-odd masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`Ah2Ldyn, StandardForm],
    ImageSizeCache->{258., {3., 9.}}]}],
  SequenceForm["Writing CP-odd masses: ", 
   Dynamic[SARAH`Ah2Ldyn]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047699642865*^9},ExpressionUUID->"48c223c4-cdab-4e66-816c-\
42fc9d053b55"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write loop masses\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047701431169*^9},ExpressionUUID->"4c90feef-792d-4e19-9191-\
b4d313c5be4e"],

Cell[BoxData["\<\"  Getting needed information\"\>"], "Print",
 CellChangeTimes->{
  3.752047701432797*^9},ExpressionUUID->"ec922cbe-61f8-44e3-9551-\
73ac3ba2496f"],

Cell[BoxData["\<\"  Writing routine for all loop corrections\"\>"], "Print",
 CellChangeTimes->{
  3.752047701654559*^9},ExpressionUUID->"f7ff9331-c98f-4bac-8018-\
e5d37083107d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing one-loop tadpoles: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTad1LoopNr, StandardForm],
    ImageSizeCache->{8., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "1", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTad1LoopName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing one-loop tadpoles: ", 
   Dynamic[SARAH`DynamicTad1LoopNr], "/", 1, "(", 
   Dynamic[SARAH`DynamicTad1LoopName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204770182506*^9},ExpressionUUID->"46121d5c-427c-4d49-88c1-acc605910b5c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing one-loop masses: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMass1LoopNr, StandardForm],
    ImageSizeCache->{17., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "14", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicMass1LoopName, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing one-loop masses: ", 
   Dynamic[SARAH`DynamicMass1LoopNr], "/", 14, "(", 
   Dynamic[SARAH`DynamicMass1LoopName], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477018827868`*^9},ExpressionUUID->"0c7999aa-3073-4f12-bf88-\
e559b21580f0"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write tree-level decays\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047704662389*^9},ExpressionUUID->"c1207e62-5e19-4881-87c1-\
015c0a24ef93"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing two-body decay: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTBDnr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicTBDpart, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing two-body decay: ", 
   Dynamic[SARAH`DynamicTBDnr], "/", 6, "(", 
   Dynamic[SARAH`DynamicTBDpart], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047704866029*^9},ExpressionUUID->"5f7f4e93-0eff-4d41-bdc1-\
0544f025a1e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing three-body decay: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`Dynamic3BDnr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`Dynamic3BDpart, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing three-body decay: ", 
   Dynamic[SARAH`Dynamic3BDnr], "/", 3, "(", 
   Dynamic[SARAH`Dynamic3BDpart], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047708204197*^9},ExpressionUUID->"bbb65ca6-abe1-4248-8b5c-\
51e4fc5e2571"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Writing Routines for 1-Loop Decays\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047713752213*^9},ExpressionUUID->"6636655b-6b18-47be-b192-\
46a0f1b237b9"],

Cell[BoxData["\<\"   Writing Counter-Terms for Couplings\"\>"], "Print",
 CellChangeTimes->{
  3.752047713810791*^9},ExpressionUUID->"8bd8bf0f-5aab-4fe2-9211-\
9fed60d1c05a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing routine for each coupling: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingNr[""], StandardForm],
    ImageSizeCache->{18., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "54", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     SARAH`DynamicCurrentCouplingName[""], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing routine for each coupling: ", 
   Dynamic[
    SARAH`DynamicCurrentCouplingNr[""]], "/", 54, " (", 
   Dynamic[
    SARAH`DynamicCurrentCouplingName[""]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047714587131*^9},ExpressionUUID->"96a93e21-38a3-45ad-b731-\
1c9a469ab0e9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing loop decays for \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLoopDecayParticle, StandardForm],
    ImageSizeCache->{16., {0., 9.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLoopDecayParticleNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\"): \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLoopDecayNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLoopDecayTotal, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicLoopDecay, StandardForm],
    ImageSizeCache->{63., {3., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing loop decays for ", 
   Dynamic[SARAH`DynamicLoopDecayParticle], "(", 
   Dynamic[SARAH`DynamicLoopDecayParticleNr], "/", 6, "): ", 
   Dynamic[SARAH`DynamicLoopDecayNr], "/", 
   Dynamic[SARAH`DynamicLoopDecayTotal], "(", 
   Dynamic[SARAH`DynamicLoopDecay], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477156760607`*^9},ExpressionUUID->"3a7d2807-353f-421f-8d16-\
36dc1e378b9c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Writing wrapper code for \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicWrapperParticle, StandardForm],
    ImageSizeCache->{16., {0., 9.}}], "\[InvisibleSpace]", "\<\"(\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicWrapperParticleNr, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  Writing wrapper code for ", 
   Dynamic[SARAH`DynamicWrapperParticle], "(", 
   Dynamic[SARAH`DynamicWrapperParticleNr], "/", 6, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477684119873`*^9},ExpressionUUID->"6d7ddbdb-ef6f-4396-a22a-\
7331525cd416"],

Cell[BoxData["\<\"  Writing main function\"\>"], "Print",
 CellChangeTimes->{
  3.75204777374352*^9},ExpressionUUID->"4682432c-e0a6-47fa-b99e-1987a9f5b4eb"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write Branching Ratios\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520477743038607`*^9},ExpressionUUID->"7ac0a414-d5f3-4677-9c1a-\
82a80d0962ef"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write CP even Higgs cross sections\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047774452488*^9},ExpressionUUID->"956c02ea-3c0c-4123-a6c7-\
abf04904f114"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write 'ModelData'\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047774511054*^9},ExpressionUUID->"b7fd6fdb-f331-4ed8-b5bc-\
31b249d283a8"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write 'Boundaries and Running'\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047774807589*^9},ExpressionUUID->"ded4f90e-9c2a-414f-859d-\
751aecffab4a"],

Cell[BoxData["\<\"  Write 'BoundarySUSY'\"\>"], "Print",
 CellChangeTimes->{
  3.752047774809167*^9},ExpressionUUID->"b223ffbd-9464-4d31-975e-\
0db1293521c5"],

Cell[BoxData["\<\"  Write 'BoundaryHS'\"\>"], "Print",
 CellChangeTimes->{
  3.752047774867628*^9},ExpressionUUID->"8dde85a3-8ea3-4979-8630-\
42edf92679a0"],

Cell[BoxData["\<\"  Write 'BoundarySM'\"\>"], "Print",
 CellChangeTimes->{
  3.752047774926195*^9},ExpressionUUID->"6854dacc-3bd9-4eb5-8416-\
94ed588e856b"],

Cell[BoxData["\<\"  Write 'BoundaryBSM'\"\>"], "Print",
 CellChangeTimes->{
  3.752047774984755*^9},ExpressionUUID->"6a45a00a-bca2-4883-824d-\
1113ca80cdee"],

Cell[BoxData["\<\"  Write 'RunRGE'\"\>"], "Print",
 CellChangeTimes->{
  3.752047775128512*^9},ExpressionUUID->"9181466f-b499-4b94-9b70-\
c618b54f573e"],

Cell[BoxData["\<\"  Write 'Match_and_Run'\"\>"], "Print",
 CellChangeTimes->{
  3.752047775130018*^9},ExpressionUUID->"d16cda72-d1c5-4200-ab37-\
7ddb9c56205c"],

Cell[BoxData["\<\"  Write new 'RunRGE'\"\>"], "Print",
 CellChangeTimes->{
  3.7520477752295856`*^9},ExpressionUUID->"1374a39a-8938-40ec-8df6-\
973c53bd92ad"],

Cell[BoxData["\<\"  Write 'FirstGuess'\"\>"], "Print",
 CellChangeTimes->{
  3.752047775287607*^9},ExpressionUUID->"91a849f3-8738-4469-adea-\
c7701c70836a"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write routine for precision observables\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047775346014*^9},ExpressionUUID->"ab50a544-0be5-4d3c-9711-\
73a596682845"],

Cell[BoxData["\<\"(in collaboration with K. Nickel, W. Porod, A. \
Vicente)\"\>"], "Print",
 CellChangeTimes->{
  3.7520477753474007`*^9},ExpressionUUID->"fd896f20-3c0d-4942-b56b-\
2a2f0aed24f3"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Checking for FlavorKit input files\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.7520477754055967`*^9},ExpressionUUID->"d8419b55-2b2c-4000-b3b0-\
d7d2cf79b3ac"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Reference: 'A Flavor Kit for BSM models' by W. Porod, F. \
Staub, A.Vicente; 1405.1434\"\>", "Section",
   FontSize->10],
  StyleForm[#, "Section", FontSize -> 10]& ]], "Print",
 CellChangeTimes->{
  3.7520477754073772`*^9},ExpressionUUID->"255ebdad-2bb0-4ca9-8c56-\
3765b65e85f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Generating code for FlavorKit \"\>", 
   "\[InvisibleSpace]", "\<\"LFV\"\>", 
   "\[InvisibleSpace]", "\<\" observables: \"\>"}],
  SequenceForm["Generating code for FlavorKit ", "LFV", " observables: "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047775408864*^9},ExpressionUUID->"fe7106b0-1aef-451f-b702-\
a1e9af3a4bdb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... processing: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNrPS["LFV"], StandardForm],
    ImageSizeCache->{130., {3., 9.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNamePS["LFV"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], 
   "\[InvisibleSpace]", "\<\" [Diagrams: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNumberDiagram[$CellContext`currentNameOp], 
     StandardForm],
    ImageSizeCache->{283., {3., 9.}}], "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNumberTotalDiagram[$CellContext`currentNameOp], 
     StandardForm],
    ImageSizeCache->{323., {3., 9.}}], "\[InvisibleSpace]", "\<\"])\"\>"}],
  SequenceForm["  ... processing: ", 
   Dynamic[
    $CellContext`DynamicNrPS["LFV"]], "/", 0, " (", 
   Dynamic[
    $CellContext`DynamicNamePS["LFV"]], " [Diagrams: ", 
   Dynamic[
    $CellContext`DynamicNumberDiagram[$CellContext`currentNameOp]], " of ", 
   Dynamic[
    $CellContext`DynamicNumberTotalDiagram[$CellContext`currentNameOp]], "])"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047775410651*^9},ExpressionUUID->"d3936ebc-fa84-439f-8086-\
ea4b0d7564b3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Write Routines to calculate observables: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicObsNr["LFV"], StandardForm],
    ImageSizeCache->{138., {3., 9.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicObsName["LFV"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Write Routines to calculate observables: ", 
   Dynamic[
    $CellContext`DynamicObsNr["LFV"]], "/", 0, " (", 
   Dynamic[
    $CellContext`DynamicObsName["LFV"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477754140987`*^9},ExpressionUUID->"dcf97ee3-0bf3-4ebf-9307-\
cf354ca6e9fc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Generating code for FlavorKit \"\>", 
   "\[InvisibleSpace]", "\<\"QFV\"\>", 
   "\[InvisibleSpace]", "\<\" observables: \"\>"}],
  SequenceForm["Generating code for FlavorKit ", "QFV", " observables: "],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047775416502*^9},ExpressionUUID->"77b19ca5-e490-46f0-9330-\
1a52fdff94dc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  ... processing: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNrPS["QFV"], StandardForm],
    ImageSizeCache->{131., {3., 9.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNamePS["QFV"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], 
   "\[InvisibleSpace]", "\<\" [Diagrams: \"\>", "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNumberDiagram[$CellContext`currentNameOp], 
     StandardForm],
    ImageSizeCache->{283., {3., 9.}}], "\[InvisibleSpace]", "\<\" of \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicNumberTotalDiagram[$CellContext`currentNameOp], 
     StandardForm],
    ImageSizeCache->{323., {3., 9.}}], "\[InvisibleSpace]", "\<\"])\"\>"}],
  SequenceForm["  ... processing: ", 
   Dynamic[
    $CellContext`DynamicNrPS["QFV"]], "/", 0, " (", 
   Dynamic[
    $CellContext`DynamicNamePS["QFV"]], " [Diagrams: ", 
   Dynamic[
    $CellContext`DynamicNumberDiagram[$CellContext`currentNameOp]], " of ", 
   Dynamic[
    $CellContext`DynamicNumberTotalDiagram[$CellContext`currentNameOp]], "])"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047775417757*^9},ExpressionUUID->"746e213f-7e01-4e2a-b9d1-\
7e565a7504e3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Write Routines to calculate observables: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicObsNr["QFV"], StandardForm],
    ImageSizeCache->{139., {3., 9.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "0", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[
     $CellContext`DynamicObsName["QFV"], StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Write Routines to calculate observables: ", 
   Dynamic[
    $CellContext`DynamicObsNr["QFV"]], "/", 0, " (", 
   Dynamic[
    $CellContext`DynamicObsName["QFV"]], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477754201612`*^9},ExpressionUUID->"16286e8b-cee5-4868-9c10-\
6d32fd934c0d"],

Cell[BoxData["\<\"Write Function for g-2\"\>"], "Print",
 CellChangeTimes->{
  3.752047775421829*^9},ExpressionUUID->"1c51ed6e-525d-4969-9135-\
94c628188321"],

Cell[BoxData["\<\"Write Function EDM of Leptons\"\>"], "Print",
 CellChangeTimes->{
  3.752047775540045*^9},ExpressionUUID->"4682d321-44e5-474f-bb48-\
9cd78c725de1"],

Cell[BoxData["\<\"  Write 'CalculateLowEnergy'\"\>"], "Print",
 CellChangeTimes->{
  3.7520477757913723`*^9},ExpressionUUID->"ed1bd3df-010d-4f4f-a27c-\
610bad4e2448"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write I/O routines\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520477762686033`*^9},ExpressionUUID->"88bade46-9bc0-48d6-a70b-\
296f4ca807ed"],

Cell[BoxData["\<\"  Writing input routines\"\>"], "Print",
 CellChangeTimes->{
  3.7520477763261414`*^9},ExpressionUUID->"e3ad604f-11bb-49a9-bb49-\
d19dd3e2cc40"],

Cell[BoxData["\<\"  Writing output routines\"\>"], "Print",
 CellChangeTimes->{
  3.7520477763271027`*^9},ExpressionUUID->"77b5c08e-6d59-45df-8a36-\
5840046027f1"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write routine for tadpole equations\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047777311193*^9},ExpressionUUID->"5fb3553a-cd47-4c04-8631-\
0f04f23ad042"],

Cell[BoxData["\<\"  Writing solver for tadpole equations \"\>"], "Print",
 CellChangeTimes->{
  3.7520477773125887`*^9},ExpressionUUID->"e5f15f75-af55-47b5-9971-\
ffe4cdabe789"],

Cell[BoxData["\<\"  Writing tadpole equations \"\>"], "Print",
 CellChangeTimes->{
  3.752047777370804*^9},ExpressionUUID->"f4453f09-066c-47b1-a7d1-\
82befd05a644"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write SPheno main file\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.7520477773720922`*^9},ExpressionUUID->"07a942f1-2673-4336-a1b3-\
3c72f780b423"],

Cell[BoxData["\<\"  Write 'CalculateSpectrum'\"\>"], "Print",
 CellChangeTimes->{
  3.752047777428794*^9},ExpressionUUID->"60c62edd-0023-4f19-896b-\
3ceea827fac1"],

Cell[BoxData["\<\"  Write 'ReadingData'\"\>"], "Print",
 CellChangeTimes->{
  3.752047777486038*^9},ExpressionUUID->"3ae8794c-96bf-4e40-916c-\
d662f149b337"],

Cell[BoxData["\<\"  Write 'ScaleUncertainty'\"\>"], "Print",
 CellChangeTimes->{
  3.7520477774872723`*^9},ExpressionUUID->"671ad612-b154-4cea-8f62-\
131b2e5a3090"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write SM RGEs\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047777589522*^9},ExpressionUUID->"b3ea18a0-f66e-4ecd-8941-\
3590c637928b"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write routine for running couplings in decays\"\>", "Section",
   
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047777652554*^9},ExpressionUUID->"4ac1ada5-ad9f-425b-9baf-\
8e1632ef6bcf"],

Cell[BoxData["\<\"  Writing module header\"\>"], "Print",
 CellChangeTimes->{
  3.75204777765397*^9},ExpressionUUID->"b6fe3817-9c8a-4987-b887-c6317a5dd2b6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing running couplings for 2-body decays: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRunCoupD2B, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "6", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRunCoupNameD2B, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing running couplings for 2-body decays: ", 
   Dynamic[SARAH`DynamicRunCoupD2B], "/", 6, " (", 
   Dynamic[SARAH`DynamicRunCoupNameD2B], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047777654738*^9},ExpressionUUID->"291d0c23-674e-4efd-85b6-\
cc43c3b7cfd7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  writing running couplings for 3-body decays: \"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRunCoupD3B, StandardForm],
    ImageSizeCache->{9., {0., 8.}}], "\[InvisibleSpace]", "\<\"/\"\>", 
   "\[InvisibleSpace]", "3", "\[InvisibleSpace]", "\<\" (\"\>", 
   "\[InvisibleSpace]", 
   DynamicBox[ToBoxes[SARAH`DynamicRunCoupNameD3B, StandardForm],
    ImageSizeCache->{67., {0., 9.}}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["  writing running couplings for 3-body decays: ", 
   Dynamic[SARAH`DynamicRunCoupD3B], "/", 3, " (", 
   Dynamic[SARAH`DynamicRunCoupNameD3B], ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477790993757`*^9},ExpressionUUID->"592475c1-6636-49f8-951d-\
f0f9be5b966c"],

Cell[BoxData[
 TagBox[
  StyleBox["\<\"Write templates for input files\"\>", "Section",
   FontSize->12],
  StyleForm[#, "Section", FontSize -> 12]& ]], "Print",
 CellChangeTimes->{
  3.752047779901155*^9},ExpressionUUID->"51879a8a-70c9-475a-bd71-\
03346e28acc8"],

Cell[BoxData["\<\"  Writing LesHouches input file\"\>"], "Print",
 CellChangeTimes->{
  3.752047779903316*^9},ExpressionUUID->"7fc82b18-c1c6-4dbf-b0bb-\
6ff59c9dabfa"],

Cell[BoxData["\<\"  Writing SSP templates\"\>"], "Print",
 CellChangeTimes->{
  3.752047779960588*^9},ExpressionUUID->"25b5144c-f3ff-4f0b-bd13-\
941d0952a67f"],

Cell[BoxData["\<\"  Writing Makefile\"\>"], "Print",
 CellChangeTimes->{
  3.752047779966722*^9},ExpressionUUID->"5dbb345a-5386-44de-a51f-\
6b6ce3926bac"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.752047779967602*^9},ExpressionUUID->"f58b58a9-1135-475b-9b6d-\
691751754e20"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Finished! SPheno code generated in \"\>", "\[InvisibleSpace]", 
   "1271.264131`", "\[InvisibleSpace]", "\<\"s\"\>"}],
  SequenceForm["Finished! SPheno code generated in ", 1271.264131, "s"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7520477799681807`*^9},ExpressionUUID->"b2663b2c-33ab-4812-8f00-\
747d41fd9b4b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Output saved in \"\>", "\[InvisibleSpace]", 
   TagBox[
    StyleBox["\<\"/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/EWSB/\
SPheno/\"\>", "Section",
     FontSize->10],
    StyleForm[#, "Section", FontSize -> 10]& ]}],
  SequenceForm["Output saved in ", 
   StyleForm[
   "/home/martin/FeynTools/sarah4/Output/SplitSUSY-NMSSM/EWSB/SPheno/", 
    "Section", FontSize -> 10]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047779968933*^9},ExpressionUUID->"83fef00d-8bbc-4135-b66a-\
b5fbfa6013f7"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.75204777996966*^9},ExpressionUUID->"d1452405-024e-42d0-b489-903c4cd64eda"],

Cell[BoxData["\<\"The following steps are now necessary to implement the \
model in SPheno: \"\>"], "Print",
 CellChangeTimes->{
  3.7520477799702597`*^9},ExpressionUUID->"db10d226-63bd-425b-9418-\
3b7de89cc2b7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  1. Copy the created files to a new subdirectory \\\"/\"\>", 
   "\[InvisibleSpace]", "\<\"SimpleSplitNMSSM\"\>", 
   "\[InvisibleSpace]", "\<\"\\\" of your SPheno 3.3.8 (or later) \
installation\"\>"}],
  SequenceForm[
  "  1. Copy the created files to a new subdirectory \"/", "SimpleSplitNMSSM",
    "\" of your SPheno 3.3.8 (or later) installation"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.75204777997095*^9},ExpressionUUID->"0e9dfd19-67ad-4673-aa1a-553e36c5120a"],

Cell[BoxData["\<\"  2. Compile the model by using \"\>"], "Print",
 CellChangeTimes->{
  3.752047779971732*^9},ExpressionUUID->"7c44ee55-0206-4fd1-a672-\
bd8e992713a6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"        make Model=\"\>", 
   "\[InvisibleSpace]", "\<\"SimpleSplitNMSSM\"\>"}],
  SequenceForm["        make Model=", "SimpleSplitNMSSM"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.752047779972426*^9},ExpressionUUID->"c8f01958-1697-4faf-89ca-\
01492a9719f7"],

Cell[BoxData["\<\"     in the main directory of SPheno\"\>"], "Print",
 CellChangeTimes->{
  3.752047779973098*^9},ExpressionUUID->"5e9f64d1-e3fa-40cb-b04b-\
6fc3dd4c8f6d"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{960, 533},
WindowMargins->{{0, Automatic}, {Automatic, 15}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info133752048344-6846142"->{
  Cell[60839, 1664, 192, 4, 
  44, "Print", "ExpressionUUID" -> "bc583f9d-d7dc-44df-8566-1466db81a86e",
   CellTags->"Info133752048344-6846142"],
  Cell[61034, 1670, 3013, 102, 
  434, "Print", "ExpressionUUID" -> "15cc254d-feb2-4f78-b718-20f4987f078a",
   CellTags->"Info133752048344-6846142"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info133752048344-6846142", 227898, 6293}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 180, 3, 67, "Section", "ExpressionUUID" -> \
"8e253acc-b2e1-4487-8f3f-39240e608766"],
Cell[CellGroupData[{
Cell[785, 29, 164, 3, 46, "Subsection", "ExpressionUUID" -> \
"8033087c-0dd7-450f-8f98-0ea56236d76f"],
Cell[CellGroupData[{
Cell[974, 36, 165, 3, 37, "Subsubsection", "ExpressionUUID" -> \
"4d1bb4e3-8777-4655-b01c-8ae5d285a8a8"],
Cell[CellGroupData[{
Cell[1164, 43, 226, 5, 33, "Input", "ExpressionUUID" -> \
"8c37efd2-dd51-4c4a-807d-d14c687de43d"],
Cell[CellGroupData[{
Cell[1415, 52, 584, 17, 27, "Print", "ExpressionUUID" -> \
"e88c70fa-07b1-4d68-b1d1-35a04a529988"],
Cell[2002, 71, 158, 3, 25, "Print", "ExpressionUUID" -> \
"b737dca7-4974-4785-8c76-8e9e837c8c45"],
Cell[2163, 76, 270, 8, 26, "Print", "ExpressionUUID" -> \
"4cf98d7f-61d5-4837-bc10-74cef0ea3358"],
Cell[2436, 86, 136, 3, 25, "Print", "ExpressionUUID" -> \
"1fc082a8-63a0-4ca3-acab-e0e902cd2b37"],
Cell[2575, 91, 243, 7, 27, "Print", "ExpressionUUID" -> \
"0d7aa8b5-5d18-48e4-8108-0b9585ba542b"],
Cell[2821, 100, 206, 4, 25, "Print", "ExpressionUUID" -> \
"ebee0be5-0019-45bf-8fb9-000440e64a9e"],
Cell[3030, 106, 206, 4, 25, "Print", "ExpressionUUID" -> \
"d2849734-93f2-45be-8ef3-97754b5f705b"],
Cell[3239, 112, 206, 4, 25, "Print", "ExpressionUUID" -> \
"8cb02d3a-7e0c-4cfa-8eef-8f2ad4371395"],
Cell[3448, 118, 206, 4, 25, "Print", "ExpressionUUID" -> \
"7934db82-e554-40a5-897f-45178f530bc6"],
Cell[3657, 124, 259, 7, 27, "Print", "ExpressionUUID" -> \
"7d90e073-b151-48a0-97a7-fe9912cb83b8"],
Cell[3919, 133, 163, 3, 25, "Print", "ExpressionUUID" -> \
"35d31cec-1bcb-4a2a-a548-77a2473401f5"],
Cell[4085, 138, 136, 3, 25, "Print", "ExpressionUUID" -> \
"0e8e5c70-b557-46a1-9d31-6073ed0ee12e"],
Cell[4224, 143, 171, 3, 25, "Print", "ExpressionUUID" -> \
"56136fb8-ead9-4251-a430-c39dab1e33c5"],
Cell[4398, 148, 263, 7, 26, "Print", "ExpressionUUID" -> \
"812eed21-6d0d-49ec-9bea-10bcd2ebb964"],
Cell[4664, 157, 198, 4, 25, "Print", "ExpressionUUID" -> \
"73fe4867-4278-4b27-acf9-b67956e09ac3"],
Cell[4865, 163, 508, 13, 25, "Print", "ExpressionUUID" -> \
"437799f5-2c4a-4d93-94ff-ac48aefcce7b"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[5422, 182, 198, 4, 27, "Input", "ExpressionUUID" -> \
"6a093b6b-a23b-4a28-8309-198468b48d2a"],
Cell[CellGroupData[{
Cell[5645, 190, 152, 3, 25, "Print", "ExpressionUUID" -> \
"8a0ca265-7df2-4b75-b267-f1fbeb2f1797"],
Cell[5800, 195, 377, 9, 25, "Print", "ExpressionUUID" -> \
"11b8ccb1-0769-4d1e-99b6-61acd8ef955d"],
Cell[6180, 206, 253, 7, 26, "Print", "ExpressionUUID" -> \
"00385777-2edd-4031-977c-c25312d74e31"],
Cell[6436, 215, 428, 12, 25, "Print", "ExpressionUUID" -> \
"639d4748-67cf-4117-9a25-f71475568553"],
Cell[6867, 229, 432, 12, 25, "Print", "ExpressionUUID" -> \
"b0c7be51-6a50-4036-a3d3-8e96b92e53f0"],
Cell[7302, 243, 440, 12, 25, "Print", "ExpressionUUID" -> \
"e60590af-1857-40da-a2c3-9343e9469837"],
Cell[7745, 257, 194, 4, 25, "Print", "ExpressionUUID" -> \
"7c7f52d3-9153-4139-b6e6-008599c8426b"],
Cell[7942, 263, 551, 14, 25, "Print", "ExpressionUUID" -> \
"f38859e6-c1e2-4050-ac73-877dbbee7c67"],
Cell[8496, 279, 189, 4, 25, "Print", "ExpressionUUID" -> \
"76b9afde-3487-4a83-967e-9e20551803c8"],
Cell[8688, 285, 496, 13, 25, "Print", "ExpressionUUID" -> \
"d7678b77-31ea-433c-8b6b-abb177d1ff56"],
Cell[9187, 300, 194, 4, 25, "Print", "ExpressionUUID" -> \
"b381fb3e-b5b0-4fba-b317-6783085a5955"],
Cell[9384, 306, 246, 7, 26, "Print", "ExpressionUUID" -> \
"5d7bb62d-56e8-4ec9-a9f1-7f7967c4d30b"],
Cell[9633, 315, 424, 10, 25, "Print", "ExpressionUUID" -> \
"76e75b12-e174-482b-bbc4-2a437e812f3a"],
Cell[10060, 327, 419, 10, 25, "Print", "ExpressionUUID" -> \
"ec292356-2e79-4778-97c5-6275b2581bfa"],
Cell[10482, 339, 407, 10, 25, "Print", "ExpressionUUID" -> \
"20d217fd-b99c-4ed7-bf14-a02e3fd7a802"],
Cell[10892, 351, 443, 11, 25, "Print", "ExpressionUUID" -> \
"49bd7c04-17d2-4c7c-9988-d58db5e34c1b"],
Cell[11338, 364, 429, 10, 25, "Print", "ExpressionUUID" -> \
"8045716e-aebd-4d7d-be9b-4b52b16361a0"],
Cell[11770, 376, 249, 7, 26, "Print", "ExpressionUUID" -> \
"79f65334-0972-42d1-9f3b-dd6bbbf00d40"],
Cell[12022, 385, 772, 15, 25, "Print", "ExpressionUUID" -> \
"4481724e-2978-4dbf-bcbb-2b9d7fa2e359"],
Cell[12797, 402, 440, 10, 25, "Print", "ExpressionUUID" -> \
"ce73ce6f-cdd4-4850-8660-e0ab7d2a4d9f"],
Cell[13240, 414, 717, 15, 25, "Print", "ExpressionUUID" -> \
"3a1a21f0-d0b8-457c-87fc-358c1495cf8a"],
Cell[13960, 431, 749, 15, 25, "Print", "ExpressionUUID" -> \
"dbe4157b-562c-43e9-8b36-ce2374040da9"],
Cell[14712, 448, 443, 10, 25, "Print", "ExpressionUUID" -> \
"4a64ff0f-05fa-422e-93ce-4884fe6a94d1"],
Cell[15158, 460, 159, 3, 25, "Print", "ExpressionUUID" -> \
"23f705fc-c600-4bf6-9b48-07938908d9a6"],
Cell[15320, 465, 748, 15, 25, "Print", "ExpressionUUID" -> \
"6d328ade-35b1-414c-af7a-692dbd38093a"],
Cell[16071, 482, 752, 15, 25, "Print", "ExpressionUUID" -> \
"75d8f56e-80f5-4b90-8ffe-306391281e59"],
Cell[16826, 499, 718, 14, 25, "Print", "ExpressionUUID" -> \
"614a8419-2ca0-42bd-a412-044473b21427"],
Cell[17547, 515, 771, 15, 25, "Print", "ExpressionUUID" -> \
"b9305e7c-60c5-408c-9a2e-1f95fb7b5a41"],
Cell[18321, 532, 786, 16, 25, "Print", "ExpressionUUID" -> \
"e2bf3201-8dcd-4d33-83e9-4742a6b2485f"],
Cell[19110, 550, 754, 15, 25, "Print", "ExpressionUUID" -> \
"598f629c-c6e8-4128-8b75-9a4fea98b75e"],
Cell[19867, 567, 751, 15, 25, "Print", "ExpressionUUID" -> \
"6287d874-eacf-4df9-ab5c-88cc4045fbdb"],
Cell[20621, 584, 152, 3, 25, "Print", "ExpressionUUID" -> \
"cabdf239-6d69-41dc-9b97-ee06c1570aba"],
Cell[20776, 589, 160, 3, 25, "Print", "ExpressionUUID" -> \
"c09b4604-0ac2-4ce5-82ce-1eeaa4c79b05"],
Cell[20939, 594, 138, 3, 25, "Print", "ExpressionUUID" -> \
"0b059dfb-90cb-4cf8-8080-37e31e6992a8"],
Cell[21080, 599, 256, 7, 26, "Print", "ExpressionUUID" -> \
"f5119373-a6a6-43ec-bd91-84a9f4f45f10"],
Cell[21339, 608, 498, 13, 25, "Print", "ExpressionUUID" -> \
"eca3b719-b40f-4e39-b596-95f3dfce0a2a"],
Cell[21840, 623, 156, 3, 25, "Print", "ExpressionUUID" -> \
"9c6c2111-7a0b-4dce-8eca-d624947e9cbb"],
Cell[21999, 628, 822, 20, 25, "Print", "ExpressionUUID" -> \
"011c3776-33a3-460a-8366-2eab578b08f9"],
Cell[22824, 650, 172, 3, 25, "Print", "ExpressionUUID" -> \
"ca04c8aa-5547-4532-8875-6f3bd3f1478e"],
Cell[22999, 655, 167, 3, 25, "Print", "ExpressionUUID" -> \
"edc147ac-ea67-4a46-8c74-c45d9541e07c"],
Cell[23169, 660, 481, 12, 25, "Print", "ExpressionUUID" -> \
"f69238ce-8afa-47a5-bb99-cf1da12f3280"],
Cell[23653, 674, 136, 3, 25, "Print", "ExpressionUUID" -> \
"4f428931-cb33-4b9f-a5ee-cddc37f360ce"],
Cell[23792, 679, 253, 7, 26, "Print", "ExpressionUUID" -> \
"44229511-88c4-49a7-a1a7-a12f93286a3e"],
Cell[24048, 688, 162, 3, 25, "Print", "ExpressionUUID" -> \
"61c36186-44aa-4277-9881-49ea2cc396f8"],
Cell[24213, 693, 851, 23, 25, "Print", "ExpressionUUID" -> \
"297d8340-291d-4c42-a2e0-6cdb6d21ba4d"],
Cell[25067, 718, 820, 19, 25, "Print", "ExpressionUUID" -> \
"3b938e47-7bb4-4705-8fc2-3e289847b106"],
Cell[25890, 739, 862, 22, 25, "Print", "ExpressionUUID" -> \
"a11b46cf-bf2b-402d-bab0-50cc7cfafea8"],
Cell[26755, 763, 146, 3, 25, "Print", "ExpressionUUID" -> \
"39acb61b-0286-49f6-8d7c-f3cc6f3b63c0"],
Cell[26904, 768, 869, 23, 25, "Print", "ExpressionUUID" -> \
"8912e2f7-9f25-497b-8f78-06574c927d6e"],
Cell[27776, 793, 498, 13, 25, "Print", "ExpressionUUID" -> \
"65794a18-d6ad-4999-81b9-4373cc7ec858"],
Cell[28277, 808, 156, 3, 25, "Print", "ExpressionUUID" -> \
"d3987093-54a8-4907-81f7-8d6cb07d30f6"],
Cell[28436, 813, 809, 20, 25, "Print", "ExpressionUUID" -> \
"6257078c-d45f-4ec4-aa2b-23d8de994dae"],
Cell[29248, 835, 170, 3, 25, "Print", "ExpressionUUID" -> \
"5576fcbe-2b4d-4a98-83ff-1f7c856e7ac8"],
Cell[29421, 840, 165, 3, 25, "Print", "ExpressionUUID" -> \
"0cdc93a4-46cb-4391-9823-1d967f77b8d3"],
Cell[29589, 845, 6423, 111, 25, "Print", "ExpressionUUID" -> \
"5d122492-b6f6-417e-8cee-3aba092a28ea"],
Cell[36015, 958, 869, 23, 25, "Print", "ExpressionUUID" -> \
"977f0aa3-6333-4f35-a9b9-74e16b5fd3d7"],
Cell[36887, 983, 158, 2, 25, "Print", "ExpressionUUID" -> \
"f1036903-416d-46cf-8d77-955a3dabd1de"],
Cell[37048, 987, 475, 12, 25, "Print", "ExpressionUUID" -> \
"66e97881-8afa-4608-b698-37bfb723b962"],
Cell[37526, 1001, 136, 3, 25, "Print", "ExpressionUUID" -> \
"f26acb52-4810-4152-9a15-d4a4feb82c9d"],
Cell[37665, 1006, 241, 7, 26, "Print", "ExpressionUUID" -> \
"7ca1e9cd-20cd-4eef-a995-5c79d4254279"],
Cell[37909, 1015, 164, 3, 25, "Print", "ExpressionUUID" -> \
"f6e88f89-4353-4723-b7b0-0433f19bbce7"],
Cell[38076, 1020, 149, 3, 25, "Print", "ExpressionUUID" -> \
"254c23ff-a25f-4e40-8809-ca54b4518137"],
Cell[38228, 1025, 162, 3, 25, "Print", "ExpressionUUID" -> \
"09c19c4a-cf09-4844-b4fd-f7c8d451eca1"],
Cell[38393, 1030, 174, 3, 25, "Print", "ExpressionUUID" -> \
"6acf6131-18ea-4975-a953-08d91cdd02ea"],
Cell[38570, 1035, 498, 11, 25, "Print", "ExpressionUUID" -> \
"6f7e038f-e8ba-4daa-a4e6-9489b42cc705"],
Cell[39071, 1048, 165, 3, 25, "Print", "ExpressionUUID" -> \
"b4f06fe2-81fb-4d0d-bee5-8f5203402fc0"],
Cell[39239, 1053, 173, 3, 25, "Print", "ExpressionUUID" -> \
"238444a1-849c-4d33-96e8-b337a5493205"],
Cell[39415, 1058, 458, 11, 25, "Print", "ExpressionUUID" -> \
"c041c4b6-a854-4bf6-b837-4f23de1ce6a3"],
Cell[39876, 1071, 187, 4, 25, "Print", "ExpressionUUID" -> \
"7be6c510-ef17-46fe-8958-777490bca00d"],
Cell[40066, 1077, 170, 3, 25, "Print", "ExpressionUUID" -> \
"4ef6967f-f1e5-4b4c-b876-8d41cabb0a50"],
Cell[40239, 1082, 169, 2, 25, "Print", "ExpressionUUID" -> \
"046f5ffc-09ca-4f8e-a5d5-5dc00a1a33df"],
Cell[40411, 1086, 136, 3, 25, "Print", "ExpressionUUID" -> \
"c62b78e6-65c9-48d9-bc58-40cb18a7672b"],
Cell[40550, 1091, 337, 8, 25, "Print", "ExpressionUUID" -> \
"86d9671d-e733-4396-b6d0-4d1ed2ecc70f"],
Cell[40890, 1101, 344, 8, 25, "Print", "ExpressionUUID" -> \
"118ba7ed-4fdf-44c6-9c70-e3ee0c8d28ef"],
Cell[41237, 1111, 138, 3, 25, "Print", "ExpressionUUID" -> \
"05121063-589f-47c0-b4fb-a437d53f90af"],
Cell[41378, 1116, 136, 3, 25, "Print", "ExpressionUUID" -> \
"c3be22e1-ed07-4810-9cd5-cabfc2fb67ab"],
Cell[41517, 1121, 498, 13, 25, "Print", "ExpressionUUID" -> \
"701d6fc2-4db0-4b3d-9cfe-a7f3aa7a4f9c"]
}, Open  ]]
}, Closed]],
Cell[42042, 1138, 534, 12, 52, "Input", "ExpressionUUID" -> \
"cb15113d-0ac6-46f1-b4ae-582b2b171875"],
Cell[CellGroupData[{
Cell[42601, 1154, 779, 16, 81, "Input", "ExpressionUUID" -> \
"4b2dc146-5f6d-4aac-b138-f20677f6b3ae"],
Cell[CellGroupData[{
Cell[43405, 1174, 257, 6, 26, "Print", "ExpressionUUID" -> \
"2b423b86-56f2-4f26-b101-4f60b2efc738"],
Cell[43665, 1182, 176, 3, 25, "Print", "ExpressionUUID" -> \
"86d350de-2de3-4747-8111-41d66776534b"],
Cell[43844, 1187, 156, 3, 25, "Print", "ExpressionUUID" -> \
"8bb480d0-8931-4f73-aae1-cd1a264e474d"],
Cell[44003, 1192, 158, 3, 25, "Print", "ExpressionUUID" -> \
"02f5caf4-1959-42c1-8d54-4cd216508ebb"],
Cell[44164, 1197, 254, 7, 26, "Print", "ExpressionUUID" -> \
"9f4ad561-dd04-4faf-acb6-02995ed1e8cb"],
Cell[44421, 1206, 265, 7, 26, "Print", "ExpressionUUID" -> \
"8e810de3-2081-4433-ac79-9d3ccc1bacc8"],
Cell[44689, 1215, 906, 21, 25, "Print", "ExpressionUUID" -> \
"79a84881-5e1c-48e7-a039-f3018c5c587b"],
Cell[45598, 1238, 264, 7, 26, "Print", "ExpressionUUID" -> \
"5c6bcc50-1fd1-47db-aff5-e70d642487a5"],
Cell[45865, 1247, 908, 21, 25, "Print", "ExpressionUUID" -> \
"d7c052dc-02e3-4e36-8f90-1a285dee09c9"],
Cell[46776, 1270, 286, 8, 26, "Print", "ExpressionUUID" -> \
"95ac231f-47b9-426e-83cc-0b1ad84b371b"],
Cell[47065, 1280, 904, 21, 25, "Print", "ExpressionUUID" -> \
"44d5fbf8-7d73-44ee-b5b1-a6beb9c00bde"],
Cell[47972, 1303, 286, 8, 26, "Print", "ExpressionUUID" -> \
"71d57adb-deb8-4092-8d50-7c23a2bc116a"],
Cell[48261, 1313, 904, 21, 25, "Print", "ExpressionUUID" -> \
"e6c18be6-11ca-43c5-9850-21e16103d2a4"],
Cell[49168, 1336, 288, 8, 26, "Print", "ExpressionUUID" -> \
"517d2ff9-a856-4b41-9b09-ef5c67ee6cc3"],
Cell[49459, 1346, 912, 21, 25, "Print", "ExpressionUUID" -> \
"dcb7d7f4-1476-471d-a1fe-482da9f63108"],
Cell[50374, 1369, 271, 7, 26, "Print", "ExpressionUUID" -> \
"9f1e92c8-f001-470f-a6ac-1d43e453c08e"],
Cell[50648, 1378, 904, 21, 25, "Print", "ExpressionUUID" -> \
"7e223910-bdf7-476f-ba49-b9029fbaed72"],
Cell[51555, 1401, 281, 8, 26, "Print", "ExpressionUUID" -> \
"3b4626fd-6c7e-4e4b-8487-69818d6cd89f"],
Cell[51839, 1411, 904, 21, 25, "Print", "ExpressionUUID" -> \
"a506cebc-6a2e-4fef-af6b-bf4cfb0b957e"],
Cell[52746, 1434, 287, 8, 26, "Print", "ExpressionUUID" -> \
"e3518c2b-1fd5-46fc-8ca4-4dd77cdeb6ca"],
Cell[53036, 1444, 904, 21, 25, "Print", "ExpressionUUID" -> \
"9df77601-6f91-4d01-b81d-b4f8b35b88a0"],
Cell[53943, 1467, 272, 7, 26, "Print", "ExpressionUUID" -> \
"93e1291d-456e-4de0-beae-01aa643af788"],
Cell[54218, 1476, 908, 21, 25, "Print", "ExpressionUUID" -> \
"b5fb0bc7-a0be-4bc2-b814-2daed353620f"],
Cell[55129, 1499, 285, 8, 26, "Print", "ExpressionUUID" -> \
"3538e639-6082-432c-be56-b4bb9b84b17f"],
Cell[55417, 1509, 904, 21, 25, "Print", "ExpressionUUID" -> \
"424b3775-0ed7-4ef3-b479-e3a3d9a019b4"],
Cell[56324, 1532, 275, 7, 26, "Print", "ExpressionUUID" -> \
"4ead3a13-4cd3-4cb6-ba23-7c15b33b3a28"],
Cell[56602, 1541, 904, 21, 25, "Print", "ExpressionUUID" -> \
"159011f7-e9f7-4998-89f8-3de6c425aed3"],
Cell[57509, 1564, 283, 8, 26, "Print", "ExpressionUUID" -> \
"529ac02a-986c-44cf-9667-f2e368725262"],
Cell[57795, 1574, 910, 21, 25, "Print", "ExpressionUUID" -> \
"6918cf14-0390-4a70-87b0-4f9580351dde"],
Cell[58708, 1597, 136, 3, 25, "Print", "ExpressionUUID" -> \
"20f2531b-4fa7-47ab-a772-18d76f676d4d"],
Cell[58847, 1602, 150, 2, 25, "Print", "ExpressionUUID" -> \
"ccb58b68-c15b-40ea-a7df-bface65b00ab"],
Cell[59000, 1606, 158, 2, 25, "Print", "ExpressionUUID" -> \
"4b7f5071-863f-4370-9b67-da83300ee11d"],
Cell[59161, 1610, 380, 8, 25, "Print", "ExpressionUUID" -> \
"3de7a6b2-de11-4214-ba31-1cf57e26b90c"],
Cell[59544, 1620, 571, 15, 25, "Print", "ExpressionUUID" -> \
"f5012871-11da-4a71-97dc-133dcd5f22bf"],
Cell[60118, 1637, 192, 4, 25, "Print", "ExpressionUUID" -> \
"ad5f2c07-f43c-45f9-add1-71dc02e561b8"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[60371, 1648, 197, 3, 37, "Subsubsection", "ExpressionUUID" -> \
"7c05fa7f-bfe8-4665-9406-fc0f996ee233"],
Cell[CellGroupData[{
Cell[60593, 1655, 221, 5, 33, "Input", "ExpressionUUID" -> \
"4b773128-7f11-49fa-988b-6ae68bd147d8"],
Cell[CellGroupData[{
Cell[60839, 1664, 192, 4, 44, "Print", "ExpressionUUID" -> \
"bc583f9d-d7dc-44df-8566-1466db81a86e",
 CellTags->"Info133752048344-6846142"],
Cell[61034, 1670, 3013, 102, 434, "Print", "ExpressionUUID" -> \
"15cc254d-feb2-4f78-b718-20f4987f078a",
 CellTags->"Info133752048344-6846142"]
}, Open  ]]
}, Open  ]],
Cell[64074, 1776, 529, 13, 35, "Input", "ExpressionUUID" -> \
"905724b6-55b0-420f-a8ef-4b499f55a13d"],
Cell[CellGroupData[{
Cell[64628, 1793, 635, 17, 59, "Input", "ExpressionUUID" -> \
"8606040a-ad75-4ac4-b958-59599506457a"],
Cell[65266, 1812, 250, 6, 33, "Output", "ExpressionUUID" -> \
"5bde8b6c-c071-4c15-b818-02e567178308"],
Cell[65519, 1820, 969, 30, 62, "Output", "ExpressionUUID" -> \
"3b88804d-5352-4b85-a83e-1e50d72b7265"]
}, Open  ]],
Cell[66503, 1853, 501, 12, 33, "Input", "ExpressionUUID" -> \
"334122b1-54b5-43b3-a3ea-6c68f886289a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67041, 1870, 317, 6, 37, "Subsubsection", "ExpressionUUID" -> \
"af2ed19f-80f3-4c7f-b8a3-874236a55488"],
Cell[CellGroupData[{
Cell[67383, 1880, 778, 20, 59, "Input", "ExpressionUUID" -> \
"d0f0aea6-731a-4859-b086-52b947d54b2e"],
Cell[68164, 1902, 371, 10, 57, "Output", "ExpressionUUID" -> \
"e47e5d30-0b6c-498e-9719-f5c76e7caf26"],
Cell[68538, 1914, 5027, 141, 333, "Output", "ExpressionUUID" -> \
"2f98bbce-dc63-4736-aada-e3322850ec74"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[73626, 2062, 158, 3, 46, "Subsection", "ExpressionUUID" -> \
"95b9b768-0e5b-4c4b-a3dd-91d9a2c27cb7"],
Cell[73787, 2067, 782, 17, 58, "Input", "ExpressionUUID" -> \
"da330e5d-1830-436b-8363-7e69740df309"],
Cell[CellGroupData[{
Cell[74594, 2088, 281, 6, 35, "Input", "ExpressionUUID" -> \
"3817fcc3-1726-442f-800f-11534fe6d023"],
Cell[CellGroupData[{
Cell[74900, 2098, 260, 7, 26, "Print", "ExpressionUUID" -> \
"284b355a-555b-45e9-893f-b97c44b8cc57"],
Cell[75163, 2107, 171, 2, 25, "Print", "ExpressionUUID" -> \
"2cd5e1e0-32a1-4abf-ae50-268fad0c171b"],
Cell[75337, 2111, 156, 3, 25, "Print", "ExpressionUUID" -> \
"68cc65cc-3f61-47f9-89cd-2d52e3846339"],
Cell[75496, 2116, 160, 3, 25, "Print", "ExpressionUUID" -> \
"bd52fb8b-fe22-46b6-a1fa-0c7ebd3ed379"],
Cell[75659, 2121, 254, 7, 26, "Print", "ExpressionUUID" -> \
"d90d8329-5297-4d93-b32d-9277e72e321d"],
Cell[75916, 2130, 265, 7, 26, "Print", "ExpressionUUID" -> \
"9ebd3ad0-ba0d-47e0-aa22-8c218954b7b3"],
Cell[76184, 2139, 904, 21, 25, "Print", "ExpressionUUID" -> \
"b8f3027e-81ce-40c9-9191-09857133d1c4"],
Cell[77091, 2162, 264, 7, 26, "Print", "ExpressionUUID" -> \
"11186366-4fdb-4b6f-a636-f25245eaef15"],
Cell[77358, 2171, 908, 21, 25, "Print", "ExpressionUUID" -> \
"dc268dd3-0bd8-4b33-81db-b6811b049715"],
Cell[78269, 2194, 286, 8, 26, "Print", "ExpressionUUID" -> \
"520e9bfd-bc4e-4301-ac4a-f360da10747a"],
Cell[78558, 2204, 904, 21, 25, "Print", "ExpressionUUID" -> \
"472d5857-091e-433e-87f8-f2a3e2d2c45a"],
Cell[79465, 2227, 286, 8, 26, "Print", "ExpressionUUID" -> \
"8cd41b99-8271-4220-8a51-5f1b214f82d8"],
Cell[79754, 2237, 904, 21, 25, "Print", "ExpressionUUID" -> \
"9ce53143-da4b-4724-abcc-d8d0bac57b6d"],
Cell[80661, 2260, 286, 8, 26, "Print", "ExpressionUUID" -> \
"4e9a3b8a-ebad-4168-9191-7eb15516e5cf"],
Cell[80950, 2270, 912, 21, 25, "Print", "ExpressionUUID" -> \
"0fc9f2da-7302-4942-9bc6-4e43b750f7ac"],
Cell[81865, 2293, 273, 7, 26, "Print", "ExpressionUUID" -> \
"b653a66c-7b62-4134-bd20-dbcdc23ec800"],
Cell[82141, 2302, 906, 21, 25, "Print", "ExpressionUUID" -> \
"2d360e50-37c9-47ea-ba2c-0d018d5bd545"],
Cell[83050, 2325, 281, 8, 26, "Print", "ExpressionUUID" -> \
"714c89a6-5961-4018-8a34-527a2b7451ab"],
Cell[83334, 2335, 906, 21, 25, "Print", "ExpressionUUID" -> \
"5632605f-b2d6-4a3f-99ed-c1fa54e95070"],
Cell[84243, 2358, 287, 8, 26, "Print", "ExpressionUUID" -> \
"94dd113c-c680-4d10-bf6e-27debbaeb32b"],
Cell[84533, 2368, 904, 21, 25, "Print", "ExpressionUUID" -> \
"8c3ca25a-f80d-4b41-9c66-88228d56221d"],
Cell[85440, 2391, 272, 7, 26, "Print", "ExpressionUUID" -> \
"86c03657-2b43-4820-9aff-e9d31eee3e23"],
Cell[85715, 2400, 908, 21, 25, "Print", "ExpressionUUID" -> \
"3a4adb53-bb41-4eda-9034-2d8486654739"],
Cell[86626, 2423, 285, 8, 26, "Print", "ExpressionUUID" -> \
"6048f6c5-11d9-48d2-8aef-144b5e38cb20"],
Cell[86914, 2433, 904, 21, 25, "Print", "ExpressionUUID" -> \
"4c00e978-d97d-4906-aac6-7bf9412804fe"],
Cell[87821, 2456, 275, 7, 26, "Print", "ExpressionUUID" -> \
"b4063669-04b2-4b00-bc5d-fc77c5d5e193"],
Cell[88099, 2465, 904, 21, 25, "Print", "ExpressionUUID" -> \
"f35faf2b-a865-484c-8009-bb380599ae33"],
Cell[89006, 2488, 283, 8, 26, "Print", "ExpressionUUID" -> \
"08ea1f6f-87a6-4688-9eb5-34869bebd411"],
Cell[89292, 2498, 908, 21, 25, "Print", "ExpressionUUID" -> \
"8e7e176b-4738-4722-a31b-fecb90a9bb5b"],
Cell[90203, 2521, 138, 3, 25, "Print", "ExpressionUUID" -> \
"0f5add1a-d14c-4703-ab77-6459589db643"],
Cell[90344, 2526, 153, 3, 25, "Print", "ExpressionUUID" -> \
"378f6485-2b5f-4df7-9b51-2ebc91f3d340"],
Cell[90500, 2531, 161, 3, 25, "Print", "ExpressionUUID" -> \
"469b9d6d-48d0-4fbd-ac0b-1292c91e9886"],
Cell[90664, 2536, 404, 10, 25, "Print", "ExpressionUUID" -> \
"4b5e2f0e-efd4-4a03-88d6-a65315b03aba"],
Cell[91071, 2548, 569, 15, 25, "Print", "ExpressionUUID" -> \
"9dcb6a33-ddf4-4db6-81dd-a58cadf32a02"],
Cell[91643, 2565, 192, 4, 25, "Print", "ExpressionUUID" -> \
"3cac4dfd-b06c-4163-bf1a-0c096263fc94"],
Cell[91838, 2571, 248, 7, 26, "Print", "ExpressionUUID" -> \
"1845c007-ba2a-4348-a0ab-92c6a5f16bc9"],
Cell[92089, 2580, 706, 15, 25, "Print", "ExpressionUUID" -> \
"182bd5fe-f3c6-447c-91c6-aeb02239f4e1"],
Cell[92798, 2597, 706, 15, 25, "Print", "ExpressionUUID" -> \
"3596521e-131c-489c-91a3-e4222f55006c"],
Cell[93507, 2614, 244, 7, 26, "Print", "ExpressionUUID" -> \
"b5644946-3fdf-4fce-812f-ac1f8e13981d"],
Cell[93754, 2623, 158, 3, 25, "Print", "ExpressionUUID" -> \
"756aba7e-7839-4a58-a807-62e24183ad30"],
Cell[93915, 2628, 156, 2, 25, "Print", "ExpressionUUID" -> \
"2d6fcf3d-ae6a-4eff-971a-18fc25af90a6"],
Cell[94074, 2632, 469, 13, 25, "Print", "ExpressionUUID" -> \
"df6e7383-1399-4331-8c5c-7fa9f020546c"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[94604, 2652, 221, 4, 46, "Subsection", "ExpressionUUID" -> \
"a813fb72-3042-4937-aaba-481b4e6c6af8"],
Cell[94828, 2658, 178, 4, 33, "Input", "ExpressionUUID" -> \
"a0ca2c57-a713-4665-ae23-2fc1b024c990"],
Cell[CellGroupData[{
Cell[95031, 2666, 288, 6, 58, "Input", "ExpressionUUID" -> \
"85dc48ab-1283-4f5e-a2a9-eac1988108c0"],
Cell[CellGroupData[{
Cell[95344, 2676, 584, 17, 27, "Print", "ExpressionUUID" -> \
"35d84b5e-6209-4766-9398-4a613032777a"],
Cell[95931, 2695, 158, 3, 25, "Print", "ExpressionUUID" -> \
"b11de04d-4883-4c75-bc6e-f9df35d8c7fa"],
Cell[96092, 2700, 272, 8, 26, "Print", "ExpressionUUID" -> \
"74a595ee-2317-4ad1-bb76-7f04ed5c2bfa"],
Cell[96367, 2710, 136, 3, 25, "Print", "ExpressionUUID" -> \
"88f7e458-c8a4-4bfd-95c1-91c70034d50f"],
Cell[96506, 2715, 243, 7, 27, "Print", "ExpressionUUID" -> \
"32517d07-d933-402e-8b24-bd732cb2143e"],
Cell[96752, 2724, 206, 4, 25, "Print", "ExpressionUUID" -> \
"12a335ad-508c-4c27-a874-ce9a8bfd6f1a"],
Cell[96961, 2730, 206, 4, 25, "Print", "ExpressionUUID" -> \
"3042924d-85c7-4bbb-9a6b-08b616b1e304"],
Cell[97170, 2736, 208, 4, 25, "Print", "ExpressionUUID" -> \
"d6577e6b-9373-4cae-94d1-4afbdc1132ec"],
Cell[97381, 2742, 206, 4, 25, "Print", "ExpressionUUID" -> \
"9d48999e-7584-447a-b59f-9e3fcf1097ab"],
Cell[97590, 2748, 259, 7, 27, "Print", "ExpressionUUID" -> \
"35af3a44-2b8b-4895-87f9-b96853f37ba8"],
Cell[97852, 2757, 163, 3, 25, "Print", "ExpressionUUID" -> \
"d926a47f-0f8b-45d9-a483-35a153e989be"],
Cell[98018, 2762, 136, 3, 25, "Print", "ExpressionUUID" -> \
"ea0bab6b-e565-401a-8e37-62827d584309"],
Cell[98157, 2767, 169, 3, 25, "Print", "ExpressionUUID" -> \
"31a0db5d-3073-4d31-ba92-4722c3a46984"],
Cell[98329, 2772, 265, 7, 26, "Print", "ExpressionUUID" -> \
"31d5178a-ce2f-4f6e-985e-f854001b0d99"],
Cell[98597, 2781, 198, 4, 25, "Print", "ExpressionUUID" -> \
"61ea757a-2497-49d0-84b8-ed805baa7dda"],
Cell[98798, 2787, 508, 13, 25, "Print", "ExpressionUUID" -> \
"01fa3974-ad96-491d-a139-9c701348f98f"],
Cell[99309, 2802, 152, 3, 25, "Print", "ExpressionUUID" -> \
"14df397b-3184-49c4-b57d-8267571e7732"],
Cell[99464, 2807, 379, 9, 25, "Print", "ExpressionUUID" -> \
"1d279d79-e5e6-4919-b43b-c6d52f764d70"],
Cell[99846, 2818, 253, 7, 26, "Print", "ExpressionUUID" -> \
"f717791f-9bb2-419b-be2d-59e01a859565"],
Cell[100102, 2827, 435, 11, 25, "Print", "ExpressionUUID" -> \
"b1d7d2cc-4469-471e-9cca-fe4e2b4bc0f1"],
Cell[100540, 2840, 460, 12, 25, "Print", "ExpressionUUID" -> \
"c673efdc-2f8f-46fc-a9cc-31bc6dbbd42d"],
Cell[101003, 2854, 435, 11, 25, "Print", "ExpressionUUID" -> \
"b6e4480b-d845-48e8-b4fe-9885617c7347"],
Cell[101441, 2867, 194, 4, 25, "Print", "ExpressionUUID" -> \
"626165a5-85b1-4bbd-a53b-4549ab319e67"],
Cell[101638, 2873, 549, 14, 25, "Print", "ExpressionUUID" -> \
"13afa37b-2b09-4c8b-815f-1db8949bdd7a"],
Cell[102190, 2889, 191, 4, 25, "Print", "ExpressionUUID" -> \
"8e8798e0-3370-4fe1-bcba-6a50a5973b8b"],
Cell[102384, 2895, 496, 13, 25, "Print", "ExpressionUUID" -> \
"b3ea8d5c-8fb1-422a-bd26-7df8f6028fbe"],
Cell[102883, 2910, 196, 4, 25, "Print", "ExpressionUUID" -> \
"e34f3e16-0d27-4ba7-acde-71da4fbb7c7e"],
Cell[103082, 2916, 246, 7, 26, "Print", "ExpressionUUID" -> \
"f67a0d3c-7526-45fa-a5e3-664d668a34d7"],
Cell[103331, 2925, 426, 10, 25, "Print", "ExpressionUUID" -> \
"43987770-5874-4b62-9a68-d50b6581106b"],
Cell[103760, 2937, 419, 10, 25, "Print", "ExpressionUUID" -> \
"0fd86f07-aad4-4124-9836-07038a384202"],
Cell[104182, 2949, 405, 10, 25, "Print", "ExpressionUUID" -> \
"87e20d30-8d65-4434-bbfe-f77b32ade198"],
Cell[104590, 2961, 440, 10, 25, "Print", "ExpressionUUID" -> \
"5b5a6b08-1fec-44e1-8fea-28d533af61ac"],
Cell[105033, 2973, 429, 10, 25, "Print", "ExpressionUUID" -> \
"bf9f4f19-f3ce-444d-8497-72d303bfbc8d"],
Cell[105465, 2985, 249, 7, 26, "Print", "ExpressionUUID" -> \
"dfd76ff0-2ee7-4a48-bc5b-6332c8bc9acd"],
Cell[105717, 2994, 159, 3, 25, "Print", "ExpressionUUID" -> \
"cbcb38d2-93b5-4608-82a9-e1656673b6c8"],
Cell[105879, 2999, 748, 15, 25, "Print", "ExpressionUUID" -> \
"20bf5dff-d5fe-464e-abf6-8a2f44f7a187"],
Cell[106630, 3016, 757, 15, 25, "Print", "ExpressionUUID" -> \
"4f185746-cefa-418e-877c-5fcbc3d4ea9c"],
Cell[107390, 3033, 752, 15, 25, "Print", "ExpressionUUID" -> \
"9d11bc0c-3454-48f1-a1b2-cb6f7327deaa"],
Cell[108145, 3050, 749, 15, 25, "Print", "ExpressionUUID" -> \
"e443e645-510d-4a6b-8044-ee8bf0f2dc71"],
Cell[108897, 3067, 150, 3, 25, "Print", "ExpressionUUID" -> \
"3072755a-cf8f-4b7a-a330-0d6ca7791252"],
Cell[109050, 3072, 160, 3, 25, "Print", "ExpressionUUID" -> \
"8cd66c73-c6a5-4734-ae48-4a82206581e3"],
Cell[109213, 3077, 136, 3, 25, "Print", "ExpressionUUID" -> \
"642ecaaf-0e82-44ac-ae9f-e7c13195a0ec"],
Cell[109352, 3082, 251, 6, 26, "Print", "ExpressionUUID" -> \
"7a80e224-49fa-478b-a6bd-d755c3af8203"],
Cell[109606, 3090, 168, 3, 25, "Print", "ExpressionUUID" -> \
"c28fa9ef-2006-4523-80c3-2dc84103825a"],
Cell[109777, 3095, 6167, 131, 84, "Print", "ExpressionUUID" -> \
"e4e6b5ae-7940-4c33-b1c5-dc5d09b16aba"],
Cell[115947, 3228, 6608, 144, 92, "Print", "ExpressionUUID" -> \
"d5185993-d1bd-43c0-bbfb-86b9404b444e"],
Cell[122558, 3374, 496, 13, 25, "Print", "ExpressionUUID" -> \
"9c8dc8b9-a271-4407-a71b-4f3a82604433"],
Cell[123057, 3389, 156, 3, 25, "Print", "ExpressionUUID" -> \
"98074ca6-44b9-48c5-8b44-803912bf2f5f"],
Cell[123216, 3394, 822, 20, 25, "Print", "ExpressionUUID" -> \
"7cb6ca9c-a8d1-440c-aa63-3e5f0ffa1235"],
Cell[124041, 3416, 172, 3, 25, "Print", "ExpressionUUID" -> \
"0d4af0f8-6e42-4ed7-976b-4e4e9bd51486"],
Cell[124216, 3421, 167, 3, 25, "Print", "ExpressionUUID" -> \
"b2e06f57-e4a4-495c-ba75-eddeddc31b29"],
Cell[124386, 3426, 481, 12, 25, "Print", "ExpressionUUID" -> \
"bca38708-f615-4277-8a78-2aca72382ba8"],
Cell[124870, 3440, 136, 3, 25, "Print", "ExpressionUUID" -> \
"e84240be-c768-4f17-ad2e-2f33e8b8fb86"],
Cell[125009, 3445, 251, 7, 26, "Print", "ExpressionUUID" -> \
"b2607755-2e8e-41e1-9d6b-1a818ad8e539"],
Cell[125263, 3454, 162, 3, 25, "Print", "ExpressionUUID" -> \
"6380148d-6d05-44e6-8539-10712eecf221"],
Cell[125428, 3459, 849, 23, 25, "Print", "ExpressionUUID" -> \
"cedb53b9-8bae-475d-b627-07bc455a6077"],
Cell[126280, 3484, 818, 19, 25, "Print", "ExpressionUUID" -> \
"63c6550d-b64e-40c6-89ad-9f2d8df1a5f3"],
Cell[127101, 3505, 867, 23, 25, "Print", "ExpressionUUID" -> \
"8063cd49-fee4-44da-85e2-3e2bb7b03e8c"],
Cell[127971, 3530, 146, 3, 25, "Print", "ExpressionUUID" -> \
"c3a8a0fd-a79b-41f0-a7ca-03f172f8c5f5"],
Cell[128120, 3535, 869, 23, 25, "Print", "ExpressionUUID" -> \
"0d957782-3181-49aa-ac38-4894a40471d2"],
Cell[128992, 3560, 498, 13, 25, "Print", "ExpressionUUID" -> \
"81820431-17a4-4dee-a426-dd483f52f9ec"],
Cell[129493, 3575, 156, 3, 25, "Print", "ExpressionUUID" -> \
"4060bbc7-fda8-48e7-9f3a-9bf1fa65b192"],
Cell[129652, 3580, 811, 20, 25, "Print", "ExpressionUUID" -> \
"a39fd052-b807-4488-8553-b53d40754d1d"],
Cell[130466, 3602, 172, 3, 25, "Print", "ExpressionUUID" -> \
"444c1dbc-82f3-43b7-9a89-736b2b0f9e70"],
Cell[130641, 3607, 165, 3, 25, "Print", "ExpressionUUID" -> \
"39501baa-d903-4b52-9a6f-52e63b15ae65"],
Cell[130809, 3612, 3402, 59, 25, "Print", "ExpressionUUID" -> \
"6b288e11-1880-46f7-9a07-6d97a10dd4f0"],
Cell[134214, 3673, 866, 22, 25, "Print", "ExpressionUUID" -> \
"cfce0bc4-853d-4635-b355-5bbe5a1fcf41"],
Cell[135083, 3697, 163, 3, 25, "Print", "ExpressionUUID" -> \
"def650f3-c8b1-4de9-8165-cdd4c2b7e6e0"],
Cell[135249, 3702, 477, 12, 25, "Print", "ExpressionUUID" -> \
"a676351b-1e41-44b6-83df-2b651c30a5c9"],
Cell[135729, 3716, 136, 3, 25, "Print", "ExpressionUUID" -> \
"0ee2c2dd-3042-4d88-a3b5-44ea56633fb3"],
Cell[135868, 3721, 241, 7, 26, "Print", "ExpressionUUID" -> \
"9e77d06f-2647-44b5-b9ea-7e7c200be170"],
Cell[136112, 3730, 162, 3, 25, "Print", "ExpressionUUID" -> \
"88664ed8-2e33-40f6-a7d7-257e5e68cbdf"],
Cell[136277, 3735, 147, 3, 25, "Print", "ExpressionUUID" -> \
"863d89fc-4db9-4cde-aa38-4e96acee303f"],
Cell[136427, 3740, 164, 3, 25, "Print", "ExpressionUUID" -> \
"882647cb-4ed0-40b4-ae1a-f15f8897a48a"],
Cell[136594, 3745, 174, 3, 25, "Print", "ExpressionUUID" -> \
"197d152e-d375-4224-b190-a4cfdf119364"],
Cell[136771, 3750, 496, 11, 25, "Print", "ExpressionUUID" -> \
"6c812504-10a4-4e4f-8bf8-ab165ea7e682"],
Cell[137270, 3763, 162, 2, 25, "Print", "ExpressionUUID" -> \
"6cb3e7d1-fb32-465f-9bc0-73c4a079903a"],
Cell[137435, 3767, 175, 3, 25, "Print", "ExpressionUUID" -> \
"8a0fb273-6b39-4b6d-a39a-5941fd847ac1"],
Cell[137613, 3772, 458, 11, 25, "Print", "ExpressionUUID" -> \
"dfdbcb9e-3a4c-4f5a-8de1-1583d03a6067"],
Cell[138074, 3785, 185, 4, 25, "Print", "ExpressionUUID" -> \
"2061fd49-c274-4199-9a37-5cc35c01a908"],
Cell[138262, 3791, 168, 3, 25, "Print", "ExpressionUUID" -> \
"4ba6a039-e534-4e98-91e3-34eb42b175af"],
Cell[138433, 3796, 172, 3, 25, "Print", "ExpressionUUID" -> \
"a6e2b546-1b37-4409-95cf-ca1bb4ecdbfb"],
Cell[138608, 3801, 136, 3, 25, "Print", "ExpressionUUID" -> \
"311fbb7a-c5d9-4eaf-829f-c16c5290625d"],
Cell[138747, 3806, 342, 7, 25, "Print", "ExpressionUUID" -> \
"a0809791-c34b-41dd-b904-03fbf1e8d3da"],
Cell[139092, 3815, 362, 8, 25, "Print", "ExpressionUUID" -> \
"52382fc9-a438-429c-8b7e-5a446e159eed"],
Cell[139457, 3825, 136, 3, 25, "Print", "ExpressionUUID" -> \
"eb37cfb4-1b2f-404f-a86a-46c7591d484b"],
Cell[139596, 3830, 136, 3, 25, "Print", "ExpressionUUID" -> \
"e0184929-979d-4af9-9570-742b09aa31e5"],
Cell[139735, 3835, 498, 13, 25, "Print", "ExpressionUUID" -> \
"99d40189-8083-4e94-9504-d707c2da12dc"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[140282, 3854, 348, 9, 29, "Input", "ExpressionUUID" -> \
"603ca995-fd45-4e74-9990-4b6bd5897704"],
Cell[CellGroupData[{
Cell[140655, 3867, 226, 6, 44, "Print", "ExpressionUUID" -> \
"617b8a2b-848a-4831-8acc-fe4f0d8b7b7d"],
Cell[140884, 3875, 265, 7, 27, "Print", "ExpressionUUID" -> \
"62fdcec2-114c-4e73-8618-0e27f99d6cfc"],
Cell[141152, 3884, 174, 3, 25, "Print", "ExpressionUUID" -> \
"6d01f63e-ec99-49e3-b3cd-3f8c7751e5c1"],
Cell[141329, 3889, 156, 3, 25, "Print", "ExpressionUUID" -> \
"c1bd9798-8a90-480a-9f97-f8554b72622a"],
Cell[141488, 3894, 158, 3, 25, "Print", "ExpressionUUID" -> \
"d06514d0-7d1e-4009-b961-01bad91049fd"],
Cell[141649, 3899, 254, 7, 26, "Print", "ExpressionUUID" -> \
"f92315d9-7249-475e-9978-055503c80092"],
Cell[141906, 3908, 265, 7, 26, "Print", "ExpressionUUID" -> \
"da3cd9b0-de80-4831-ac03-b3d815643dd8"],
Cell[142174, 3917, 901, 21, 25, "Print", "ExpressionUUID" -> \
"333a758c-d8e5-4d6d-a388-fc32ac6874c6"],
Cell[143078, 3940, 264, 7, 26, "Print", "ExpressionUUID" -> \
"4c46e125-56aa-49c4-b94b-0e1062561af3"],
Cell[143345, 3949, 903, 21, 25, "Print", "ExpressionUUID" -> \
"dc15a044-740e-49ef-84e2-8cd328ee6b93"],
Cell[144251, 3972, 288, 8, 26, "Print", "ExpressionUUID" -> \
"56331768-80f9-4db4-a396-26e0ff4d10eb"],
Cell[144542, 3982, 904, 21, 25, "Print", "ExpressionUUID" -> \
"d4bfc014-8b5c-46e4-9cc1-209e91991da0"],
Cell[145449, 4005, 286, 8, 26, "Print", "ExpressionUUID" -> \
"11190609-5d20-4d4b-b533-a0dae8b6e50a"],
Cell[145738, 4015, 904, 21, 25, "Print", "ExpressionUUID" -> \
"86b3bc34-f220-49a2-8adf-a0d9e20c8078"],
Cell[146645, 4038, 286, 8, 26, "Print", "ExpressionUUID" -> \
"50b55c51-6afd-44ac-a7a2-1a4a43314a5d"],
Cell[146934, 4048, 908, 21, 25, "Print", "ExpressionUUID" -> \
"8bbc65b2-456d-45e3-bfaf-c12ca42d8c89"],
Cell[147845, 4071, 271, 7, 26, "Print", "ExpressionUUID" -> \
"ebc1a9c7-6e57-4c6b-9a04-4a9cc12f4d5f"],
Cell[148119, 4080, 901, 20, 25, "Print", "ExpressionUUID" -> \
"0980d597-bfc7-4c41-aa29-b4325e11a901"],
Cell[149023, 4102, 281, 8, 26, "Print", "ExpressionUUID" -> \
"4eac567a-1fa6-4d1f-afef-a44ac83992a7"],
Cell[149307, 4112, 904, 21, 25, "Print", "ExpressionUUID" -> \
"cb4e367e-4484-4354-a26c-b61cfd72ee21"],
Cell[150214, 4135, 289, 8, 26, "Print", "ExpressionUUID" -> \
"3ba65548-1277-49c8-86a7-1f03199dea9f"],
Cell[150506, 4145, 904, 21, 25, "Print", "ExpressionUUID" -> \
"80b66c72-bb48-4327-85bb-cbeb7685e893"],
Cell[151413, 4168, 270, 7, 26, "Print", "ExpressionUUID" -> \
"df309dfd-0f51-4abf-a0cb-97557bb4ebbc"],
Cell[151686, 4177, 908, 21, 25, "Print", "ExpressionUUID" -> \
"b3905ec3-ecdf-4b6b-8b22-22da34488836"],
Cell[152597, 4200, 287, 8, 26, "Print", "ExpressionUUID" -> \
"072199af-7fb1-4a18-a659-e6742bf57196"],
Cell[152887, 4210, 904, 21, 25, "Print", "ExpressionUUID" -> \
"79c289ce-c7be-4e8a-b2b5-c82a6f1ba696"],
Cell[153794, 4233, 277, 7, 26, "Print", "ExpressionUUID" -> \
"815e654b-31b0-4e6a-a339-4653ba72e110"],
Cell[154074, 4242, 906, 21, 25, "Print", "ExpressionUUID" -> \
"a933b98c-f15a-4be9-ae5b-c8b0224373db"],
Cell[154983, 4265, 280, 7, 26, "Print", "ExpressionUUID" -> \
"01dbc707-d134-4d6b-81bb-f827a638eaa9"],
Cell[155266, 4274, 136, 3, 25, "Print", "ExpressionUUID" -> \
"f631d61c-9b37-4e50-8e95-8f894cb03c91"],
Cell[155405, 4279, 153, 3, 25, "Print", "ExpressionUUID" -> \
"0c9484f3-1d3d-49d6-8d6b-9e78a28322c6"],
Cell[155561, 4284, 163, 3, 25, "Print", "ExpressionUUID" -> \
"b0706b03-eab4-45c0-805b-7608447e9700"],
Cell[155727, 4289, 401, 10, 25, "Print", "ExpressionUUID" -> \
"47e228c5-f7ac-4c13-8f4b-884a6d4a6f64"],
Cell[156131, 4301, 589, 15, 25, "Print", "ExpressionUUID" -> \
"ab0d2193-efcb-40a5-b0dc-20ec68cfcd8f"],
Cell[156723, 4318, 163, 3, 25, "Print", "ExpressionUUID" -> \
"383d86b2-5169-4bd0-9253-27e039ef9349"],
Cell[156889, 4323, 260, 7, 26, "Print", "ExpressionUUID" -> \
"081ee6cc-b352-450f-bbde-94101a8aada7"],
Cell[157152, 4332, 158, 3, 25, "Print", "ExpressionUUID" -> \
"27d83af0-7103-4033-8218-cea00f3b184a"],
Cell[157313, 4337, 726, 15, 25, "Print", "ExpressionUUID" -> \
"03f825fd-749d-42bd-b89f-c4881bbb1ca2"],
Cell[158042, 4354, 150, 3, 25, "Print", "ExpressionUUID" -> \
"9fcffe23-fd4e-4549-8c0d-857fe1255c60"],
Cell[158195, 4359, 874, 18, 25, "Print", "ExpressionUUID" -> \
"902b10ba-425f-4748-908b-b60475371ba7"],
Cell[159072, 4379, 159, 3, 25, "Print", "ExpressionUUID" -> \
"1d2b5e00-15b5-4741-8cb1-5b49a50ef797"],
Cell[159234, 4384, 730, 15, 25, "Print", "ExpressionUUID" -> \
"7d6eb850-8af6-4254-a74b-39e1386d825a"],
Cell[159967, 4401, 155, 2, 25, "Print", "ExpressionUUID" -> \
"fe77bb4a-0095-45ef-85b7-8d720c993aee"],
Cell[160125, 4405, 267, 7, 26, "Print", "ExpressionUUID" -> \
"8244ab99-be11-43d8-92e5-a3858bd6dba8"],
Cell[160395, 4414, 163, 3, 25, "Print", "ExpressionUUID" -> \
"89ba4ec5-0d74-49be-8a12-974cb22a266d"],
Cell[160561, 4419, 248, 7, 26, "Print", "ExpressionUUID" -> \
"c59d8ef7-80f2-499b-ad80-ed691dba45af"],
Cell[160812, 4428, 409, 10, 25, "Print", "ExpressionUUID" -> \
"f660033b-a5ea-4843-aae3-a4fed87a2c4f"],
Cell[161224, 4440, 248, 7, 26, "Print", "ExpressionUUID" -> \
"7c6a3953-75df-4e96-89fb-b6a8e844dc9c"],
Cell[161475, 4449, 409, 10, 25, "Print", "ExpressionUUID" -> \
"e24dc3c9-9756-432e-807f-03b566ffb81f"],
Cell[161887, 4461, 247, 7, 26, "Print", "ExpressionUUID" -> \
"fd0e26f0-83d8-4f20-87b1-0e42c13152e6"],
Cell[162137, 4470, 153, 3, 25, "Print", "ExpressionUUID" -> \
"7e1fee9c-0918-4ddb-b9fe-22459f5a271b"],
Cell[162293, 4475, 153, 3, 25, "Print", "ExpressionUUID" -> \
"c9b85e11-a604-45bc-9284-519d104d2fd7"],
Cell[162449, 4480, 391, 9, 25, "Print", "ExpressionUUID" -> \
"8647f0ee-7745-4c41-a8e4-a92f34fc40ee"],
Cell[162843, 4491, 248, 7, 26, "Print", "ExpressionUUID" -> \
"c06b03de-8c60-4cb5-a6a9-2aa1ff091b57"],
Cell[163094, 4500, 151, 3, 25, "Print", "ExpressionUUID" -> \
"3958677b-dd3e-416c-90fa-dc6755141f01"],
Cell[163248, 4505, 151, 3, 25, "Print", "ExpressionUUID" -> \
"30f7da53-f033-4c52-bb2b-8849781d6a19"],
Cell[163402, 4510, 412, 10, 25, "Print", "ExpressionUUID" -> \
"f4a3e7ac-8f0b-4ad9-ac91-cfff48886741"],
Cell[163817, 4522, 244, 7, 26, "Print", "ExpressionUUID" -> \
"aec1e31d-de3e-4a6f-9d1f-d2ec8bb14a06"],
Cell[164064, 4531, 151, 3, 25, "Print", "ExpressionUUID" -> \
"b6f651bd-1edd-4c9a-9faf-363f9ff0ef11"],
Cell[164218, 4536, 151, 3, 25, "Print", "ExpressionUUID" -> \
"ace27b33-eb4b-4fac-9e35-8b6acb4928e1"],
Cell[164372, 4541, 391, 9, 25, "Print", "ExpressionUUID" -> \
"75067a5c-2118-4d3c-80ee-aa5fe83d3359"],
Cell[164766, 4552, 403, 9, 25, "Print", "ExpressionUUID" -> \
"41757570-732c-4727-92c3-30a82a98f3ff"],
Cell[165172, 4563, 136, 3, 25, "Print", "ExpressionUUID" -> \
"91c7e97c-9609-4b75-ba17-d76f2820d3b6"],
Cell[165311, 4568, 171, 3, 25, "Print", "ExpressionUUID" -> \
"1fb0632d-9cfe-423e-b55a-a0dd4f63b117"],
Cell[165485, 4573, 276, 7, 26, "Print", "ExpressionUUID" -> \
"be85537e-cc82-4fbf-8c90-31af7ee98512"],
Cell[165764, 4582, 792, 19, 25, "Print", "ExpressionUUID" -> \
"595ac73d-0bf3-4fd2-8312-bf403143cdff"],
Cell[166559, 4603, 273, 7, 26, "Print", "ExpressionUUID" -> \
"9eb00784-e149-4e3b-a050-e33a71313ae4"],
Cell[166835, 4612, 786, 18, 25, "Print", "ExpressionUUID" -> \
"8724461f-214f-439f-9c91-ea2f9719aaea"],
Cell[167624, 4632, 269, 7, 26, "Print", "ExpressionUUID" -> \
"976c0274-4eab-4d5b-a027-6e9d17347099"],
Cell[167896, 4641, 801, 19, 25, "Print", "ExpressionUUID" -> \
"69c0bc69-a428-4b87-abd1-75ce55a5c9ff"],
Cell[168700, 4662, 274, 7, 26, "Print", "ExpressionUUID" -> \
"2065e4d7-45b7-455f-8615-f8e7b109c16e"],
Cell[168977, 4671, 793, 19, 25, "Print", "ExpressionUUID" -> \
"edbb7a3f-5303-4d65-8fc5-a7bddc57e15a"],
Cell[169773, 4692, 289, 8, 26, "Print", "ExpressionUUID" -> \
"ed46a4df-7e92-48b2-a375-b440f3ce41f2"],
Cell[170065, 4702, 791, 19, 25, "Print", "ExpressionUUID" -> \
"fd894a07-504b-4861-ae8f-6b2a10c1000f"],
Cell[170859, 4723, 294, 8, 26, "Print", "ExpressionUUID" -> \
"132658c2-054e-432f-8c4f-c81b7b1997cb"],
Cell[171156, 4733, 788, 19, 25, "Print", "ExpressionUUID" -> \
"1191be91-2224-4ebd-adda-9e499dab2f0e"],
Cell[171947, 4754, 292, 8, 26, "Print", "ExpressionUUID" -> \
"00e0f3dc-17ab-4ff8-b855-d0ddabbd89fa"],
Cell[172242, 4764, 794, 19, 25, "Print", "ExpressionUUID" -> \
"20ea2b0a-e3c9-4617-8230-b25d31c16034"],
Cell[173039, 4785, 292, 8, 26, "Print", "ExpressionUUID" -> \
"6e67ead6-49a4-4753-bc22-222d0a2d5f32"],
Cell[173334, 4795, 790, 19, 25, "Print", "ExpressionUUID" -> \
"104d053d-0e9b-418a-b206-1c5a754871c6"],
Cell[174127, 4816, 291, 8, 26, "Print", "ExpressionUUID" -> \
"08d2b8bc-0cb4-410d-8cfe-6aa67865fc78"],
Cell[174421, 4826, 788, 19, 25, "Print", "ExpressionUUID" -> \
"6f14bf96-2c54-4ee1-80c7-0dbdc34a4735"],
Cell[175212, 4847, 265, 7, 26, "Print", "ExpressionUUID" -> \
"bdda9c90-02aa-4dfc-a711-7c66e7e2d7b4"],
Cell[175480, 4856, 788, 19, 25, "Print", "ExpressionUUID" -> \
"c44d7a44-9906-41f7-81df-69e2488cc3b3"],
Cell[176271, 4877, 138, 3, 25, "Print", "ExpressionUUID" -> \
"e4614894-f955-4b5f-b112-440e059b463d"],
Cell[176412, 4882, 442, 11, 25, "Print", "ExpressionUUID" -> \
"4c5c11bf-eebf-4d1b-8740-ca48df7882f3"],
Cell[176857, 4895, 571, 15, 25, "Print", "ExpressionUUID" -> \
"b287a9c7-d8bc-41e5-aad1-c2d30d321759"],
Cell[177431, 4912, 138, 3, 25, "Print", "ExpressionUUID" -> \
"46db3ab3-1fe2-4729-bc8c-aa3422d2bc0e"],
Cell[177572, 4917, 255, 7, 26, "Print", "ExpressionUUID" -> \
"b7c640e5-35d2-48e3-be2a-cedd71e112bd"],
Cell[177830, 4926, 765, 19, 25, "Print", "ExpressionUUID" -> \
"68ce6ce3-b2e0-4502-8921-c7e968bc8fca"],
Cell[178598, 4947, 159, 3, 25, "Print", "ExpressionUUID" -> \
"8db388b2-e976-4c85-8069-1aca1c267697"],
Cell[178760, 4952, 244, 7, 26, "Print", "ExpressionUUID" -> \
"a626035c-935a-488b-98c4-340283253275"],
Cell[179007, 4961, 664, 16, 25, "Print", "ExpressionUUID" -> \
"68ec0926-468c-4a1b-b072-1f25e13f5737"],
Cell[179674, 4979, 708, 17, 25, "Print", "ExpressionUUID" -> \
"90629fa7-800d-4966-b793-3231af01389e"],
Cell[180385, 4998, 257, 7, 26, "Print", "ExpressionUUID" -> \
"543ec693-c20a-43d1-a46e-9ae9b7df5666"],
Cell[180645, 5007, 164, 3, 25, "Print", "ExpressionUUID" -> \
"4c2972cf-151a-4e7d-944d-16ce4771c48f"],
Cell[180812, 5012, 152, 3, 25, "Print", "ExpressionUUID" -> \
"9c02c1b4-a7f8-49af-a2c0-fbe22a0f4efc"],
Cell[180967, 5017, 182, 3, 25, "Print", "ExpressionUUID" -> \
"da95d27a-1953-498d-929c-5556bb4c0348"],
Cell[181152, 5022, 719, 15, 25, "Print", "ExpressionUUID" -> \
"7f8bfa13-a117-43cb-9804-d167caaa45bb"],
Cell[181874, 5039, 180, 3, 25, "Print", "ExpressionUUID" -> \
"6a42e1c6-82b4-4a6e-8cc7-bbdf2ac35a09"],
Cell[182057, 5044, 717, 15, 25, "Print", "ExpressionUUID" -> \
"89ea9efb-a248-486f-82f7-0252a70ed280"],
Cell[182777, 5061, 179, 3, 25, "Print", "ExpressionUUID" -> \
"d41516f9-52ae-4806-9291-94ea05203da7"],
Cell[182959, 5066, 720, 15, 25, "Print", "ExpressionUUID" -> \
"e7463cf7-b6aa-4834-839f-56d446917433"],
Cell[183682, 5083, 247, 7, 26, "Print", "ExpressionUUID" -> \
"e2a54e10-80ec-4ac3-b2b6-ae08231cdb59"],
Cell[183932, 5092, 157, 3, 25, "Print", "ExpressionUUID" -> \
"a60e01f1-c422-437e-b4a8-1c7476c6dc6f"],
Cell[184092, 5097, 186, 4, 25, "Print", "ExpressionUUID" -> \
"e40ca3ea-2ed5-4cb1-8cce-c6b5ba46b156"],
Cell[184281, 5103, 740, 17, 25, "Print", "ExpressionUUID" -> \
"07c93bc9-befc-4b69-b0d9-7202172b0178"],
Cell[185024, 5122, 725, 16, 25, "Print", "ExpressionUUID" -> \
"5f500c02-1c42-4a94-88f6-a1250976ee63"],
Cell[185752, 5140, 841, 20, 25, "Print", "ExpressionUUID" -> \
"2f77256e-79ca-4bbb-ab16-f484d4a96539"],
Cell[186596, 5162, 187, 4, 25, "Print", "ExpressionUUID" -> \
"083f91f4-35fa-480f-a797-e8d9e18e3528"],
Cell[186786, 5168, 494, 11, 25, "Print", "ExpressionUUID" -> \
"ab512de2-6bcc-42dd-8017-b739470c375f"],
Cell[187283, 5181, 841, 20, 25, "Print", "ExpressionUUID" -> \
"09ddd3e4-b6d7-4e74-8646-fb22871ffec7"],
Cell[188127, 5203, 840, 19, 25, "Print", "ExpressionUUID" -> \
"ca4950cb-c348-4ae8-8f27-72e646e015bf"],
Cell[188970, 5224, 466, 11, 25, "Print", "ExpressionUUID" -> \
"6ad5f41f-d737-4332-8edd-c6fc7072d37d"],
Cell[189439, 5237, 846, 20, 25, "Print", "ExpressionUUID" -> \
"30dc3b12-3f02-4aa6-b1f3-4fa5f483092c"],
Cell[190288, 5259, 444, 10, 25, "Print", "ExpressionUUID" -> \
"4d4f4f5f-aa26-4d5b-96fd-5aa2f9514892"],
Cell[190735, 5271, 844, 20, 25, "Print", "ExpressionUUID" -> \
"ad9db1e9-b0ae-4394-9568-94438598dc37"],
Cell[191582, 5293, 176, 3, 25, "Print", "ExpressionUUID" -> \
"cd8fdc34-c27b-4c3d-8a17-a59a64dafdbb"],
Cell[191761, 5298, 736, 17, 25, "Print", "ExpressionUUID" -> \
"adbf6d53-6e1b-457c-8147-35777b5fb0d0"],
Cell[192500, 5317, 841, 20, 25, "Print", "ExpressionUUID" -> \
"413f907b-19f8-4c44-84bd-ab5c69a5bb9b"],
Cell[193344, 5339, 734, 17, 25, "Print", "ExpressionUUID" -> \
"699cd6b6-4fac-4362-baba-53bfb25a46c8"],
Cell[194081, 5358, 738, 17, 25, "Print", "ExpressionUUID" -> \
"157d9bd9-d20a-4273-9bdc-75b63d96c4fe"],
Cell[194822, 5377, 732, 17, 25, "Print", "ExpressionUUID" -> \
"b0078bb7-d52a-424f-b41b-91c16364c570"],
Cell[195557, 5396, 170, 3, 25, "Print", "ExpressionUUID" -> \
"c62a91a0-df73-48b7-a61b-4ff87c9baa59"],
Cell[195730, 5401, 839, 20, 25, "Print", "ExpressionUUID" -> \
"e29da018-b9f2-4d9a-87aa-bc4742524d13"],
Cell[196572, 5423, 266, 7, 26, "Print", "ExpressionUUID" -> \
"41df8f28-dcc7-4b3a-ac26-02c4521d2b27"],
Cell[196841, 5432, 152, 3, 25, "Print", "ExpressionUUID" -> \
"884d7d12-fc47-4c04-8b04-89c411649deb"],
Cell[196996, 5437, 157, 3, 25, "Print", "ExpressionUUID" -> \
"a8a5ee05-9c60-4ae5-988e-1a97a8857f03"],
Cell[197156, 5442, 158, 3, 25, "Print", "ExpressionUUID" -> \
"6a1768de-6285-4ed6-82d0-5d796f24a47f"],
Cell[197317, 5447, 164, 3, 25, "Print", "ExpressionUUID" -> \
"4841b527-07e4-45b5-9e67-ef33fab4790f"],
Cell[197484, 5452, 156, 3, 25, "Print", "ExpressionUUID" -> \
"6b08d79a-4f5d-4c59-b74a-680fad1b4c38"],
Cell[197643, 5457, 153, 3, 25, "Print", "ExpressionUUID" -> \
"e1d7eaf9-70c1-4bea-ab94-a05f9f84bd45"],
Cell[197799, 5462, 601, 12, 25, "Print", "ExpressionUUID" -> \
"ec2cd1fa-43ff-4a1c-9836-135136c657ac"],
Cell[198403, 5476, 283, 8, 26, "Print", "ExpressionUUID" -> \
"ba5cfa92-4601-4618-aeea-acf9fffd680f"],
Cell[198689, 5486, 200, 4, 25, "Print", "ExpressionUUID" -> \
"5111f7a4-124f-433c-8448-4dd2ec6adfc9"],
Cell[198892, 5492, 163, 3, 25, "Print", "ExpressionUUID" -> \
"c2551262-f4e3-42c0-a3e0-33325b9283fd"],
Cell[199058, 5497, 585, 14, 25, "Print", "ExpressionUUID" -> \
"fee2d4af-4df7-4538-94be-2734a832e3e4"],
Cell[199646, 5513, 176, 3, 25, "Print", "ExpressionUUID" -> \
"b39dd8a0-250d-4c86-a5b3-73eb39604a4d"],
Cell[199825, 5518, 574, 14, 25, "Print", "ExpressionUUID" -> \
"f55b441f-3d87-4560-b226-3182973a7735"],
Cell[200402, 5534, 174, 3, 25, "Print", "ExpressionUUID" -> \
"471da1ef-28f1-4b15-85d2-0e3b67d9ac14"],
Cell[200579, 5539, 580, 14, 25, "Print", "ExpressionUUID" -> \
"a21f64a0-0ccc-4366-a9b6-3c8b7ae0587f"],
Cell[201162, 5555, 622, 14, 25, "Print", "ExpressionUUID" -> \
"26073ac7-ff04-4ae3-a45e-eeb66875d1df"],
Cell[201787, 5571, 371, 9, 25, "Print", "ExpressionUUID" -> \
"cf732eb9-b039-45f2-b80c-4b536ebb11ce"],
Cell[202161, 5582, 385, 9, 25, "Print", "ExpressionUUID" -> \
"ee47ad89-9740-41ef-aeaa-085c142a7907"],
Cell[202549, 5593, 398, 10, 25, "Print", "ExpressionUUID" -> \
"4945f370-3f9c-4746-afa2-6ec8fe7c1352"],
Cell[202950, 5605, 396, 10, 25, "Print", "ExpressionUUID" -> \
"48c223c4-cdab-4e66-816c-42fc9d053b55"],
Cell[203349, 5617, 249, 7, 26, "Print", "ExpressionUUID" -> \
"4c90feef-792d-4e19-9191-b4d313c5be4e"],
Cell[203601, 5626, 164, 3, 25, "Print", "ExpressionUUID" -> \
"ec922cbe-61f8-44e3-9551-73ac3ba2496f"],
Cell[203768, 5631, 178, 3, 25, "Print", "ExpressionUUID" -> \
"f7ff9331-c98f-4bac-8018-e5d37083107d"],
Cell[203949, 5636, 741, 14, 25, "Print", "ExpressionUUID" -> \
"46121d5c-427c-4d49-88c1-acc605910b5c"],
Cell[204693, 5652, 749, 15, 25, "Print", "ExpressionUUID" -> \
"0c7999aa-3073-4f12-bf88-e559b21580f0"],
Cell[205445, 5669, 255, 7, 26, "Print", "ExpressionUUID" -> \
"c1207e62-5e19-4881-87c1-015c0a24ef93"],
Cell[205703, 5678, 718, 15, 25, "Print", "ExpressionUUID" -> \
"5f7f4e93-0eff-4d41-bdc1-0544f025a1e0"],
Cell[206424, 5695, 722, 15, 25, "Print", "ExpressionUUID" -> \
"bbb65ca6-abe1-4248-8b5c-51e4fc5e2571"],
Cell[207149, 5712, 266, 7, 26, "Print", "ExpressionUUID" -> \
"6636655b-6b18-47be-b192-46a0f1b237b9"],
Cell[207418, 5721, 174, 3, 25, "Print", "ExpressionUUID" -> \
"8bd8bf0f-5aab-4fe2-9211-9fed60d1c05a"],
Cell[207595, 5726, 835, 20, 25, "Print", "ExpressionUUID" -> \
"96a93e21-38a3-45ad-b731-1c9a469ab0e9"],
Cell[208433, 5748, 1387, 27, 25, "Print", "ExpressionUUID" -> \
"3a7d2807-353f-421f-8d16-36dc1e378b9c"],
Cell[209823, 5777, 762, 15, 25, "Print", "ExpressionUUID" -> \
"6d7ddbdb-ef6f-4396-a22a-7331525cd416"],
Cell[210588, 5794, 156, 2, 25, "Print", "ExpressionUUID" -> \
"4682432c-e0a6-47fa-b99e-1987a9f5b4eb"],
Cell[210747, 5798, 256, 7, 26, "Print", "ExpressionUUID" -> \
"7ac0a414-d5f3-4677-9c1a-82a80d0962ef"],
Cell[211006, 5807, 266, 7, 26, "Print", "ExpressionUUID" -> \
"956c02ea-3c0c-4123-a6c7-abf04904f114"],
Cell[211275, 5816, 249, 7, 26, "Print", "ExpressionUUID" -> \
"b7fd6fdb-f331-4ed8-b5bc-31b249d283a8"],
Cell[211527, 5825, 262, 7, 26, "Print", "ExpressionUUID" -> \
"ded4f90e-9c2a-414f-859d-751aecffab4a"],
Cell[211792, 5834, 158, 3, 25, "Print", "ExpressionUUID" -> \
"b223ffbd-9464-4d31-975e-0db1293521c5"],
Cell[211953, 5839, 156, 3, 25, "Print", "ExpressionUUID" -> \
"8dde85a3-8ea3-4979-8630-42edf92679a0"],
Cell[212112, 5844, 156, 3, 25, "Print", "ExpressionUUID" -> \
"6854dacc-3bd9-4eb5-8416-94ed588e856b"],
Cell[212271, 5849, 157, 3, 25, "Print", "ExpressionUUID" -> \
"6a45a00a-bca2-4883-824d-1113ca80cdee"],
Cell[212431, 5854, 152, 3, 25, "Print", "ExpressionUUID" -> \
"9181466f-b499-4b94-9b70-c618b54f573e"],
Cell[212586, 5859, 159, 3, 25, "Print", "ExpressionUUID" -> \
"d16cda72-d1c5-4200-ab37-7ddb9c56205c"],
Cell[212748, 5864, 158, 3, 25, "Print", "ExpressionUUID" -> \
"1374a39a-8938-40ec-8df6-973c53bd92ad"],
Cell[212909, 5869, 156, 3, 25, "Print", "ExpressionUUID" -> \
"91a849f3-8738-4469-adea-c7701c70836a"],
Cell[213068, 5874, 271, 7, 26, "Print", "ExpressionUUID" -> \
"ab50a544-0be5-4d3c-9711-73a596682845"],
Cell[213342, 5883, 195, 4, 25, "Print", "ExpressionUUID" -> \
"fd896f20-3c0d-4942-b56b-2a2f0aed24f3"],
Cell[213540, 5889, 268, 7, 27, "Print", "ExpressionUUID" -> \
"d8419b55-2b2c-4000-b3b0-d7d2cf79b3ac"],
Cell[213811, 5898, 320, 8, 27, "Print", "ExpressionUUID" -> \
"255ebdad-2bb0-4ca9-8c56-3765b65e85f3"],
Cell[214134, 5908, 385, 9, 25, "Print", "ExpressionUUID" -> \
"fe7106b0-1aef-451f-b702-a1e9af3a4bdb"],
Cell[214522, 5919, 1414, 33, 25, "Print", "ExpressionUUID" -> \
"d3936ebc-fa84-439f-8086-ea4b0d7564b3"],
Cell[215939, 5954, 836, 20, 25, "Print", "ExpressionUUID" -> \
"dcf97ee3-0bf3-4ebf-9307-cf354ca6e9fc"],
Cell[216778, 5976, 385, 9, 25, "Print", "ExpressionUUID" -> \
"77b19ca5-e490-46f0-9330-1a52fdff94dc"],
Cell[217166, 5987, 1414, 33, 25, "Print", "ExpressionUUID" -> \
"746e213f-7e01-4e2a-b9d1-7e565a7504e3"],
Cell[218583, 6022, 836, 20, 25, "Print", "ExpressionUUID" -> \
"16286e8b-cee5-4868-9c10-6d32fd934c0d"],
Cell[219422, 6044, 158, 3, 25, "Print", "ExpressionUUID" -> \
"1c51ed6e-525d-4969-9135-94c628188321"],
Cell[219583, 6049, 165, 3, 25, "Print", "ExpressionUUID" -> \
"4682d321-44e5-474f-bb48-9cd78c725de1"],
Cell[219751, 6054, 166, 3, 25, "Print", "ExpressionUUID" -> \
"ed1bd3df-010d-4f4f-a27c-610bad4e2448"],
Cell[219920, 6059, 252, 7, 26, "Print", "ExpressionUUID" -> \
"88bade46-9bc0-48d6-a70b-296f4ca807ed"],
Cell[220175, 6068, 162, 3, 25, "Print", "ExpressionUUID" -> \
"e3ad604f-11bb-49a9-bb49-d19dd3e2cc40"],
Cell[220340, 6073, 163, 3, 25, "Print", "ExpressionUUID" -> \
"77b5c08e-6d59-45df-8a36-5840046027f1"],
Cell[220506, 6078, 267, 7, 26, "Print", "ExpressionUUID" -> \
"5fb3553a-cd47-4c04-8631-0f04f23ad042"],
Cell[220776, 6087, 177, 3, 25, "Print", "ExpressionUUID" -> \
"e5f15f75-af55-47b5-9971-ffe4cdabe789"],
Cell[220956, 6092, 164, 3, 25, "Print", "ExpressionUUID" -> \
"f4453f09-066c-47b1-a7d1-82befd05a644"],
Cell[221123, 6097, 256, 7, 26, "Print", "ExpressionUUID" -> \
"07a942f1-2673-4336-a1b3-3c72f780b423"],
Cell[221382, 6106, 163, 3, 25, "Print", "ExpressionUUID" -> \
"60c62edd-0023-4f19-896b-3ceea827fac1"],
Cell[221548, 6111, 157, 3, 25, "Print", "ExpressionUUID" -> \
"3ae8794c-96bf-4e40-916c-d662f149b337"],
Cell[221708, 6116, 164, 3, 25, "Print", "ExpressionUUID" -> \
"671ad612-b154-4cea-8f62-131b2e5a3090"],
Cell[221875, 6121, 245, 7, 26, "Print", "ExpressionUUID" -> \
"b3ea18a0-f66e-4ecd-8941-3590c637928b"],
Cell[222123, 6130, 281, 8, 26, "Print", "ExpressionUUID" -> \
"4ac1ada5-ad9f-425b-9baf-8e1632ef6bcf"],
Cell[222407, 6140, 156, 2, 25, "Print", "ExpressionUUID" -> \
"b6fe3817-9c8a-4987-b887-c6317a5dd2b6"],
Cell[222566, 6144, 790, 16, 25, "Print", "ExpressionUUID" -> \
"291d0c23-674e-4efd-85b6-cc43c3b7cfd7"],
Cell[223359, 6162, 792, 16, 25, "Print", "ExpressionUUID" -> \
"592475c1-6636-49f8-951d-f0f9be5b966c"],
Cell[224154, 6180, 263, 7, 26, "Print", "ExpressionUUID" -> \
"51879a8a-70c9-475a-bd71-03346e28acc8"],
Cell[224420, 6189, 167, 3, 25, "Print", "ExpressionUUID" -> \
"7fc82b18-c1c6-4dbf-b0bb-6ff59c9dabfa"],
Cell[224590, 6194, 159, 3, 25, "Print", "ExpressionUUID" -> \
"25b5144c-f3ff-4f0b-bd13-941d0952a67f"],
Cell[224752, 6199, 154, 3, 25, "Print", "ExpressionUUID" -> \
"5dbb345a-5386-44de-a51f-6b6ce3926bac"],
Cell[224909, 6204, 136, 3, 25, "Print", "ExpressionUUID" -> \
"f58b58a9-1135-475b-9b6d-691751754e20"],
Cell[225048, 6209, 374, 8, 25, "Print", "ExpressionUUID" -> \
"b2663b2c-33ab-4812-8f00-747d41fd9b4b"],
Cell[225425, 6219, 565, 15, 25, "Print", "ExpressionUUID" -> \
"83fef00d-8bbc-4135-b66a-b5fbfa6013f7"],
Cell[225993, 6236, 133, 2, 25, "Print", "ExpressionUUID" -> \
"d1452405-024e-42d0-b489-903c4cd64eda"],
Cell[226129, 6240, 212, 4, 25, "Print", "ExpressionUUID" -> \
"db10d226-63bd-425b-9418-3b7de89cc2b7"],
Cell[226344, 6246, 533, 11, 25, "Print", "ExpressionUUID" -> \
"0e9dfd19-67ad-4673-aa1a-553e36c5120a"],
Cell[226880, 6259, 168, 3, 25, "Print", "ExpressionUUID" -> \
"7c44ee55-0206-4fd1-a672-bd8e992713a6"],
Cell[227051, 6264, 320, 8, 25, "Print", "ExpressionUUID" -> \
"c8f01958-1697-4faf-89ca-01492a9719f7"],
Cell[227374, 6274, 172, 3, 25, "Print", "ExpressionUUID" -> \
"5e9f64d1-e3fa-40cb-b04b-6fc3dd4c8f6d"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

